#include <windows.h>
#include <Shlwapi.h>
#include <stdio.h>
#include <tchar.h>
#include <locale.h>
#include <Winternl.h>

#undef MAX_PATH
#define MAX_PATH 1024

#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "winmm.lib")

#ifdef _UNICODE
#define CP_TCHAR CP_WINUNICODE
#else
#define CP_TCHAR CP_WINANSI
#endif

//#define FORCE_WAIT
//#define ENABLE_TRACE
//#define STOP_EXIT
#ifdef ENABLE_TRACE
#include <conio.h>
void NVOutputDebugLog(TCHAR *fmt, ...)
{
	va_list arg;
	FILE *fp = NULL;
	TCHAR szName[1024];
	TCHAR buf[1024];

	GetModuleFileName((HMODULE)GetModuleHandle(NULL), szName, 1024);
	PathRemoveFileSpec(szName);
	PathAppend(szName, TEXT("DDEClientLog.txt"));
	_tfopen_s(&fp, szName, TEXT("a"));

	if (fp)
	{
		va_start(arg, fmt);

		_vstprintf_s(buf, 1024, fmt, arg);
		_fputts(buf, fp);
		_tprintf(buf);

		va_end(arg);
		fclose(fp);
	}
}

#else

#define NVOutputDebugLog

#endif

#define STR_LENGTH 1024
#define DEFAULT_DDE_SERVICE TEXT("uLilithDdeControl")
#define DEFAULT_DDE_TOPIC TEXT("uLilithDdeControl")
#define DEFAULT_SERVER_PATH TEXT(".\\uLilith.exe")
#define DEFAULT_SERVER_OPTIONS TEXT("\"/DDE\"")
#define DEFAULT_SERVER_REGISTKEY TEXT("Software\\Project9k\\uLilith\\Path")
#define DEFAULT_WINDOWCLASS TEXT("uLilith")

#define DEFAULT_DDE_QUERY_STATUS TEXT("\"/query_dde_status\"")
#define DEFAULT_DDE_STATUS_ACCEPTABLE TEXT("dde_acceptable")

#define WAIT_FOR_INPUT_IDLE_TIMEOUT 10000
#define REQUEST TEXT("XTYP_REQUEST")
#define EXECUTE TEXT("XTYP_EXECUTE")
#define DDE_TIMEOUT 5000
#define MAX_DDE_WAIT_TIME 10000
#define DDECONNECT_RETRY 10
#define ENUM_WINDOWS_RETRY 10

struct ENUMWINDOWSPARAM
{
	SHELLEXECUTEINFO Info;
	HWND hwndResult;
	LPCTSTR lpcszWindowClass;
};


static HWND CreateTarget(LPTSTR szConfigFileName, LPCTSTR lpcszWindowClass, LPTSTR lpszQueryStatus, LPTSTR lpszStatusAcceptable);
static BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);
static int SendDDEMessage(HWND hwnd, LPTSTR lpszServiceName, LPTSTR lpszTopicName, LPTSTR lpszMessage, LPTSTR lpszReturnString, DWORD dwReturnStringLength, BOOL fSilentMode = FALSE);
static LPCTSTR GetCommandOption(LPCTSTR lpcszCommandLine, LPTSTR lpszOption, DWORD dwSize);

typedef DWORD NVRESULT;

#define NV_OK ((NVRESULT) 0)
#define NV_ERR ((NVRESULT) -1)

#ifdef _CONSOLE
#define FPRINTF _ftprintf
#define FPRINTF2 if (! fSilentMode) _ftprintf
#else
#define FPRINTF
#define FPRINTF2
#endif

typedef DWORD (WINAPI *pfnGetProcessId) (HANDLE Process);
typedef NTSTATUS (WINAPI *pfnQueryInformationProcess)(HANDLE ProcessHandle, PROCESSINFOCLASS ProcessInformationClass, PVOID ProcessInformation,
													  ULONG ProcessInformationLength, PULONG ReturnLength);
static ULONG_PTR NVGetProcessId(HANDLE hProcess);

static DWORD g_sam64Key = 0;


#ifdef _CONSOLE
int _tmain(int argc, TCHAR *argv[])
#else
int WINAPI _tWinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nShowCmd)
#endif
{
	{
		HMODULE hKernel32 = GetModuleHandle(TEXT("Kernel32.dll"));
		if (GetProcAddress(hKernel32, "IsWow64Process"))
		{
			g_sam64Key = KEY_WOW64_64KEY;
		}
	}
	{
		TCHAR szLocale[256];
		_stprintf_s(szLocale, 256, TEXT(".%d"), GetACP());
		_tsetlocale(LC_ALL, szLocale);
	}
	TCHAR szServiceName[STR_LENGTH];
	TCHAR szTopicName[STR_LENGTH];
	TCHAR szWindowClass[STR_LENGTH];
	TCHAR szConfigFileName[MAX_PATH];
	TCHAR szQueryStatus[STR_LENGTH];
	TCHAR szStatusAcceptable[STR_LENGTH];

	HWND hwndTarget = NULL;

	HANDLE hMutex = NULL;
	int ret;

	*szQueryStatus = TEXT('\0');
	*szStatusAcceptable = TEXT('\0');

	NVOutputDebugLog(TEXT("DDEClient vOJn\n"));

	NVOutputDebugLog(TEXT("R}hC = %s\n"), GetCommandLine());
	GetModuleFileName((HMODULE)GetModuleHandle(NULL), szConfigFileName, MAX_PATH);
	PathRenameExtension(szConfigFileName, TEXT(".ini"));

	NVOutputDebugLog(TEXT("ݒt@C \"%s\" ǂݎJnB\n"), szConfigFileName);

	GetPrivateProfileString(TEXT("General"), TEXT("ServiceName"), DEFAULT_DDE_SERVICE, szServiceName, STR_LENGTH, szConfigFileName);
	GetPrivateProfileString(TEXT("General"), TEXT("TopicName"), DEFAULT_DDE_TOPIC, szTopicName, STR_LENGTH, szConfigFileName);
	GetPrivateProfileString(TEXT("General"), TEXT("WindowClass"), DEFAULT_WINDOWCLASS, szWindowClass, STR_LENGTH, szConfigFileName);

	NVOutputDebugLog(TEXT("ServiceName = %s\nTopicName = %s\nWindowClass = %s\nȏ̐ݒœ삵܂B\n"),
		szServiceName, szTopicName, szWindowClass);

	hMutex = CreateMutex(NULL, FALSE, TEXT("DDEClientTargetWindowInitialization"));
	if (hMutex == NULL)
	{
		FPRINTF(stderr, TEXT("^[QbgvZX̋NɎs܂B\n"));
		NVOutputDebugLog(TEXT("rp~[ebNX쐬sB\n"));
#ifdef STOP_EXIT
		_getch();
#endif
		return -1;
	}
	if (WaitForSingleObject(hMutex, 15 * 1000) != WAIT_OBJECT_0)
	{
		ReleaseMutex(hMutex);
		CloseHandle(hMutex);
		FPRINTF(stderr, TEXT("^[QbgvZX̋NɎs܂B\n"));
		NVOutputDebugLog(TEXT("~[ebNXIuWFNgmێsB\n"));
#ifdef STOP_EXIT
		_getch();
#endif
		return -1;
	}

	NVOutputDebugLog(TEXT("^[QbgEBhEJnB\n"));

	hwndTarget = FindWindow(szWindowClass, NULL);
	if (hwndTarget == NULL || hwndTarget == INVALID_HANDLE_VALUE)
	{
		FPRINTF(stderr, TEXT("^[QbgEBhE܂B\nVɃvZXN܂B\n"));
		NVOutputDebugLog(TEXT("^[QbgEBhEłB\nVKɃvZXNB\n"));
		hwndTarget = CreateTarget(szConfigFileName, szWindowClass, szQueryStatus, szStatusAcceptable);
		if (hwndTarget == NULL || hwndTarget == INVALID_HANDLE_VALUE)
		{
			NVOutputDebugLog(TEXT("^[QbgvZX̋NɎsB\n"));
			ReleaseMutex(hMutex);
			CloseHandle(hMutex);
			FPRINTF(stderr, TEXT("^[QbgvZX̋NɎs܂B\n"));
#ifdef STOP_EXIT
			_getch();
#endif
			return -1;
		}
		NVOutputDebugLog(TEXT("^[QbgvZX̐NmFB\n"));
	}
	NVOutputDebugLog(TEXT("hwnd = %08X ^[QbgEBhEɐݒ\n"), hwndTarget);

	if (_tcsicmp(DEFAULT_DDE_SERVICE, szServiceName) != 0 ||
		_tcsicmp(DEFAULT_DDE_TOPIC, szTopicName) != 0 ||
		_tcsicmp(DEFAULT_WINDOWCLASS, szWindowClass) != 0)
	{
		TCHAR szBuf[STR_LENGTH];

		GetPrivateProfileString(TEXT("General"), TEXT("UseQueryStatus"), TEXT("FALSE"), szBuf, STR_LENGTH, szConfigFileName);
		if (_tcsicmp(szBuf, TEXT("TRUE")))
		{
			*szQueryStatus = TEXT('\0');
		}
	}

	if (*szQueryStatus)
	{
		TCHAR szMessage[STR_LENGTH * 2];
		TCHAR szReturnString[STR_LENGTH];
		DWORD dwStartTime;
		BOOL fFlag = FALSE;
		LONG i;
		
		_stprintf_s(szMessage, STR_LENGTH * 2, TEXT("dummy.exe XTYP_REQUEST %s"), szQueryStatus);

		FPRINTF(stderr, TEXT("^[QbgvZX DDE R}ht\Ԃ`FbNB\n"));
		for (dwStartTime = timeGetTime(), i = 0; (timeGetTime() - dwStartTime) < MAX_DDE_WAIT_TIME; i++)
		{
			NVOutputDebugLog(TEXT("^[QbgvZX DDE R}ht\Ԃ`FbNB\n"));
			ret = SendDDEMessage(hwndTarget, szServiceName, szTopicName, szMessage, szReturnString, STR_LENGTH, TRUE);
			if (ret)
			{
				Sleep(50);
				continue;
//				FPRINTF(stderr, TEXT("DDE R}h̑MɎŝŒf܂B\n"));
//				NVOutputDebugLog(TEXT("DDE R}h̑MɎŝŒf܂B\n"));
//				return ret;
			}

			if (_tcsicmp(szReturnString, szStatusAcceptable) == 0)
			{
				FPRINTF(stderr, TEXT("^[QbgvZX DDE R}ht\mF܂B\n"));
				NVOutputDebugLog(TEXT("^[QbgvZX DDE R}ht\mF܂B\n"));
				fFlag = TRUE;
				break;
			}
#ifdef ENABLE_TRACE
			else
			{
				NVOutputDebugLog(TEXT("^[QbgvZX DDE R}ht\Ԃł͂܂B(%d )\n"), i);
				if (i == 0)
				{
					NVOutputDebugLog(TEXT("ő %d bԍĎs܂B\n"), MAX_DDE_WAIT_TIME / 1000);
				}
			}
#endif
			Sleep(50);
		}

		if (! fFlag)
		{
			FPRINTF(stderr, TEXT("%d bԑ҂܂ADDE R}ht\ɂȂȂ̂Œf܂B\n"), MAX_DDE_WAIT_TIME / 1000);
			NVOutputDebugLog(TEXT("%d bԑ҂܂ADDE R}ht\ɂȂȂ̂Œf܂B\n"), MAX_DDE_WAIT_TIME / 1000);
#ifdef STOP_EXIT
			_getch();
#endif
			ReleaseMutex(hMutex);
			CloseHandle(hMutex);
			return -1;
		}
	}

	NVOutputDebugLog(TEXT("DDE R}hoɈڍsB\n"));
	ret = SendDDEMessage(hwndTarget, szServiceName, szTopicName, GetCommandLine(), NULL, 0);
	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
#ifdef STOP_EXIT
	_getch();
#endif
	return ret;
}


static HWND CreateTarget(LPTSTR szConfigFileName, LPCTSTR lpcszWindowClass, LPTSTR lpszQueryStatus, LPTSTR lpszStatusAcceptable)
{
	TCHAR szServerRegKey[STR_LENGTH];
	TCHAR szServerPath[MAX_PATH];
	TCHAR szServerOptions[STR_LENGTH];
	TCHAR szQueryStatus[STR_LENGTH];
	TCHAR szStatusAcceptable[STR_LENGTH];
	DWORD dwType;
	BOOL fUseQueryStatus = TRUE;

	szServerPath[0] = TEXT('\0');
	GetPrivateProfileString(TEXT("General"), TEXT("ServerRegKey"), TEXT("\0"), szServerRegKey, STR_LENGTH, szConfigFileName);
	if (szServerRegKey[0])
	{
		NVOutputDebugLog(TEXT("ݒt@C̎w背WXgst@CpX擾B\n"));
		HKEY hKey;
		DWORD dwSize = MAX_PATH - 1;
		if (RegOpenKeyEx(HKEY_CURRENT_USER, szServerRegKey, 0, KEY_QUERY_VALUE | KEY_READ | g_sam64Key, &hKey) == NOERROR)
		{
			if (RegQueryValueEx(hKey, NULL, NULL, &dwType, (LPBYTE) szServerPath, &dwSize) == NOERROR)
			{
				szServerPath[MAX_PATH - 1] = TEXT('\0');
				if (dwType != REG_SZ)
				{
					szServerPath[0] = TEXT('\0');
				}
			}
			else
			{
				szServerPath[0] = TEXT('\0');
			}
		}
		RegCloseKey(hKey);
	}

	if (szServerPath[0] == TEXT('\0'))
	{
		NVOutputDebugLog(TEXT("ݒt@Cst@CpX擾B\n"));
		GetPrivateProfileString(TEXT("General"), TEXT("ServerPath"), TEXT("\0"), szServerPath, MAX_PATH, szConfigFileName);
	}

	GetPrivateProfileString(TEXT("General"), TEXT("ServerOptions"), TEXT("\0"), szServerOptions, STR_LENGTH, szConfigFileName);
	NVOutputDebugLog(TEXT("ݒt@CvZXNIvV擾B\n"));
	GetPrivateProfileString(TEXT("General"), TEXT("UseQueryStatus"), TEXT("TRUE"), szQueryStatus, STR_LENGTH, szConfigFileName);
	if (_tcsicmp(szQueryStatus, TEXT("FALSE")))
	{
		fUseQueryStatus = TRUE;
	}
	else
	{
		fUseQueryStatus = FALSE;
	}
	*szQueryStatus = TEXT('\0');
	*szStatusAcceptable = TEXT('\0');
	if (fUseQueryStatus)
	{
		GetPrivateProfileString(TEXT("General"), TEXT("QueryStatus"), TEXT("\0"), szQueryStatus, STR_LENGTH, szConfigFileName);
		GetPrivateProfileString(TEXT("General"), TEXT("StatusAcceptable"), TEXT("\0"), szStatusAcceptable, STR_LENGTH, szConfigFileName);
		NVOutputDebugLog(TEXT("ݒt@CvZXmFIvV擾B\n"));
	}

	if (szServerPath[0] == TEXT('\0'))
	{
		NVOutputDebugLog(TEXT("ftHgWXgL[st@CpX擾B\n"));
		HKEY hKey;
		DWORD dwSize = MAX_PATH - 1;
		if (RegOpenKeyEx(HKEY_CURRENT_USER, DEFAULT_SERVER_REGISTKEY, 0, KEY_QUERY_VALUE | KEY_READ | g_sam64Key, &hKey) == NOERROR)
		{
			if (RegQueryValueEx(hKey, NULL, NULL, &dwType, (LPBYTE) szServerPath, &dwSize) == NOERROR)
			{
				szServerPath[MAX_PATH - 1] = TEXT('\0');
				if (dwType != REG_SZ)
				{
					szServerPath[0] = TEXT('\0');
				}
				else if (*szServerPath)
				{
					if (*szServerOptions == TEXT('\0'))
					{
						NVOutputDebugLog(TEXT("ݒt@CvZXNIvV擾łB\nuLilithpftHgݒgp܂B\n"));
						_tcscpy_s(szServerOptions, STR_LENGTH, DEFAULT_SERVER_OPTIONS);
					}
					if (fUseQueryStatus && *szQueryStatus == TEXT('\0') || *szStatusAcceptable == TEXT('\0'))
					{
						NVOutputDebugLog(TEXT("ݒt@CvZXmFIvV擾łB\nuLilithpftHgݒgp܂B\n"));
						_tcscpy_s(szQueryStatus, STR_LENGTH, DEFAULT_DDE_QUERY_STATUS);
						_tcscpy_s(szStatusAcceptable, STR_LENGTH, DEFAULT_DDE_STATUS_ACCEPTABLE);
					}
				}
			}
			else
			{
				szServerPath[0] = TEXT('\0');
			}
		}
		RegCloseKey(hKey);
	}

	if (szServerPath[0] == TEXT('\0'))
	{
		NVOutputDebugLog(TEXT("ݒt@Cst@CpX擾łB\nuLilithpftHgݒgp܂B\n"));
		_tcscpy_s(szServerPath, STR_LENGTH, DEFAULT_SERVER_PATH);
		if (*szServerOptions == TEXT('\0'))
		{
			NVOutputDebugLog(TEXT("ݒt@CvZXNIvV擾łB\nuLilithpftHgݒgp܂B\n"));
			_tcscpy_s(szServerOptions, STR_LENGTH, DEFAULT_SERVER_OPTIONS);
		}
		if (fUseQueryStatus && *szQueryStatus == TEXT('\0') || *szStatusAcceptable == TEXT('\0'))
		{
			NVOutputDebugLog(TEXT("ݒt@CvZXmFIvV擾łB\nuLilithpftHgݒgp܂B\n"));
			_tcscpy_s(szQueryStatus, STR_LENGTH, DEFAULT_DDE_QUERY_STATUS);
			_tcscpy_s(szStatusAcceptable, STR_LENGTH, DEFAULT_DDE_STATUS_ACCEPTABLE);
		}
	}

	NVOutputDebugLog(TEXT("ServerPath = %s\nServerOptions = %s\nQueryStatus = %s\nStatusAcceptable=%s\nȏ̐ݒŃvZXN܂B\n"),
		szServerPath, szServerOptions, szQueryStatus, szStatusAcceptable);

	{
		LPTSTR lpsz;
		TCHAR szServerFileName[MAX_PATH];
		TCHAR szServerDirectory[MAX_PATH];
		TCHAR szServerCommandLine[STR_LENGTH * 2];

		{
			TCHAR szCurrentDirectory[MAX_PATH];
			TCHAR szWorkDirectory[MAX_PATH];

			GetModuleFileName((HMODULE)GetModuleHandle(NULL), szWorkDirectory, MAX_PATH);
			PathRemoveFileSpec(szWorkDirectory);

			GetCurrentDirectory(MAX_PATH, szCurrentDirectory);
			SetCurrentDirectory(szWorkDirectory);

			GetFullPathName(szServerPath, MAX_PATH, szServerFileName, &lpsz);

			SetCurrentDirectory(szCurrentDirectory);
		}

		_tcscpy_s(szServerDirectory, MAX_PATH, szServerFileName);
		PathRemoveFileSpec(szServerDirectory);
		_stprintf_s(szServerCommandLine, STR_LENGTH * 2, TEXT("\"%s\" %s"), szServerFileName, szServerOptions);

		BOOL ret;
		SHELLEXECUTEINFO info;

		ZeroMemory(&info, sizeof(SHELLEXECUTEINFO));

		info.cbSize = sizeof(SHELLEXECUTEINFO);
		info.fMask = SEE_MASK_NOCLOSEPROCESS;
		info.lpVerb = TEXT("open");
		info.lpFile = szServerFileName;
		info.lpParameters = szServerCommandLine;
		info.lpDirectory = szServerDirectory;

		NVOutputDebugLog(TEXT("ServerFileName = %s\nServerCommandLine = %s\nȏ̈ŃvZX쐬B\n"),
			szServerFileName, szServerCommandLine);
		ret = ShellExecuteEx(&info);
		if (! ret)
		{
			LPVOID lpMsgBuf;

			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);

			NVOutputDebugLog(TEXT("vZX̍쐬ɎsB\nWindowsɂƁAȉ̓ẽG[łB\n")
				TEXT("-=-=-=-=-=-=-=-=-=-\n%s\n-=-=-=-=-=-=-=-=-=-\n"),(LPTSTR) lpMsgBuf);

			LocalFree(lpMsgBuf);
			return NULL;
		}
		else
		{
			NVOutputDebugLog(TEXT("vZXNB\nProcessID = %08X łB\nNҋ@܂B\n"),
				NVGetProcessId(info.hProcess));
			if (WaitForInputIdle(info.hProcess, WAIT_FOR_INPUT_IDLE_TIMEOUT))
			{
				NVOutputDebugLog(TEXT("%d~bԑ҂܂AvZXAChԂɂȂ܂łB\n"), WAIT_FOR_INPUT_IDLE_TIMEOUT);
				return NULL;
			}

			NVOutputDebugLog(TEXT("vZX̃AChԂmFB\n^[QbgEBhEɈڍs܂B\n"));

			ENUMWINDOWSPARAM Param;

			Param.Info = info;
			Param.hwndResult = NULL;
			Param.lpcszWindowClass = lpcszWindowClass;

			int i;
			for (i = 0; i < ENUM_WINDOWS_RETRY; i++)
			{
				EnumWindows(EnumWindowsProc, (LPARAM) &Param);
				if (Param.hwndResult && Param.hwndResult != INVALID_HANDLE_VALUE)
				{
					break;
				}
				Sleep(50);
			}

			_tcscpy_s(lpszQueryStatus, STR_LENGTH, szQueryStatus);
			_tcscpy_s(lpszStatusAcceptable, STR_LENGTH, szStatusAcceptable);
			return Param.hwndResult;
		}
	}
}

static BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	ENUMWINDOWSPARAM * lpParam = (ENUMWINDOWSPARAM *) lParam;

	DWORD dwProcessID;


	GetWindowThreadProcessId(hwnd, &dwProcessID);
	NVOutputDebugLog(TEXT("hwnd = %08X, ProsessID = %08X\n"),	hwnd, dwProcessID);
	if (dwProcessID == NVGetProcessId(lpParam->Info.hProcess))
	{
		TCHAR szWindowClass[STR_LENGTH];
		GetClassName(hwnd, szWindowClass, STR_LENGTH);
		if (_tcscmp(szWindowClass, lpParam->lpcszWindowClass) == 0)
		{
			NVOutputDebugLog(TEXT("hwnd = %08X Ŕ܂B\n"), hwnd);
			lpParam->hwndResult = hwnd;
			return FALSE;
		}
	}

	return TRUE;
}

static HDDEDATA CALLBACK DDECallBack(UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1, HSZ hsz2, HDDEDATA hdata, ULONG_PTR dwData1, ULONG_PTR dwData2)
{
	return (HDDEDATA) NULL;
}

static int SendDDEMessage(HWND hwnd, LPTSTR lpszServiceName, LPTSTR lpszTopicName, LPTSTR lpszMessage, LPTSTR lpszReturnString, DWORD dwReturnStringLength, BOOL fSilentMode)
{
	DWORD dwDdeInst = 0;
	HSZ hszService = NULL;
	HSZ hszTopic = NULL;
	HCONV hConv = NULL;
	HDDEDATA hdata = NULL;
	UINT Type;
	TCHAR szBuf[STR_LENGTH];
	LPCTSTR lpszOption;

#ifdef FORCE_WAIT
	FPRINTF2(stderr, TEXT("EFCg(10sec)̂P܂B\n"));
	NVOutputDebugLog(TEXT("EFCg(10sec)̂P܂B\n"));
	Sleep(1000 * 10);
#endif
	

	if (lpszReturnString && dwReturnStringLength)
	{
		*lpszReturnString = TEXT('\0');
	}

	lpszOption = GetCommandOption(lpszMessage, szBuf, STR_LENGTH);
	if (! lpszOption)
	{
		FPRINTF2(stderr, TEXT("R}hłB\n"));
		NVOutputDebugLog(TEXT("R}hłB\n"));
		return -1;
	}

	{
		LPCTSTR lpsz;

		lpsz = GetCommandOption(lpszOption, szBuf, STR_LENGTH);
		if (_tcsicmp(szBuf, TEXT("XTYP_EXECUTE")) == 0)
		{
			Type = XTYP_EXECUTE;
			lpszOption = lpsz;
			FPRINTF2(stderr, TEXT("XTYP_EXECUTE I܂B\n"));
			NVOutputDebugLog(TEXT("XTYP_EXECUTE I܂B\n"));
		}
		else if (_tcsicmp(szBuf, TEXT("XTYP_REQUEST")) == 0)
		{
			Type = XTYP_REQUEST;
			lpszOption = lpsz;
			FPRINTF2(stderr, TEXT("XTYP_REQUEST I܂B\n"));
			NVOutputDebugLog(TEXT("XTYP_REQUEST I܂B\n"));
		}
		else
		{
			Type = XTYP_EXECUTE;
			FPRINTF2(stderr, TEXT("XTYP_EXECUTE ftHgŎgp܂B\n"));
			NVOutputDebugLog(TEXT("XTYP_EXECUTE ftHgŎgp܂B\n"));
		}
	}

	if (! lpszOption)
	{
		FPRINTF2(stderr, TEXT("R}hłB\n"));
		NVOutputDebugLog(TEXT("R}hłB\n"));
		return -1;
	}

	try
	{
		UINT uLastError = DMLERR_NO_ERROR;
		LONG lRetry = 0;

		NVOutputDebugLog(TEXT("DDE܂B\n"));
		DdeInitialize(&dwDdeInst, DDECallBack, APPCMD_CLIENTONLY, 0);

		hszService = DdeCreateStringHandle(dwDdeInst, lpszServiceName, CP_TCHAR);
		hszTopic = DdeCreateStringHandle(dwDdeInst, lpszTopicName, CP_TCHAR);
		hConv = DdeConnect(dwDdeInst, hszService, hszTopic, NULL);
		while ((uLastError = DdeGetLastError(dwDdeInst)) != DMLERR_NO_ERROR)
		{
#ifdef ENABLE_TRACE
			NVOutputDebugLog(TEXT("DDȄɃG[ %08X Ŏs܂B(%d)\n"), uLastError, lRetry + 1);
#endif
			if (lRetry >= DDECONNECT_RETRY)
			{
				throw NV_ERR;
			}
			lRetry++;
			Sleep(50);
			hConv = DdeConnect(dwDdeInst, hszService, hszTopic, NULL);
		}

#ifdef FORCE_WAIT
		FPRINTF2(stderr, TEXT("EFCg(10sec)̂Q܂B\n"));
		NVOutputDebugLog(TEXT("EFCg(10sec)̂Q܂B\n"));
		Sleep(1000 * 10);
#endif
		if (Type == XTYP_EXECUTE)
		{
			DWORD dwLen;
			DWORD dwResult;
			dwLen = (DWORD) _tcslen(lpszOption);
			if (dwLen)
			{
				FPRINTF2(stderr, TEXT("R}h %s 𑗐M܂B\n"), lpszOption);
				NVOutputDebugLog(TEXT("R}h %s 𑗐M܂B\n"), lpszOption);
				hdata = DdeClientTransaction((LPBYTE) lpszOption, (dwLen + 1) * sizeof(TCHAR), hConv, NULL, 0, Type, DDE_TIMEOUT, &dwResult);
				if (hdata)
				{
					NVOutputDebugLog(TEXT("R}h̑MB\n"));
					DdeFreeDataHandle(hdata);
				}
#ifdef ENABLE_TRACE
				else
				{
					NVOutputDebugLog(TEXT("R}h̑MɃG[ %08X Ŏs܂B\n"), DdeGetLastError(dwDdeInst));
				}
#endif
			}
			else
			{
				FPRINTF2(stderr, TEXT("R}hłB\n"));
			}
		}
		else
		{
			DWORD dwResult;
			DWORD dwLen;
			HSZ hszItem;
			dwLen = (DWORD) _tcslen(lpszOption);
			if (dwLen)
			{
				WCHAR wszBuf[STR_LENGTH];
				FPRINTF2(stderr, TEXT("R}h %s 𑗐M܂B\n"), lpszOption);
				NVOutputDebugLog(TEXT("R}h %s 𑗐M܂B\n"), lpszOption);
				hszItem = DdeCreateStringHandle(dwDdeInst, lpszOption, CP_TCHAR);
				hdata = DdeClientTransaction(NULL, 0, hConv, hszItem, CF_UNICODETEXT, Type, DDE_TIMEOUT, &dwResult);
				DdeFreeStringHandle(dwDdeInst, hszItem);
				if (hdata)
				{
					wszBuf[0] = TEXT('\0');
					DdeGetData(hdata, (LPBYTE) wszBuf, sizeof(WCHAR) * STR_LENGTH, 0);
					DdeFreeDataHandle(hdata);
#ifndef _UNICODE
					CHAR szBuf[STR_LENGTH];
					WideCharToMultiByte(CP_ACP, 0, wszBuf, -1, szBuf, STR_LENGTH, NULL, NULL);
					LPCTSTR psz = szBuf;
#else
					LPCTSTR psz = wszBuf;
#endif
					FPRINTF2(stderr, TEXT("߂l:\n%s\n"), psz);
					NVOutputDebugLog(TEXT("R}h̑MB\n߂l:\n%s\n"), psz);
					if (lpszReturnString && dwReturnStringLength)
					{
						_tcsncpy_s(lpszReturnString, STR_LENGTH, psz, min(STR_LENGTH, dwReturnStringLength) - 1);
						lpszReturnString[dwReturnStringLength - 1] = TEXT('\0');
					}
				}
#ifdef ENABLE_TRACE
				else
				{
					NVOutputDebugLog(TEXT("R}h̑MɃG[ %08X Ŏs܂B\n"), DdeGetLastError(dwDdeInst));
				}
#endif
			}
		}

#ifdef FORCE_WAIT
		FPRINTF2(stderr, TEXT("EFCg(10sec)̂R܂B\n"));
		NVOutputDebugLog(TEXT("EFCg(10sec)̂R܂B\n"));
		Sleep(1000 * 10);
#endif
		DdeDisconnect(hConv);
		DdeFreeStringHandle(dwDdeInst, hszTopic);
		DdeFreeStringHandle(dwDdeInst, hszService);
		DdeUninitialize(dwDdeInst);
	}
	catch (NVRESULT)
	{
		if (hConv)
		{
			DdeDisconnect(hConv);
		}
		if (hszTopic)
		{
			DdeFreeStringHandle(dwDdeInst, hszTopic);
		}
		if (hszService)
		{
			DdeFreeStringHandle(dwDdeInst, hszService);
		}
		DdeUninitialize(dwDdeInst);
		return -1;
	}

	return 0;
}

LPCTSTR GetCommandOption(LPCTSTR lpcszCommandLine, LPTSTR lpszOption, DWORD dwSize)
{
#ifdef _UNICODE
	if (dwSize < 1)
	{
		return NULL;
	}

	dwSize--;

	if (! lpcszCommandLine)
	{
		lpcszCommandLine = GetCommandLine();
	}

	while (*lpcszCommandLine == TEXT(' ') && *lpcszCommandLine != TEXT('\0'))
	{
		lpcszCommandLine++;
	}

	if (*lpcszCommandLine == TEXT('\"'))
	{
		lpcszCommandLine++;
		while (*lpcszCommandLine != TEXT('\"') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			*(lpszOption++) = *(lpcszCommandLine++);
			dwSize--;
		}
		if (*lpcszCommandLine == TEXT('\"'))
		{
			lpcszCommandLine++;
		}
		*lpszOption = TEXT('\0');
	}
	else if (*lpcszCommandLine)
	{
		while (*lpcszCommandLine != TEXT(' ') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			*(lpszOption++) = *(lpcszCommandLine++);
			dwSize--;
		}
		*lpszOption = TEXT('\0');
	}
	else
	{
		return NULL;
	}

	return lpcszCommandLine;
#else
	if (dwSize < 1)
	{
		return NULL;
	}

	dwSize--;

	if (! lpcszCommandLine)
	{
		lpcszCommandLine = GetCommandLine();
	}

	while (*lpcszCommandLine == TEXT(' ') && *lpcszCommandLine != TEXT('\0'))
	{
		lpcszCommandLine = (LPCTSTR) _mbsinc((unsigned char *)lpcszCommandLine);
	}

	if (*lpcszCommandLine == TEXT('\"'))
	{
		lpcszCommandLine = (LPCTSTR) _mbsinc((unsigned char *)lpcszCommandLine);
		while (*lpcszCommandLine != TEXT('\"') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			if (IsDBCSLeadByteEx(0, *lpcszCommandLine))
			{
				if (dwSize < 2)
				{
					break;
				}
				*(lpszOption++) = *(lpcszCommandLine++);
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize -= 2;
			}
			else
			{
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize--;
			}
		}
		if (*lpcszCommandLine == TEXT('\"'))
		{
			lpcszCommandLine++;
		}
		*lpszOption = TEXT('\0');
	}
	else if (*lpcszCommandLine)
	{
		while (*lpcszCommandLine != TEXT(' ') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			if (IsDBCSLeadByteEx(0, *lpcszCommandLine))
			{
				if (dwSize < 2)
				{
					break;
				}
				*(lpszOption++) = *(lpcszCommandLine++);
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize -= 2;
			}
			else
			{
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize--;
			}
		}
		*lpszOption = TEXT('\0');
	}
	else
	{
		return NULL;
	}

	return lpcszCommandLine;
#endif
}


static ULONG_PTR NVGetProcessId(HANDLE hProcess)
{
	HMODULE hKernel = LoadLibrary(TEXT("Kernel32.dll"));
	pfnGetProcessId GetProcessIdProc = (pfnGetProcessId) GetProcAddress(hKernel, "GetProcessId");
	if (GetProcessIdProc)
	{
		return GetProcessIdProc(hProcess);
	}
	else
	{
		HMODULE hNTDLL = LoadLibrary(TEXT("NTDLL.dll"));
		pfnQueryInformationProcess QueryInformationProcessProc = (pfnQueryInformationProcess) GetProcAddress(hNTDLL, "NtQueryInformationProcess");
		if (QueryInformationProcessProc)
		{
			PROCESS_BASIC_INFORMATION info;
			ULONG uSize;
			QueryInformationProcessProc(hProcess, ProcessBasicInformation, &info, sizeof(info), &uSize);
			return info.UniqueProcessId;
		}
		else
		{
			return -1;
		}
	}
}