#include "main.h"


extern CLSID g_EncoderId;
extern TCHAR g_szDestFileName[READ_BUF_LEN];


BOOL ConvertBaseWindow(LPCTSTR pszFaceFileName)
{
	TCHAR szReadBuf[READ_BUF_LEN];
	_tstring stImageName;

	GetPrivateProfileString(TEXT("Window"), TEXT("Image"), TEXT("Window.bmp"), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (! szReadBuf[0])
	{
		return FALSE;
	}

	if (PathIsRelative(szReadBuf))
	{
		TCHAR szTemp[READ_BUF_LEN];
		_tcscpy_s(szTemp, READ_BUF_LEN, pszFaceFileName);
		PathRemoveFileSpec(szTemp);
		PathAppend(szTemp, szReadBuf);
		stImageName = szTemp;
	}
	else
	{
		stImageName = szReadBuf;
	}
#ifdef _UNICODE
	Gdiplus::Bitmap bmp(stImageName.c_str());
#else
	int len = MultiByteToWideChar(CP_ACP, 0, stImageName.c_str(), -1, NULL, 0) + 1;
	LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
	MultiByteToWideChar(CP_ACP, 0, stImageName.c_str(), -1, temp, len);
	Gdiplus::Bitmap bmp(temp);
	_freea(temp);
#endif
	if (bmp.GetLastStatus() != Gdiplus::Ok)
	{
		return FALSE;
	}

	int nWidth = GetPrivateProfileInt(TEXT("Window"), TEXT("Width"), bmp.GetWidth(), pszFaceFileName);
	int nHeight = GetPrivateProfileInt(TEXT("Window"), TEXT("Height"), bmp.GetHeight(), pszFaceFileName);
	__int64 flags = GetFlags(pszFaceFileName, TEXT("Window"));
	Gdiplus::Bitmap dest(nWidth, nHeight);

	{
		Gdiplus::Graphics gr(&dest);
		Gdiplus::Rect rc(0, 0, nWidth, nHeight);

		gr.Clear(0);
		if (flags & NVBUTTON_TRANSPARENT)
		{
			if (bmp.GetPixelFormat() & (PixelFormatAlpha | PixelFormatPAlpha))
			{
				int i, j;
				int iMax = nHeight;
				int jMax = nWidth;
				BOOL fHasTransparentAlpha = FALSE;
				for (i = 0; i < iMax; i++)
				{
					for (j = 0; j < jMax; j++)
					{
						Gdiplus::Color color;
						bmp.GetPixel(j, i, &color);
						if (color.GetAlpha() != 255)
						{
							fHasTransparentAlpha = TRUE;
							break;
						}
					}
					if (fHasTransparentAlpha)
					{
						break;
					}
				}

				if (fHasTransparentAlpha)
				{
					gr.DrawImage(&bmp, rc, 0, 0, rc.Width, rc.Height, Gdiplus::UnitPixel, NULL, NULL, NULL);
				}
				else
				{
					Gdiplus::ImageAttributes attr;
					Gdiplus::Color color;
					bmp.GetPixel(0, 0, &color);
					color.SetValue(color.GetValue() & 0x00FFFFFF);
					attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
					gr.DrawImage(&bmp, rc, 0, 0, rc.Width, rc.Height, Gdiplus::UnitPixel, &attr, NULL, NULL);
				}
			}
			else
			{
				Gdiplus::ImageAttributes attr;
				Gdiplus::Color color;
				bmp.GetPixel(0, 0, &color);
				attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
				gr.DrawImage(&bmp, rc, 0, 0, rc.Width, rc.Height, Gdiplus::UnitPixel, &attr, NULL, NULL);
			}
		}
		else
		{
			gr.DrawImage(&bmp, rc, 0, 0, rc.Width, rc.Height, Gdiplus::UnitPixel, NULL, NULL, NULL);
		}
		if (flags & NVBUTTON_3DEDGE)
		{
			Draw3DEdge(&gr, rc.Width, rc.Height, FALSE);
		}
	}

	TCHAR szFileName[READ_BUF_LEN];

	_tcscpy_s(szFileName, READ_BUF_LEN, stImageName.c_str());
	ConvertSrcToDestFileName(szFileName, READ_BUF_LEN);
#ifdef _UNICODE
	dest.Save(szFileName, &g_EncoderId);
#else
	WCHAR wszFileName[READ_BUF_LEN];
	MultiByteToWideChar(CP_ACP, 0, szFileName, -1, wszFileName, READ_BUF_LEN);
	dest.Save(wszFileName, &g_EncoderId);
#endif

	WritePrivateProfileRelativePath(TEXT("Window"), TEXT("ImageFile"), szFileName, g_szDestFileName);
	WritePrivateProfileString(TEXT("Window"), TEXT("Category"), TEXT("BackImage"), g_szDestFileName);

	return TRUE;
}

Gdiplus::Bitmap *GetBaseImage(LPCTSTR pszFaceFileName)
{
	Gdiplus::Bitmap * bmp = NULL;

	TCHAR szReadBuf[READ_BUF_LEN];

	GetPrivateProfileString(TEXT("Window"), TEXT("Image"), TEXT("Window.bmp"), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		_tstring stImageName;
		if (PathIsRelative(szReadBuf))
		{
			TCHAR szTemp[READ_BUF_LEN];
			_tcscpy_s(szTemp, READ_BUF_LEN, pszFaceFileName);
			PathRemoveFileSpec(szTemp);
			PathAppend(szTemp, szReadBuf);
			stImageName = szTemp;
		}
		else
		{
			stImageName = szReadBuf;
		}
#ifdef _UNICODE
		bmp = new Gdiplus::Bitmap(stImageName.c_str());
#else
#endif
	}

	return bmp;
}

