#include "main.h"


extern TCHAR g_szDestFileName[READ_BUF_LEN];


BOOL ConvertCaption(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	TCHAR szReadBuf[READ_BUF_LEN];

	__int64 flags = GetFlags(pszFaceFileName, pszField);
	int nAlpha = 0xFF000000;
	if (flags & NVBUTTON_ALPHAENABLE)
	{
		int t = GetPrivateProfileInt(pszField, TEXT("AlphaValue"), -1, pszFaceFileName);
		if (t >= 0 && t <= 255)
		{
			nAlpha = t << 24;
		}
	}

	int t = GetPrivateProfileInt(pszField, TEXT("PosX"), 0, pszFaceFileName);
	WritePrivateProfileInt(pszField, TEXT("PosX"), t, g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("PosY"), 0, pszFaceFileName);
	WritePrivateProfileInt(pszField, TEXT("PosY"), t, g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("Width"), -1, pszFaceFileName);
	if (t > 0)
	{
		WritePrivateProfileInt(pszField, TEXT("Width"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Height"), -1, pszFaceFileName);
	if (t > 0)
	{
		WritePrivateProfileInt(pszField, TEXT("Height"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("FadeSpeed"), -1, pszFaceFileName);
	if (t >= 1 && t <= 256)
	{
		_tprintf(TEXT("FadeSpeed L[ɂ͖ΉłB %s\n"), pszField);
	}
	GetPrivateProfileString(pszField, TEXT("FontFace"), TEXT("lr SVbN"), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("FontFace"), szReadBuf, g_szDestFileName);
	}
	WritePrivateProfileString(pszField, TEXT("AlternateFontFace"), TEXT("lr SVbN"), g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("FontSize"), -1, pszFaceFileName);
	if (t > 0)
	{
		int p = t;
		SIZE sizGdiplus = CalcStringSize(pszFaceFileName, pszField, p, TEXT("00:00"));
		SIZE sizGdi = CalcStringSizeByGDI(pszFaceFileName, pszField, TEXT("00:00"));
		while (sizGdiplus.cy > sizGdi.cy && p > 0)
		{
			p--;
			sizGdiplus = CalcStringSize(pszFaceFileName, pszField, p, TEXT("00:00"));
		}
		WritePrivateProfileInt(pszField, TEXT("FontSize"), p, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("FontColor"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("TextColor"), t | nAlpha, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("FontShadow"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("ShadowColor"), t | nAlpha, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Priority"), 0xFFFF, pszFaceFileName) - 0xFFFF;
	WritePrivateProfileInt(pszField, TEXT("Priority"), t, g_szDestFileName);
	GetPrivateProfileString(pszField, TEXT("Caption"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("Caption"), szReadBuf, g_szDestFileName);
	}

	std::wstring stStyle;

	if (flags & (NVBUTTON_BOLD | NVBUTTON_EXTRABOLD))
	{
		stStyle.append(L"Bold, ");
	}
	if (flags & NVBUTTON_ITALIC)
	{
		stStyle.append(L"Italic, ");
	}
	if (flags & NVBUTTON_UNDERLINE)
	{
		stStyle.append(L"Underline, ");
	}
	if (flags & NVBUTTON_STRIKEOUT)
	{
		stStyle.append(L"Strikeout, ");
	}
	if (stStyle.size() > 0)
	{
#ifdef _UNICODE
		WritePrivateProfileString(pszField, TEXT("FontStyle"), stStyle.c_str(), g_szDestFileName);
#else
		int len = WideCharToMultiByte(CP_ACP, 0, stStyle.c_str(), -1, NULL, 0, NULL, NULL) + 1;
		LPSTR temp = (LPSTR) _malloca(len);
		WideCharToMultiByte(CP_ACP, 0, stStyle.c_str(), -1, temp, len, NULL, NULL);
		WritePrivateProfileString(pszField, TEXT("FontStyle"), temp, g_szDestFileName);
		_freea(temp);
#endif
	}

	if (flags & (NVBUTTON_FADE | NVBUTTON_CROSSFADE))
	{
		WritePrivateProfileInt(pszField, TEXT("CrossFadeTime"), 0, g_szDestFileName);
	}

	if (flags & NVBUTTON_TEXTCENTER)
	{
		WritePrivateProfileString(pszField, TEXT("Align"), TEXT("TopCenter"), g_szDestFileName);
	}
	else if (flags & NVBUTTON_TEXTRIGHT)
	{
		WritePrivateProfileString(pszField, TEXT("Align"), TEXT("TopRight"), g_szDestFileName);
	}
	else //if (flags & NVBUTTON_TEXTLEFT)
	{
		WritePrivateProfileString(pszField, TEXT("Align"), TEXT("TopLeft"), g_szDestFileName);
	}
	if (flags & NVBUTTON_ACTIVEONLY)
	{
		WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("ActiveOnly"), g_szDestFileName);
	}
	else if (flags & NVBUTTON_INACTIVEONLY)
	{
		WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("InactiveOnly"), g_szDestFileName);
	}
	else
	{
		WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("ActiveAndInactive"), g_szDestFileName);
	}

	if (flags & NVBUTTON_ENABLE)
	{
		WritePrivateProfileBool(pszField, TEXT("Enable"), TRUE, g_szDestFileName);
	}

	return TRUE;
}

SIZE CalcStringSize(LPCTSTR pszFaceFileName, LPCTSTR pszField, int nOverridedHeight, LPCTSTR pszTestString)
{
	SIZE siz = { 0, 0 };
	__int64 flags = GetFlags(pszFaceFileName, pszField);
	if (flags & NVBUTTON_CAPTION)
	{
		HDC hdc = GetDC(HWND_DESKTOP);
		Gdiplus::Graphics gr(hdc);

		TCHAR szFontFace[256];
		GetPrivateProfileString(pszField, TEXT("FontFace"), TEXT("lr SVbN"), szFontFace, 256, pszFaceFileName);
		int nStyle = 0;
		int nFontSize = GetPrivateProfileInt(pszField, TEXT("FontSize"), 12, pszFaceFileName);
		if (nOverridedHeight > 0)
		{
			nFontSize = nOverridedHeight;
		}
		TCHAR szCaption[READ_BUF_LEN];
		GetPrivateProfileString(pszField, TEXT("Caption"), TEXT(""), szCaption, READ_BUF_LEN, pszFaceFileName);

		if (flags & (NVBUTTON_BOLD | NVBUTTON_EXTRABOLD))
		{
			nStyle |=  Gdiplus::FontStyleBold;
		}
		if (flags & NVBUTTON_ITALIC)
		{
			nStyle |= Gdiplus::FontStyleItalic;
		}
		if (flags & NVBUTTON_UNDERLINE)
		{
			nStyle |= Gdiplus::FontStyleUnderline;
		}
		if (flags & NVBUTTON_STRIKEOUT)
		{
			nStyle |= Gdiplus::FontStyleStrikeout;
		}
#ifdef _UNICODE
		Gdiplus::Font font(szFontFace, (Gdiplus::REAL) nFontSize, nStyle, Gdiplus::UnitPixel);
#else
		WCHAR wszFontFace[256];
		MultiByteToWideChar(CP_ACP, 0, szFontFace, -1, wszFontFace, 256);
		Gdiplus::Font font(wszFontFace, (Gdiplus::REAL) nFontSize, nStyle, Gdiplus::UnitPixel);
#endif
		Gdiplus::PointF pt(0.0f, 0.0f);
		{
			Gdiplus::RectF rc;
			if (pszTestString)
			{
#ifdef _UNICODE
				gr.MeasureString(pszTestString, (INT) _tcslen(pszTestString), &font, pt, &rc);
#else
				int len = MultiByteToWideChar(CP_ACP, 0, pszTestString, -1, NULL, 0) + 1;
				LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
				MultiByteToWideChar(CP_ACP, 0, pszTestString, -1, temp, 256);
				gr.MeasureString(temp, (INT) wcslen(temp), &font, pt, &rc);
				_freea(temp);
#endif
			}
			else
			{
#ifdef _UNICODE
				gr.MeasureString(szCaption, (INT) _tcslen(szCaption), &font, pt, &rc);
#else
				int len = MultiByteToWideChar(CP_ACP, 0, szCaption, -1, NULL, 0) + 1;
				LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
				MultiByteToWideChar(CP_ACP, 0, szCaption, -1, temp, 256);
				gr.MeasureString(temp, (INT) wcslen(temp), &font, pt, &rc);
				_freea(temp);
#endif
			}

			siz.cx = (int) rc.Width;
			siz.cy = (int) rc.Height;
		}
		ReleaseDC(HWND_DESKTOP, hdc);
	}

	return siz;
}

SIZE CalcStringSizeByGDI(LPCTSTR pszFaceFileName, LPCTSTR pszField, LPCTSTR pszTestString)
{
	SIZE siz = { 0, 0 };
	__int64 flags = GetFlags(pszFaceFileName, pszField);
	if (flags & NVBUTTON_CAPTION)
	{
		LOGFONT lf;

		ZeroMemory(&lf, sizeof(LOGFONT));

		TCHAR szFontFace[256];
		GetPrivateProfileString(pszField, TEXT("FontFace"), TEXT("lr SVbN"), szFontFace, 256, pszFaceFileName);
		int nStyle = 0;
		int nFontSize = GetPrivateProfileInt(pszField, TEXT("FontSize"), 12, pszFaceFileName);

		_tcsncpy_s(lf.lfFaceName, LF_FACESIZE, szFontFace, LF_FACESIZE - 1);
		lf.lfHeight = nFontSize;
		lf.lfWidth = 0;
		lf.lfEscapement = 0;
		lf.lfOrientation = 0;
		lf.lfWeight = (flags & (NVBUTTON_BOLD | NVBUTTON_EXTRABOLD)) ? FW_BOLD : FW_NORMAL;
		lf.lfItalic = (flags & NVBUTTON_ITALIC) ? TRUE : FALSE;
		lf.lfUnderline = (flags & NVBUTTON_UNDERLINE) ? TRUE : FALSE;
		lf.lfStrikeOut = (flags & NVBUTTON_STRIKEOUT) ? TRUE : FALSE;
		lf.lfCharSet = DEFAULT_CHARSET;
		lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;
		lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		lf.lfQuality = NONANTIALIASED_QUALITY;
		lf.lfPitchAndFamily = FF_DONTCARE;

		HFONT hfont = CreateFontIndirect(&lf);

		HDC hdc;
		HGDIOBJ hPrev;

		//  ftHg̃LvV񂩂A͈̔͂vZ
		hdc = CreateCompatibleDC(NULL);
		hPrev = SelectObject(hdc, hfont);
		GetTextExtentPoint32(hdc, pszTestString, (INT) _tcslen(pszTestString), &siz);
		SelectObject(hdc, hPrev);
		DeleteDC(hdc);
		DeleteObject(hfont);
	}

	return siz;
}

