#include "main.h"

extern CLSID g_EncoderId;
extern TCHAR g_szDestFileName[READ_BUF_LEN];
extern BOOL g_fIsNewButtonControl;
extern BOOL g_fIsExistAnalyzerOnOff;


void MakeTransparentButton(Gdiplus::Bitmap& dest, SIZE sizDest, Gdiplus::Rect rcDest, Gdiplus::Bitmap& src, SIZE sizSrc, Gdiplus::Bitmap& win, RECT rcButton, int nColorKey, __int64 flags, BOOL fPushed);
void MakeImageButton(Gdiplus::Bitmap& dest, Gdiplus::Rect rcDest, Gdiplus::Bitmap& src, SIZE sizSrc, __int64 flags, int nColorKey, BOOL fPushed);
void DrawCaption(Gdiplus::Bitmap& dest, SIZE sizDest, SIZE sizSrc, __int64 flags, LPCTSTR pszField, LPCTSTR pszFaceFileName);
void SaveImage(Gdiplus::Bitmap& src, BOOL fPushed, LPCTSTR pszField, _tstring& stImageName);

BOOL ConvertImageButton(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	TCHAR szReadBuf[READ_BUF_LEN];

	Gdiplus::Bitmap *bmpWindow = NULL;
	RECT rc;
	__int64 flags = GetFlags(pszFaceFileName, pszField);
	_tstring stImageName;
	BOOL fIsStringOnlyImage = FALSE;
	BOOL fIsSlider = FALSE;

	try
	{
		if (flags & NVBUTTON_TRANSPARENT)
		{
			bmpWindow = GetBaseImage(pszFaceFileName);
		}

		GetPrivateProfileString(pszField, TEXT("Image"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		if (! szReadBuf[0])
		{
			fIsStringOnlyImage = TRUE;
		}

		if (PathIsRelative(szReadBuf))
		{
			TCHAR szTemp[READ_BUF_LEN];
			_tcscpy_s(szTemp, READ_BUF_LEN, pszFaceFileName);
			PathRemoveFileSpec(szTemp);
			PathAppend(szTemp, szReadBuf);
			stImageName = szTemp;
		}
		else
		{
			stImageName = szReadBuf;
		}
#ifdef _UNICODE
		Gdiplus::Bitmap src(stImageName.c_str());
#else
		int len = MultiByteToWideChar(CP_ACP, 0, stImageName.c_str(), -1, NULL, 0) + 1;
		LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
		MultiByteToWideChar(CP_ACP, 0, stImageName.c_str(), -1, temp, len);
		Gdiplus::Bitmap src(temp);
		_freea(temp);
#endif
/*		if (src.GetLastStatus() != Gdiplus::Ok)
		{
			throw FALSE;
		}
		if (src.GetWidth() <= 0 || src.GetHeight() <= 0)
		{
			throw FALSE;
		}
*/
		rc.left = GetPrivateProfileInt(pszField, TEXT("PosX"), 0, pszFaceFileName);
		rc.top = GetPrivateProfileInt(pszField, TEXT("PosY"), 0, pszFaceFileName);

		if (fIsStringOnlyImage)
		{
			TCHAR szTemp[READ_BUF_LEN];
			_tcscpy_s(szTemp, READ_BUF_LEN, pszFaceFileName);
			PathRemoveFileSpec(szTemp);
			PathAppend(szTemp, pszField);
			stImageName = szTemp;
			stImageName.append(TEXT("_TextButton.png"));
			SIZE siz = CalcStringSize(pszFaceFileName, pszField);
			rc.right = GetPrivateProfileInt(pszField, TEXT("Width"), siz.cx, pszFaceFileName) + rc.left;
			rc.bottom = GetPrivateProfileInt(pszField, TEXT("Height"), siz.cy, pszFaceFileName) + rc.top;
		}
		else
		{
			rc.right = GetPrivateProfileInt(pszField, TEXT("Width"), src.GetWidth(), pszFaceFileName) + rc.left;
			rc.bottom = GetPrivateProfileInt(pszField, TEXT("Height"), (flags & NVBUTTON_PUSHBUTTON) ? src.GetHeight() / 2 : src.GetHeight(), pszFaceFileName) + rc.top;
		}
		if (IsRectEmpty(&rc))
		{
			throw FALSE;
		}

		if (_tcsicmp(pszField, TEXT("Seek")) == 0 || _tcsicmp(pszField, TEXT("VolumeBar")) == 0 || _tcsicmp(pszField, TEXT("PanControl")) == 0)
		{
			fIsSlider = TRUE;
			if (flags & NVBUTTON_VERTICAL)
			{
				WritePrivateProfileBool(pszField, TEXT("IsVertical"), TRUE, g_szDestFileName);
				if (_tcsicmp(pszField, TEXT("VolumeBar")) == 0 || _tcsicmp(pszField, TEXT("PanControl")) == 0)
				{
					WritePrivateProfileBool(pszField, TEXT("IsReversedSlider"), TRUE, g_szDestFileName);
				}
			}
		}
		int nColorKey = GetPrivateProfileInt(pszField, TEXT("ColorKey"), -1, pszFaceFileName);
		if ((flags & NVBUTTON_PUSHBUTTON) && (! fIsStringOnlyImage))
		{
			WritePrivateProfileString(pszField, TEXT("Category"), TEXT("DynamicImage"), g_szDestFileName);
			SIZE sizSrc = { src.GetWidth(), rc.bottom - rc.top };
			SIZE sizDest = { rc.right - rc.left, rc.bottom - rc.top };
			if (fIsSlider)
			{
				sizDest.cx = sizSrc.cx;
				sizDest.cy = sizSrc.cy;
			}

			Gdiplus::Rect rcDest(0, 0, sizSrc.cx, sizSrc.cy);
			if (flags & NVBUTTON_CENTER)
			{
				rcDest.X = (sizDest.cx - sizSrc.cx) / 2;
			}
			if (flags & NVBUTTON_RIGHT)
			{
				rcDest.X = sizDest.cx - sizSrc.cx;
			}

			if (flags & NVBUTTON_VCENTER)
			{
				rcDest.Y = (sizDest.cy - sizSrc.cy) / 2;
			}
			if (flags & NVBUTTON_BOTTOM)
			{
				rcDest.Y = sizDest.cy - sizSrc.cy;
			}

			{
				int nImageX = GetPrivateProfileInt(pszField, TEXT("ImageX"), 0, pszFaceFileName);
				int nImageY = GetPrivateProfileInt(pszField, TEXT("ImageX"), 0, pszFaceFileName);

				if (nImageX)
				{
					rcDest.X = nImageX;
				}
				if (nImageY)
				{
					rcDest.Y = nImageY;
				}
			}

			if (flags & NVBUTTON_TRANSPARENT)
			{
				Gdiplus::Bitmap norm(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);
				Gdiplus::Bitmap push(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);

				MakeTransparentButton(norm, sizDest, rcDest, src, sizSrc, *bmpWindow, rc, nColorKey, flags, FALSE);
				MakeTransparentButton(push, sizDest, rcDest, src, sizSrc, *bmpWindow, rc, nColorKey, flags, TRUE);

				if (flags & NVBUTTON_CAPTION)
				{
					DrawCaption(norm, sizDest, sizSrc, flags, pszField, pszFaceFileName);
					DrawCaption(push, sizDest, sizSrc, flags, pszField, pszFaceFileName);
				}

				SaveImage(norm, FALSE, pszField, stImageName);
				SaveImage(push, TRUE, pszField, stImageName);
			}
			else
			{
				Gdiplus::Bitmap norm(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);
				Gdiplus::Bitmap push(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);

				MakeImageButton(norm, rcDest, src, sizSrc, flags, nColorKey, FALSE);
				MakeImageButton(push, rcDest, src, sizSrc, flags, nColorKey, TRUE);

				if (flags & NVBUTTON_CAPTION)
				{
					DrawCaption(norm, sizDest, sizSrc, flags, pszField, pszFaceFileName);
					DrawCaption(push, sizDest, sizSrc, flags, pszField, pszFaceFileName);
				}

				SaveImage(norm, FALSE, pszField, stImageName);
				SaveImage(push, TRUE, pszField, stImageName);
			}
		}
		else
		{
			SIZE sizSrc = { src.GetWidth(), src.GetHeight() };
			SIZE sizDest = { rc.right - rc.left, rc.bottom - rc.top };
			if (fIsSlider)
			{
				sizDest.cx = sizSrc.cx;
				sizDest.cy = sizSrc.cy;
			}

			Gdiplus::Rect rcDest(0, 0, sizSrc.cx, sizSrc.cy);
			if (flags & NVBUTTON_CENTER)
			{
				rcDest.X = (sizDest.cx - sizSrc.cx) / 2;
			}
			if (flags & NVBUTTON_RIGHT)
			{
				rcDest.X = sizDest.cx - sizSrc.cx;
			}

			if (flags & NVBUTTON_VCENTER)
			{
				rcDest.Y = (sizDest.cy - sizSrc.cy) / 2;
			}
			if (flags & NVBUTTON_BOTTOM)
			{
				rcDest.Y = sizDest.cy - sizSrc.cy;
			}

			if (flags & NVBUTTON_TRANSPARENT)
			{
				Gdiplus::Bitmap norm(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);

				MakeTransparentButton(norm, sizDest, rcDest, src, sizSrc, *bmpWindow, rc, nColorKey, flags, FALSE);

				if (flags & NVBUTTON_CAPTION)
				{
					DrawCaption(norm, sizDest, sizSrc, flags, pszField, pszFaceFileName);
				}

				SaveImage(norm, FALSE, pszField, stImageName);
			}
			else
			{
				Gdiplus::Bitmap norm(sizDest.cx, sizDest.cy, PixelFormat32bppARGB);

				MakeImageButton(norm, rcDest, src, sizSrc, flags, nColorKey, FALSE);

				if (flags & NVBUTTON_CAPTION)
				{
					DrawCaption(norm, sizDest, sizSrc, flags, pszField, pszFaceFileName);
				}

				SaveImage(norm, FALSE, pszField, stImageName);
			}
		}

		WritePrivateProfileInt(pszField, TEXT("PosX"), rc.left, g_szDestFileName);
		WritePrivateProfileInt(pszField, TEXT("PosY"), rc.top, g_szDestFileName);
		WritePrivateProfileInt(pszField, TEXT("Width"), rc.right - rc.left, g_szDestFileName);
		WritePrivateProfileInt(pszField, TEXT("Height"), rc.bottom - rc.top, g_szDestFileName);

		if (bmpWindow)
		{
			delete bmpWindow;
		}

		if (flags & NVBUTTON_ENABLE)
		{
			WritePrivateProfileBool(pszField, TEXT("Enable"), TRUE, g_szDestFileName);
		}
		else if (g_fIsNewButtonControl)
		{
			GetPrivateProfileString(pszField, TEXT("Category"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
			if (_tcsicmp(szReadBuf, TEXT("UserItem")) != 0)
			{
				WritePrivateProfileBool(pszField, TEXT("Enable"), TRUE, g_szDestFileName);
			}
		}
		int nPriority = GetPrivateProfileInt(pszField, TEXT("Priority"), 0xFFFF, pszFaceFileName) - 0xFFFF;
		WritePrivateProfileInt(pszField, TEXT("Priority"), nPriority, g_szDestFileName);
		if (flags & NVBUTTON_ALPHAENABLE)
		{
			int nAlpha = GetPrivateProfileInt(pszField, TEXT("AlphaValue"), -1, pszFaceFileName);
			if (nAlpha >= 0 && nAlpha <= 255)
			{
				WritePrivateProfileInt(pszField, TEXT("ConstAlpha"), nAlpha, g_szDestFileName);
			}
		}

		if (flags & NVBUTTON_ACTIVEONLY)
		{
			WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("ActiveOnly"), g_szDestFileName);
		}
		else if (flags & NVBUTTON_INACTIVEONLY)
		{
			WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("InactiveOnly"), g_szDestFileName);
		}
		else
		{
			WritePrivateProfileString(pszField, TEXT("ActiveType"), TEXT("ActiveAndInactive"), g_szDestFileName);
		}

		if (! (flags & NVBUTTON_USEREGION))
		{
			WritePrivateProfileBool(pszField, TEXT("DisableRegion"), TRUE, g_szDestFileName);
		}

		if (_tcsicmp(pszField, TEXT("AnalyzerON")) == 0)
		{
			WritePrivateProfileInt(pszField, TEXT("CommandCount"), 3, g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command1"), TEXT("HideItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType1"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam1"), TEXT("Analyzer"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command2"), TEXT("HideItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType2"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam2"), TEXT("AnalyzerON"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command3"), TEXT("ShowItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType3"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam3"), TEXT("AnalyzerOFF"), g_szDestFileName);
		}
		if (_tcsicmp(pszField, TEXT("AnalyzerOFF")) == 0)
		{
			WritePrivateProfileInt(pszField, TEXT("CommandCount"), 3, g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command1"), TEXT("ShowItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType1"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam1"), TEXT("Analyzer"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command2"), TEXT("HideItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType2"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam2"), TEXT("AnalyzerOFF"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("Command3"), TEXT("ShowItem"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParamType3"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(pszField, TEXT("CommandParam3"), TEXT("AnalyzerON"), g_szDestFileName);
			g_fIsExistAnalyzerOnOff = TRUE;
		}
	}
	catch (BOOL ret)
	{
		if (bmpWindow)
		{
			delete bmpWindow;
		}
		return ret;
	}

	return TRUE;
}

BOOL Draw3DEdge(Gdiplus::Graphics *gr, int nWidth, int nHeight, BOOL fPushed)
{
	if (fPushed)
	{
		{
			Gdiplus::Color color(255, 0, 0, 0);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, 0, 0, nWidth - 1, 0);
			gr->DrawLine(&pen, 0, 0, 0, nHeight - 1);
		}
		{
			Gdiplus::Color color(128, 0, 0, 0);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, 1, 1, nWidth - 2, 1);
			gr->DrawLine(&pen, 1, 2, 1, nHeight - 2);
		}
		{
			Gdiplus::Color color(255, 255, 255, 255);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, nWidth - 1, 1, nWidth - 1, nHeight - 1);
			gr->DrawLine(&pen, 1, nHeight - 1, nWidth - 1, nHeight - 1);
		}
		{
			Gdiplus::Color color(128, 255, 255, 255);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, nWidth - 2, 2, nWidth - 2, nHeight - 2);
			gr->DrawLine(&pen, 1, nHeight - 2, nWidth - 3, nHeight - 2);
		}
	}
	else
	{
		{
			Gdiplus::Color color(255, 255, 255, 255);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, 0, 0, nWidth - 1, 0);
			gr->DrawLine(&pen, 0, 0, 0, nHeight - 1);
		}
		{
			Gdiplus::Color color(128, 255, 255, 255);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, 1, 1, nWidth - 2, 1);
			gr->DrawLine(&pen, 1, 2, 1, nHeight - 2);
		}
		{
			Gdiplus::Color color(255, 0, 0, 0);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, nWidth - 1, 1, nWidth - 1, nHeight - 1);
			gr->DrawLine(&pen, 1, nHeight - 1, nWidth - 1, nHeight - 1);
		}
		{
			Gdiplus::Color color(128, 0, 0, 0);
			Gdiplus::Pen pen(color);
			gr->DrawLine(&pen, nWidth - 2, 2, nWidth - 2, nHeight - 2);
			gr->DrawLine(&pen, 1, nHeight - 2, nWidth - 3, nHeight - 2);
		}
	}

	return TRUE;
}

void MakeTransparentButton(Gdiplus::Bitmap& dest, SIZE sizDest, Gdiplus::Rect rcDest, Gdiplus::Bitmap& src, SIZE sizSrc, Gdiplus::Bitmap& win, RECT rcButton, int nColorKey, __int64 flags, BOOL fPushed)
{
	Gdiplus::Rect rcBack(0, 0, sizDest.cx, sizDest.cy);
	Gdiplus::Graphics gr(&dest);

	int yOffset = (fPushed) ? sizSrc.cy : 0;

	gr.DrawImage(&win, rcBack, rcButton.left, rcButton.top, rcButton.right, rcButton.bottom, Gdiplus::UnitPixel, NULL, NULL, NULL);
	if (flags & NVBUTTON_COLORKEY)
	{
		if (nColorKey >= 0)
		{
			Gdiplus::ImageAttributes attr;
			Gdiplus::Color color(GetRValue(nColorKey), GetGValue(nColorKey), GetBValue(nColorKey));
			attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
			gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, &attr, NULL, NULL);
		}
		else
		{
			Gdiplus::ImageAttributes attr;
			Gdiplus::Color color;
			src.GetPixel(0, 0, &color);
			attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
			gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, &attr, NULL, NULL);
		}
	}
	else
	{
		gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, NULL, NULL, NULL);
	}
	if (flags & NVBUTTON_3DEDGE)
	{
		Draw3DEdge(&gr, sizDest.cx, sizDest.cy, fPushed);
	}
}

void DrawCaption(Gdiplus::Bitmap& dest, SIZE sizDest, SIZE sizSrc, __int64 flags, LPCTSTR pszField, LPCTSTR pszFaceFileName)
{
	Gdiplus::Graphics gr(&dest);

	COLORREF crText = GetPrivateProfileInt(pszField, TEXT("FontColor"), RGB(255, 255, 255), pszFaceFileName);
	COLORREF crShadow = GetPrivateProfileInt(pszField, TEXT("FontShadow"), 0xFF000000, pszFaceFileName);
	TCHAR szFontFace[256];
	GetPrivateProfileString(pszField, TEXT("FontFace"), TEXT("lr SVbN"), szFontFace, 256, pszFaceFileName);
	int nStyle = 0;
	int nFontSize = GetPrivateProfileInt(pszField, TEXT("FontSize"), 12, pszFaceFileName);
	TCHAR szCaption[READ_BUF_LEN];
	GetPrivateProfileString(pszField, TEXT("Caption"), TEXT(""), szCaption, READ_BUF_LEN, pszFaceFileName);

	if (nFontSize > 0)
	{
		int p = nFontSize;
		LPCTSTR pszTestString = TEXT("00:00");
		if (szCaption[0])
		{
			pszTestString = szCaption;
		}
		SIZE sizGdiplus = CalcStringSize(pszFaceFileName, pszField, p, pszTestString);
		SIZE sizGdi = CalcStringSizeByGDI(pszFaceFileName, pszField, pszTestString);
		while ((sizGdiplus.cx > sizGdi.cx || sizGdiplus.cy > sizGdi.cy) && p > 0)
		{
			p--;
			sizGdiplus = CalcStringSize(pszFaceFileName, pszField, p, pszTestString);
		}
		nFontSize = p;
	}
	if (flags & (NVBUTTON_BOLD | NVBUTTON_EXTRABOLD))
	{
		nStyle |=  Gdiplus::FontStyleBold;
	}
	if (flags & NVBUTTON_ITALIC)
	{
		nStyle |= Gdiplus::FontStyleItalic;
	}
	if (flags & NVBUTTON_UNDERLINE)
	{
		nStyle |= Gdiplus::FontStyleUnderline;
	}
	if (flags & NVBUTTON_STRIKEOUT)
	{
		nStyle |= Gdiplus::FontStyleStrikeout;
	}
#ifdef _UNICODE
	Gdiplus::Font font(szFontFace, (Gdiplus::REAL) nFontSize, nStyle, Gdiplus::UnitPixel);
#else
	WCHAR wszFontFace[256];
	MultiByteToWideChar(CP_ACP, 0, szFontFace, -1, wszFontFace, 256);
	Gdiplus::Font font(wszFontFace, (Gdiplus::REAL) nFontSize, nStyle, Gdiplus::UnitPixel);
#endif
	Gdiplus::Color colorText(GetRValue(crText), GetGValue(crText), GetBValue(crText));
	Gdiplus::PointF pt(0.0f, 0.0f);
	{
		Gdiplus::RectF rc;
#ifdef _UNICODE
		gr.MeasureString(szCaption, (INT) _tcslen(szCaption), &font, pt, &rc);
#else
		int len = MultiByteToWideChar(CP_ACP, 0, szCaption, -1, NULL, 0) + 1;
		LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
		MultiByteToWideChar(CP_ACP, 0, szCaption, -1, temp, 256);
		gr.MeasureString(temp, (INT) wcslen(temp), &font, pt, &rc);
		_freea(temp);
#endif

		sizSrc.cx = (int) rc.Width;
		sizSrc.cy = (int) rc.Height;
	}

	Gdiplus::Rect rcDest(0, 0, sizSrc.cx, sizSrc.cy);
	if (flags & NVBUTTON_CENTER)
	{
		pt.X = (Gdiplus::REAL) (sizDest.cx - sizSrc.cx) / 2;
	}
	if (flags & NVBUTTON_RIGHT)
	{
		pt.X = (Gdiplus::REAL) sizDest.cx - sizSrc.cx;
	}

	if (flags & NVBUTTON_VCENTER)
	{
		pt.Y = (Gdiplus::REAL) (sizDest.cy - sizSrc.cy) / 2;
	}
	if (flags & NVBUTTON_BOTTOM)
	{
		pt.Y = (Gdiplus::REAL) sizDest.cy - sizSrc.cy;
	}

	if ((crShadow & 0xFF000000) == 0)
	{
		Gdiplus::Color colorShadow(GetRValue(crShadow), GetGValue(crShadow), GetBValue(crShadow));
		Gdiplus::SolidBrush brush(colorShadow);
		Gdiplus::PointF pt2 = pt;

		pt2.X += 1;
		pt2.Y += 1;
#ifdef _UNICODE
		gr.DrawString(szCaption, (INT) _tcslen(szCaption), &font, pt, &brush);
#else
		int len = MultiByteToWideChar(CP_ACP, 0, szCaption, -1, NULL, 0) + 1;
		LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
		MultiByteToWideChar(CP_ACP, 0, szCaption, -1, temp, 256);
		gr.DrawString(temp, (INT) wcslen(temp), &font, pt, &brush);
		_freea(temp);
#endif
	}
	{
		Gdiplus::SolidBrush brush(colorText);

#ifdef _UNICODE
		gr.DrawString(szCaption, (INT) _tcslen(szCaption), &font, pt, &brush);
#else
		int len = MultiByteToWideChar(CP_ACP, 0, szCaption, -1, NULL, 0) + 1;
		LPWSTR temp = (LPWSTR) _malloca(len * sizeof(WCHAR));
		MultiByteToWideChar(CP_ACP, 0, szCaption, -1, temp, 256);
		gr.DrawString(temp, (INT) wcslen(temp), &font, pt, &brush);
		_freea(temp);
#endif
	}
}

void MakeImageButton(Gdiplus::Bitmap& dest, Gdiplus::Rect rcDest, Gdiplus::Bitmap& src, SIZE sizSrc, __int64 flags, int nColorKey, BOOL fPushed)
{
	Gdiplus::Graphics gr(&dest);

	int yOffset = (fPushed) ? sizSrc.cy : 0;
	if (flags & NVBUTTON_COLORKEY)
	{
		if (nColorKey >= 0)
		{
			Gdiplus::ImageAttributes attr;
			Gdiplus::Color color(GetRValue(nColorKey), GetGValue(nColorKey), GetBValue(nColorKey));
			attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
			gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, &attr, NULL, NULL);
		}
		else
		{
			Gdiplus::ImageAttributes attr;
			Gdiplus::Color color;
			src.GetPixel(0, 0, &color);
			attr.SetColorKey(color, color, Gdiplus::ColorAdjustTypeBitmap);
			gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, &attr, NULL, NULL);
		}
	}
	else
	{
		gr.DrawImage(&src, rcDest, 0, yOffset, sizSrc.cx, sizSrc.cy, Gdiplus::UnitPixel, NULL, NULL, NULL);
	}
}

void SaveImage(Gdiplus::Bitmap& src, BOOL fPushed, LPCTSTR pszField, _tstring& stImageName)
{
	TCHAR szFileName[READ_BUF_LEN];

	_tcscpy_s(szFileName, READ_BUF_LEN, stImageName.c_str());
	ConvertSrcToDestFileName(szFileName, READ_BUF_LEN);
	PathRemoveExtension(szFileName);
	_tcscat_s(szFileName, READ_BUF_LEN, (fPushed) ? TEXT("_Pushed") : TEXT("_Normal"));
	PathAddExtension(szFileName, TEXT(".png"));

#ifdef _UNICODE
	src.Save(szFileName, &g_EncoderId, 0);
#else
	WCHAR wszFileName[READ_BUF_LEN];
	MultiByteToWideChar(CP_ACP, 0, szFileName, -1, wszFileName, READ_BUF_LEN);
	src.Save(wszFileName, &g_EncoderId, 0);
#endif
	WritePrivateProfileRelativePath(pszField, (fPushed) ? TEXT("PushedImageFile") : TEXT("ImageFile"), szFileName, g_szDestFileName);
}