#include "main.h"


extern TCHAR g_szDestFileName[READ_BUF_LEN];


enum
{
	SOUNDFILEVIEW_COLUMN_FILENAME = 0,
	SOUNDFILEVIEW_COLUMN_FILEPATH,
	SOUNDFILEVIEW_COLUMN_TITLE,
	SOUNDFILEVIEW_COLUMN_ARTIST,
	SOUNDFILEVIEW_COLUMN_ALBUM,
	SOUNDFILEVIEW_COLUMN_DATE,
	SOUNDFILEVIEW_COLUMN_TRACKNUMBER,
	SOUNDFILEVIEW_COLUMN_GENRE,
	SOUNDFILEVIEW_COLUMN_COMMENT,
	SOUNDFILEVIEW_COLUMN_PLAYTIME,
	SOUNDFILEVIEW_COLUMN_NO,
	SOUNDFILEVIEW_COLUMN_LABEL_MAX,
};


BOOL ConvertDockingPlayList(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	TCHAR szReadBuf[READ_BUF_LEN];

	WritePrivateProfileString(pszField, TEXT("Category"), TEXT("PlayList"), g_szDestFileName);
	int t = GetPrivateProfileInt(pszField, TEXT("PosX"), 0, pszFaceFileName);
	WritePrivateProfileInt(pszField, TEXT("PosX"), t, g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("PosY"), 0, pszFaceFileName);
	WritePrivateProfileInt(pszField, TEXT("PosY"), t, g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("Width"), -1, pszFaceFileName);
	if (t > 0)
	{
		WritePrivateProfileInt(pszField, TEXT("Width"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Height"), -1, pszFaceFileName);
	if (t > 0)
	{
		WritePrivateProfileInt(pszField, TEXT("Height"), t, g_szDestFileName);
	}

	t = GetPrivateProfileInt(pszField, TEXT("FileName"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("FileNameWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("FilePath"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("FilePathWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Title"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("TitleWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Artist"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("ArtistWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Album"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("AlbumWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Date"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("DateWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Track"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("TrackNumberWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Genre"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("GenreWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Comment"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("CommentWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("PlayTime"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("PlayTimeWidth"), t, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("Number"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileInt(pszField, TEXT("NumberWidth"), t, g_szDestFileName);
	}

	GetPrivateProfileString(pszField, TEXT("ColumnOrder"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		int i;
		int index = 0;
		LPTSTR pszCur = szReadBuf;
		LPTSTR pContext = NULL;
		int nOrder[SOUNDFILEVIEW_COLUMN_LABEL_MAX] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, };
		const static TCHAR *lpszColumnName[SOUNDFILEVIEW_COLUMN_LABEL_MAX] = 
		{
			TEXT("FileName"), TEXT("FilePath"), TEXT("Title"), TEXT("Artist"), TEXT("Album"), TEXT("Date"), TEXT("Track"), TEXT("Genre"), TEXT("Comment"), TEXT("PlayTime"), TEXT("Number"),
		};
		pszCur = _tcstok_s(pszCur, OPTION_DELIMITA, &pContext);

		while (pszCur != NULL)
		{
			for (i = 0; i < SOUNDFILEVIEW_COLUMN_LABEL_MAX; i++)
			{
				if (_tcsicmp(pszCur, lpszColumnName[i]) == 0)
				{
					if (nOrder[i] < 0)
					{
						nOrder[i] = index;
						index++;
					}
					break;
				}
			}
			pszCur = _tcstok_s(NULL, OPTION_DELIMITA, &pContext);
		}

		for (i = 0; index < SOUNDFILEVIEW_COLUMN_LABEL_MAX && i < SOUNDFILEVIEW_COLUMN_LABEL_MAX; i++)
		{
			if (nOrder[i] < 0)
			{
				nOrder[i] = index;
				index++;
			}
		}
		static const LPCTSTR pszOrderName[SOUNDFILEVIEW_COLUMN_LABEL_MAX] =
		{
			TEXT("FileNameOrder"), TEXT("FilePathOrder"), TEXT("TitleOrder"), TEXT("ArtistOrder"),
			TEXT("AlbumOrder"), TEXT("DateOrder"), TEXT("TrackNumberOrder"), TEXT("GenreOrder"),
			TEXT("CommentOrder"), TEXT("PlayTimeOrder"), TEXT("NumberOrder"),
		};
		for (i = 0; i < SOUNDFILEVIEW_COLUMN_LABEL_MAX; i++)
		{
			WritePrivateProfileInt(pszField, pszOrderName[i], nOrder[i], g_szDestFileName);
		}
	}

	GetPrivateProfileString(pszField, TEXT("ColumFileName"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("FileNameLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnFilePath"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("FilePathLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnTitle"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("TitleLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnArtist"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("ArtistLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnAlbum"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("AlbumLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnDate"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("DateLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnTrack"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("TrackNumberLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnGenre"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("GenreLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnComment"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("CommentLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnPlayTime"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("PlayTimeLabel"), szReadBuf, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("ColumnNumber"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("NumberLabel"), szReadBuf, g_szDestFileName);
	}

	t = GetPrivateProfileInt(pszField, TEXT("TextColor"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("TextColorNormal"), t | 0xFF000000, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("BackColor1"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("BackColorOdd"), t | 0xFF000000, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("BackColor2"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("BackColorEven"), t | 0xFF000000, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("TextColorPlaying"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("TextColorPlaying"), t | 0xFF000000, g_szDestFileName);
	}
	t = GetPrivateProfileInt(pszField, TEXT("BackColorPlaying"), -1, pszFaceFileName);
	if (t >= 0)
	{
		WritePrivateProfileHex(pszField, TEXT("BackColorPlaying"), t | 0xFF000000, g_szDestFileName);
	}
	GetPrivateProfileString(pszField, TEXT("FontFace"), TEXT("lr SVbN"), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("FontFace"), szReadBuf, g_szDestFileName);
	}
	WritePrivateProfileString(pszField, TEXT("AlternateFontFace"), TEXT("lr SVbN"), g_szDestFileName);
	t = GetPrivateProfileInt(pszField, TEXT("FontSize"), -1, pszFaceFileName);
	if (t > 0)
	{
		WritePrivateProfileInt(pszField, TEXT("FontSize"), t, g_szDestFileName);
	}
	std::wstring stStyle;

	GetPrivateProfileString(pszField, TEXT("FontOption"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	{
		LPTSTR pszCur = szReadBuf;
		LPTSTR pContext = NULL;

		pszCur = _tcstok_s(pszCur, OPTION_DELIMITA, &pContext);
		while (pszCur)
		{
			if (_tcsicmp(pszCur, TEXT("BOLD")) == 0)
			{
				stStyle.append(L"Bold, ");
			}
			if (_tcsicmp(pszCur, TEXT("ITALIC")) == 0)
			{
				stStyle.append(L"Italic, ");
			}
			if (_tcsicmp(pszCur, TEXT("UNDERLINE")) == 0)
			{
				stStyle.append(L"Underline, ");
			}
			if (_tcsicmp(pszCur, TEXT("STRIKEOUT")) == 0)
			{
				stStyle.append(L"Strikeout, ");
			}
			if (_tcsicmp(pszCur, TEXT("EXTRABOLD")) == 0)
			{
				stStyle.append(L"Bold, ");
			}
			pszCur = _tcstok_s(NULL, OPTION_DELIMITA, &pContext);
		}
	}
	if (stStyle.size() > 0)
	{
#ifdef _UNICODE
		WritePrivateProfileString(pszField, TEXT("FontStyle"), stStyle.c_str(), g_szDestFileName);
#else
		int len = WideCharToMultiByte(CP_ACP, 0, stStyle.c_str(), -1, NULL, 0, NULL, NULL) + 1;
		LPSTR temp = (LPSTR) _malloca(len);
		WideCharToMultiByte(CP_ACP, 0, stStyle.c_str(), -1, temp, len, NULL, NULL);
		WritePrivateProfileString(pszField, TEXT("FontStyle"), temp, g_szDestFileName);
		_freea(temp);
#endif
	}

	return TRUE;
}

BOOL ConvertAnalyzer(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	__int64 flags = GetFlags(pszFaceFileName, pszField);
	if (flags & NVBUTTON_ANALYZER)
	{
		ConvertImageButton(pszFaceFileName, pszField);
		WritePrivateProfileString(pszField, TEXT("Category"), TEXT("DynamicImage"), g_szDestFileName);
		WritePrivateProfileString(pszField, TEXT("Type"), TEXT("SpectrumAnalyzer"), g_szDestFileName);
		int t = GetPrivateProfileInt(pszField, TEXT("Reduction"), -1, pszFaceFileName);
		if (t >= 0)
		{
			WritePrivateProfileInt(pszField, TEXT("Reduction"), t, g_szDestFileName);
		}

		if (! (flags & NVBUTTON_ACCUMULATIONEX))
		{
			_tprintf(TEXT("AccumulationEx ȊÕXyNgAiCÚAAccumulationEx ɕϊ܂B\n"));
		}
		return TRUE;
	}

	return FALSE;
}

