#include <windows.h>
#include <stdio.h>
#include <shlwapi.h>
#include <gdiplus.h>
#include <tchar.h>
#include <conio.h>
#include <string>
#include <xstring>
#include "..\\NVLibCore\\NVLibCore.h"


#pragma once


#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "gdiplus.lib")



#define READ_BUF_LEN 2048
#define LOADFACE_KEY_BUFSIZE 65535

#define NV_OPTIONMAX 37		//  IvV̎

#define NVBUTTON_IMAGE       0x01		//  C[W\
#define NVBUTTON_CAPTION     0x02		//  LvV\
#define NVBUTTON_TRANSPARENT 0x04		//  {^
#define NVBUTTON_ENABLE      0x08		//  ͂󂯕t{^
#define NVBUTTON_DEFAULTSIZE 0x10		//  C[W܂̓LvṼTCYɂ킹
#define NVBUTTON_PUSHBUTTON  0x20		//  \ȃ{^
#define NVBUTTON_BOLD        0x40		//  tHg𑾎ɂ
#define NVBUTTON_ITALIC      0x80		//  tHgΑ̂ɂ
#define NVBUTTON_UNDERLINE   0x100		//  tHgɉ
#define NVBUTTON_STRIKEOUT   0x200		//  tHgɎ
#define NVBUTTON_3DEDGE      0x400		//  C[WɂRc̃GbW
#define NVBUTTON_VCENTER 0x800			//  C[W𐂒Œ
#define NVBUTTON_TOP    0x1000			//  C[W
#define NVBUTTON_BOTTOM 0x2000			//  C[W
#define NVBUTTON_CENTER 0x4000			//  C[W𐅕Œ
#define NVBUTTON_LEFT   0x8000			//  C[W
#define NVBUTTON_RIGHT  0x10000			//  C[WE
#define NVBUTTON_EXTRABOLD 0x20000		//  tHgɑɂ
#define NVBUTTON_ALPHAENABLE 0x40000	//  \ɂ
#define NVBUTTON_COLORKEY    0x80000	//  J[L[
#define NVBUTTON_FADE        0x100000
#define NVBUTTON_SCROLL      0x200000
#define NVBUTTON_FORCESCROLL 0x400000
#define NVBUTTON_USETIPHINT  0x800000
#define NVBUTTON_TEXTLEFT    0x1000000
#define NVBUTTON_TEXTCENTER  0x2000000
#define NVBUTTON_TEXTRIGHT   0x4000000
#define NVBUTTON_CROSSFADE   0x8000000
#define NVBUTTON_ANALYZER     0x10000000
#define NVBUTTON_ACCUMULATION 0x20000000
#define NVBUTTON_ACCUMULATIONEX 0x40000000
#define NVBUTTON_ACTIVEONLY 0x80000000
#define NVBUTTON_INACTIVEONLY 0x100000000i64
#define NVBUTTON_VERTICAL 0x200000000i64
#define NVBUTTON_USEREGION 0x400000000i64
#define NVBUTTON_ANTIALIASTEXT 0x800000000i64
#define NVBUTTON_CLEARTYPETEXT 0x1000000000i64

enum
{
	BUTTON_SEEK, BUTTON_PLAY, BUTTON_STOP, BUTTON_REWIND, BUTTON_FORWARD,
	BUTTON_CLOSE, BUTTON_MINIMIZE, BUTTON_TITLE,
	BUTTON_SUSPEND, BUTTON_NORMAL, BUTTON_REPEAT, BUTTON_RANDOM,
	BUTTON_NEXT, BUTTON_BACK, BUTTON_INFO, BUTTON_OPEN,
	BUTTON_TOTALTIME, BUTTON_PLAYTIME, BUTTON_REMAINTIME,
	BUTTON_VOLUME, BUTTON_VOLUMEUP, BUTTON_VOLUMEDOWN,
	BUTTON_EQUALIZERON, BUTTON_EQUALIZEROFF, BUTTON_PLAYLIST,
	BUTTON_ALLREPEATON, BUTTON_ALLREPEATOFF,

	BUTTON_TAG_FILENAME, BUTTON_TAG_FILETYPE, BUTTON_TAG_BITRATE,
	BUTTON_TAG_BITS, BUTTON_TAG_SAMPLERATE, BUTTON_TAG_MODE,
	BUTTON_TAG_TITLE, BUTTON_TAG_ARTIST, BUTTON_TAG_ALBUM,
	BUTTON_TAG_DATE, BUTTON_TAG_TRACK, BUTTON_TAG_GENRE,
	BUTTON_TAG_COMMENT, BUTTON_TAG_VBR,

	BUTTON_LISTCOUNT, BUTTON_LISTCURRENT, BUTTON_LISTPLAYED, BUTTON_LISTPLAYTIME,
	BUTTON_LISTNUMBER,

	BUTTON_ANALYZER, BUTTON_VOLUMEBAR,
	BUTTON_NORMALCHANGE, BUTTON_CROSSFADECHANGE, BUTTON_NONSTOPCHANGE,
	BUTTON_ANALYZERON, BUTTON_ANALYZEROFF,
	BUTTON_RESUME, BUTTON_TOPMOSTON, BUTTON_TOPMOSTOFF,
	BUTTON_PANSLIDER, BUTTON_PANVALUE,
	BUTTON_TAG_FILEPATH, BUTTON_TAG_FILEEXT,
	NV_BUTTONMAX
};



//  {^̎ʎq
struct BUTTON_PARAM
{
	LPCTSTR pszCommand;
	LPCTSTR pszCommandParamType;
	LPCTSTR pszCommandParam;
	LPCTSTR pszTypeString;
	LPCTSTR pszViewTypeString;
	LPCTSTR pszCategory;
	LPCTSTR pszFormatString;
};

#define OPTION_DELIMITA TEXT(" \n\r\t,")

struct COMMAND_TABLE
{
	int nCommandId;
	LPCTSTR pszCommand;
	LPCTSTR pszCommandParamType;
	LPCTSTR pszCommandParam;
};
#define COMMAND_MAX 83


extern const TCHAR *lpszOptions[NV_OPTIONMAX];
extern const __int64 lpOptions[NV_OPTIONMAX];

extern const COMMAND_TABLE lpCommandTable[COMMAND_MAX];
extern const BUTTON_PARAM lpButtonParam[NV_BUTTONMAX];
extern const TCHAR *lpszButtonText[NV_BUTTONMAX];
extern const TCHAR *lpszButtonName[NV_BUTTONMAX];


BOOL ConvertBaseWindow(LPCTSTR pszFaceFileName);
Gdiplus::Bitmap *GetBaseImage(LPCTSTR pszFaceFileName);

BOOL ConvertImageButton(LPCTSTR pszFaceFileName, LPCTSTR pszField);
BOOL Draw3DEdge(Gdiplus::Graphics *gr, int nWidth, int nHeight, BOOL fPushed);

BOOL ConvertCaption(LPCTSTR pszFaceFileName, LPCTSTR pszField);
SIZE CalcStringSize(LPCTSTR pszFaceFileName, LPCTSTR pszField, int nOverridedHeight = -1, LPCTSTR pszTestString = NULL);
SIZE CalcStringSizeByGDI(LPCTSTR pszFaceFileName, LPCTSTR pszField, LPCTSTR pszTestString);

__int64 GetFlags(LPCTSTR pszFaceFileName, LPCTSTR pszField);

BOOL ConvertPredefinedField(LPCTSTR pszFaceFileName, LPCTSTR pszField);
int GetPredefinedFieldParam(LPCTSTR pszFaceFileName, LPCTSTR pszField);

BOOL ConvertDockingPlayList(LPCTSTR pszFaceFileName, LPCTSTR pszField);
BOOL ConvertAnalyzer(LPCTSTR pszFaceFileName, LPCTSTR pszField);

int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);
BOOL ConvertFolder(LPCTSTR pszSrcFolder);
BOOL ConvertFile(LPCTSTR pszFaceFileName);
BOOL ConvertSrcToDestFileName(LPTSTR pszFileName, int nLength);
BOOL ConvertTipHint(LPCTSTR pszFaceFileName, LPCTSTR pszField);
BOOL ConvertCommand(LPCTSTR pszFaceFileName, LPCTSTR pszField);
BOOL WritePrivateProfileRelativePath(LPCTSTR pszAppName, LPCTSTR pszKeyName, LPCTSTR pszPath, LPCTSTR pszIniFile);
