#pragma once

#define _USE_IPP_SCALE_

Gdiplus::Bitmap * WINAPI GetScaledBitmap(LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame);
IStream * WINAPI GetScaledBitmapStream(LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame);

typedef Gdiplus::Bitmap * (WINAPI * pfnGetScaledBitmap) (LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame);
typedef IStream * (WINAPI * pfnGetScaledBitmapStream) (LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame);


inline Gdiplus::Bitmap *GetScaledBitmap_DLL(LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame)
{
	static HMODULE hGLib = (HMODULE) INVALID_HANDLE_VALUE;
	static pfnGetScaledBitmap proc = NULL;
	if (hGLib == INVALID_HANDLE_VALUE)
	{
		hGLib = GetModuleHandle(TEXT("NVGLib.dll"));
		if (hGLib == INVALID_HANDLE_VALUE)
		{
			hGLib = NULL;
		}
		else if (hGLib)
		{
			proc = (pfnGetScaledBitmap) GetProcAddress(hGLib, "GetScaledBitmap");
		}
	}

	if (proc)
	{
		return proc(pszFileName, dwScale, psizFrame);
	}
	else
	{
		return NULL;
	}
}

inline IStream *GetScaledBitmapStream_DLL(LPCTSTR pszFileName, DWORD dwScale, SIZE *psizFrame)
{
	static HMODULE hGLib = (HMODULE) INVALID_HANDLE_VALUE;
	static pfnGetScaledBitmapStream proc = NULL;
	if (hGLib == INVALID_HANDLE_VALUE)
	{
		hGLib = GetModuleHandle(TEXT("NVGLib.dll"));
		if (hGLib == INVALID_HANDLE_VALUE)
		{
			hGLib = NULL;
		}
		else if (hGLib)
		{
			proc = (pfnGetScaledBitmapStream) GetProcAddress(hGLib, "GetScaledBitmapStream");
		}
	}

	if (proc)
	{
		return proc(pszFileName, dwScale, psizFrame);
	}
	else
	{
		return NULL;
	}
}