#include "..\\uLilith\\Plugin\\GenericPlugin.h"
#include <shlwapi.h>
#include "Resource.h"
#include <commctrl.h>
#include <process.h>

#include <string>
#include <xstring>

#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "gdiplus.lib")


#ifndef _tstring
#ifdef _UNICODE
#define _tstring std::wstring
#else
#define _tstring std::string
#endif
#endif

enum ShutdownMethod
{
	ShutdownDisable = 0,
	ShutdownAfterTime,
	ShutdownAtTime,
	ShutdownMax,
};
UINT g_uAfterTime = 600;
UINT g_uStartTime = 0;
UINT g_uShutdownTime = 0;
SYSTEMTIME g_AtTime;
ShutdownMethod g_Method = ShutdownDisable;
BOOL g_fIsForceTermination = FALSE;
HWND g_hwndApp = NULL;
HWND g_hwndProperty = NULL;
HWND g_hwndConfirm = NULL;
HANDLE g_hThread = NULL;
HANDLE g_hKillEvent = NULL;


extern "C"
{
	void WINAPI GetPluginInfo(GenericPlugin::GenericPluginInfo& info);
}

LPVOID WINAPI InitializePlugin(HWND hwndMain, const GenericPlugin::PluginCallbacks* callbacks);
void WINAPI UninitializePlugin(LPVOID lpvUserData);
HWND WINAPI ShowProperty(LPVOID lpvUserData, HWND hwndOwner);

static INT_PTR CALLBACK PropertyDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);

static void StartThread(void);
static void StopThread(void);
static unsigned int __stdcall ThreadProc(void *lpvParam);
static void MakeConfirm(void);
static INT_PTR CALLBACK ConfirmDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
static void DoShutdown(void);

GenericPlugin::GenericPluginInfo g_Info =
{
	0x200,
	TEXT("SampleShutdownTimer"),
	TEXT("Northern Verse (Project9k)"),
	TEXT("tFCX`vOC̃Tvł"),
	InitializePlugin,
	UninitializePlugin,
	ShowProperty,
	NULL,//OnFaceLoad,
	NULL,//OnFaceUnload,
	NULL,//OnSoundOpen,
	NULL,//OnSoundChange,
	NULL,//OnSoundClose,
	NULL,//OnUpdateVisual,
};

GenericPlugin::PluginCallbacks *g_callbacks = NULL;
HINSTANCE g_hThisInstance = NULL;

BOOL APIENTRY DllMain(HINSTANCE hThisInstance, DWORD dwNotification, LPVOID lpReserved)
{
	if (dwNotification == DLL_PROCESS_ATTACH)
	{
		g_hThisInstance = hThisInstance;
		DisableThreadLibraryCalls(hThisInstance);
		GetLocalTime(&g_AtTime);
	}
	else if (dwNotification == DLL_PROCESS_DETACH)
	{
	}

	return TRUE;
}



void WINAPI GetPluginInfo(GenericPlugin::GenericPluginInfo& info)
{
	info = g_Info;
}

LPVOID WINAPI InitializePlugin(HWND hwndMain, const GenericPlugin::PluginCallbacks* callbacks)
{
	g_hwndApp = hwndMain;
	g_callbacks = (GenericPlugin::PluginCallbacks *) callbacks;

	return NULL;
}

void WINAPI UninitializePlugin(LPVOID lpvUserData)
{
	StopThread();
}

HWND WINAPI ShowProperty(LPVOID lpvUserData, HWND hwndOwner)
{
	if (g_hwndProperty)
	{
		SetForegroundWindow(g_hwndProperty);
		return g_hwndProperty;
	}
	else
	{
		g_hwndProperty = CreateDialog(g_hThisInstance, MAKEINTRESOURCE(IDD_PROPERTY), hwndOwner, PropertyDialogProc);
		return g_hwndProperty;
	}
}

static INT_PTR CALLBACK PropertyDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch (uMessage)
	{
	case WM_INITDIALOG:
		{
			if (g_Method == ShutdownAfterTime)
			{
				SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_CHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_UNCHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_UNCHECKED, 0);
				EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), FALSE);
			}
			else if (g_Method == ShutdownAtTime)
			{
				SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_UNCHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_CHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_UNCHECKED, 0);
				EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), FALSE);
				EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), TRUE);
			}
			else// if (g_Method == ShutdownDisable)
			{
				SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_UNCHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_UNCHECKED, 0);
				SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_CHECKED, 0);
				EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), FALSE);
				EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), FALSE);
			}

			SetDlgItemInt(hwnd, IDC_AFTERTIME, g_uAfterTime, FALSE);
			{
				SYSTEMTIME sysTime;
				FILETIME curTime;
				FILETIME fileTime;

				GetLocalTime(&sysTime);
				SystemTimeToFileTime(&sysTime, &curTime);
				SystemTimeToFileTime(&g_AtTime, &fileTime);

				if (CompareFileTime(&curTime, &fileTime) >= 0)
				{
					*((__int64 *) &curTime) += 10i64 * 1000 * 1000 * 600;
					FileTimeToSystemTime(&curTime, &g_AtTime);
				}
			}
			DateTime_SetSystemtime(GetDlgItem(hwnd, IDC_ATTIME), GDT_VALID, &g_AtTime);
			SendDlgItemMessage(hwnd, IDC_FORCESHUTDOWN, BM_SETCHECK, (g_fIsForceTermination) ? BST_CHECKED : BST_UNCHECKED, 0);
			g_callbacks->RegisterDialog(hwnd);
			ShowWindow(hwnd, SW_SHOWNORMAL);
		}
		break;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDCANCEL:
				{
					DestroyWindow(hwnd);
				}
				break;
			case IDOK:
				{
					{
						BOOL fTrans = FALSE;

						UINT t = GetDlgItemInt(hwnd, IDC_AFTERTIME, &fTrans, FALSE);
						if (fTrans)
						{
							g_uAfterTime = t;
						}
					}
					{
						SYSTEMTIME sysTime;
						if (GDT_VALID == DateTime_GetSystemtime(GetDlgItem(hwnd, IDC_ATTIME), &sysTime))
						{
							g_AtTime = sysTime;
						}
					}
					if (SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_GETCHECK, 0, 0) == BST_CHECKED)
					{
						g_Method = ShutdownAfterTime;
						g_uStartTime = timeGetTime();
						g_uShutdownTime = g_uAfterTime * 1000;
						StartThread();
					}
					else if (SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_GETCHECK, 0, 0) == BST_CHECKED)
					{
						g_Method = ShutdownAtTime;
						SYSTEMTIME sysTime;
						FILETIME curTime;
						FILETIME endTime;
						GetLocalTime(&sysTime);
						SystemTimeToFileTime(&sysTime, &curTime);
						SystemTimeToFileTime(&g_AtTime, &endTime);
						*((__int64 *) &endTime) -= *((__int64 *) &curTime);
						g_uStartTime = timeGetTime();
						g_uShutdownTime = (UINT) (*((__int64 *) &endTime) / (10 * 1000));
						StartThread();
					}
					else// if (SendDlgItemMessage(hwnd, IDC_DISABLe, BM_GETCHECK, 0, 0) == BST_CHECKED)
					{
						g_Method = ShutdownDisable;
						StopThread();
					}

					g_fIsForceTermination = (SendDlgItemMessage(hwnd, IDC_FORCESHUTDOWN, BM_SETCHECK, 0, 0) == BST_CHECKED) ? TRUE : FALSE;
					DestroyWindow(hwnd);
				}
				break;
			case IDC_BYAFTERTIME:
				{
					SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_CHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_UNCHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_UNCHECKED, 0);
					EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), FALSE);
				}
				break;
			case IDC_BYATTIME:
				{
					SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_UNCHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_CHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_UNCHECKED, 0);
					EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), TRUE);
				}
				break;
			case IDC_DISABLE:
				{
					SendDlgItemMessage(hwnd, IDC_BYAFTERTIME, BM_SETCHECK, BST_UNCHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_BYATTIME, BM_SETCHECK, BST_UNCHECKED, 0);
					SendDlgItemMessage(hwnd, IDC_DISABLE, BM_SETCHECK, BST_CHECKED, 0);
					EnableWindow(GetDlgItem(hwnd, IDC_AFTERTIME), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_ATTIME), FALSE);
				}
				break;
			}
		}
		break;
	case WM_DESTROY:
		{
			g_callbacks->UnregisterDialog(hwnd);
			g_hwndProperty = NULL;
		}
		break;
	}

	return FALSE;
}

static void StartThread(void)
{
	if (g_hThread == NULL)
	{
		g_hKillEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
		if (g_hKillEvent == NULL || g_hKillEvent == INVALID_HANDLE_VALUE)
		{
			g_hKillEvent = NULL;
			return;
		}

		unsigned int id;
		g_hThread = (HANDLE) _beginthreadex(NULL, 0, ThreadProc, NULL, 0, &id);
		if (g_hThread == NULL || g_hThread == INVALID_HANDLE_VALUE)
		{
			CloseHandle(g_hKillEvent);
			g_hKillEvent = NULL;
			return;
		}
	}
}

static void StopThread(void)
{
	if (g_hThread)
	{
		SetEvent(g_hKillEvent);
		WaitForSingleObject(g_hThread, INFINITE);
		CloseHandle(g_hThread);
		g_hThread = NULL;
	}
	if (g_hKillEvent)
	{
		CloseHandle(g_hKillEvent);
		g_hKillEvent = NULL;
	}
}

static unsigned int __stdcall ThreadProc(void *lpvParam)
{
	MSG msg;

	PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE);

	for ( ; ; )
	{
		DWORD dwRet = MsgWaitForMultipleObjects(1, &g_hKillEvent, FALSE, 500, QS_ALLINPUT);
		if (dwRet == WAIT_OBJECT_0 + 1)
		{
			while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
			{
				if (! GetMessage(&msg, NULL, 0, 0))
				{
					return 0;
				}
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else if (dwRet != WAIT_TIMEOUT)
		{
			return 0;
		}

		if (g_Method == ShutdownAfterTime || g_Method == ShutdownAtTime)
		{
			UINT time = timeGetTime() - g_uStartTime;
			UINT rest = g_uShutdownTime - time;
			if (time > g_uShutdownTime)
			{
				DoShutdown();
				return 0;
			}
			else if (rest <= 30 * 1000)
			{
				MakeConfirm();
				TCHAR szText[256];
				_stprintf_s(szText, 256, TEXT("%u bɃVXeVbg_E܂B\nƂ𑱂ɂ́ALZ{^ĂB"), rest / 1000);
				SetDlgItemText(g_hwndConfirm, IDC_REMAINTIME, szText);
			}
		}
		else if (g_hwndConfirm)
		{
			DestroyWindow(g_hwndConfirm);
		}
		else
		{
			CloseHandle(g_hThread);
			CloseHandle(g_hKillEvent);
			g_hThread = NULL;
			g_hKillEvent = NULL;
			return 0;
		}
	}
}

static void MakeConfirm(void)
{
	if (! g_hwndConfirm)
	{
		g_hwndConfirm = CreateDialog(g_hThisInstance, MAKEINTRESOURCE(IDD_CONFIRM), g_hwndApp, ConfirmDialogProc);
	}
}

static INT_PTR CALLBACK ConfirmDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch (uMessage)
	{
	case WM_INITDIALOG:
		{
			UINT time = timeGetTime() - g_uStartTime;
			UINT rest = g_uShutdownTime - time;
			if (time > g_uShutdownTime)
			{
				rest = 0;
			}

			TCHAR szText[256];
			_stprintf_s(szText, 256, TEXT("%u bɃVXeVbg_E܂B\nƂ𑱂ɂ́ALZ{^ĂB"), rest / 1000);
			SetDlgItemText(hwnd, IDC_REMAINTIME, szText);
			g_callbacks->RegisterDialog(hwnd);
			ShowWindow(hwnd, SW_SHOWNORMAL);
		}
		break;
	case WM_DESTROY:
		{
			g_callbacks->UnregisterDialog(hwnd);
			g_hwndConfirm = NULL;
		}
		break;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDCANCEL:
				{
					g_Method = ShutdownDisable;
					DestroyWindow(hwnd);
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}

static void DoShutdown(void)
{
	//  fobOp
	// MessageBox(g_hwndApp, TEXT("Shutdown"), TEXT("Shutdown"), MB_OK | MB_TOPMOST);

	UINT uFlags = EWX_POWEROFF;
	if (g_fIsForceTermination)
	{
		uFlags |= EWX_FORCEIFHUNG;
	}

	HANDLE hToken;
	BOOL fShutdown = FALSE;

	if (OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
	{
		LUID luid;
		if (LookupPrivilegeValue(TEXT(""), SE_SHUTDOWN_NAME, &luid))
		{
			TOKEN_PRIVILEGES tp;

			ZeroMemory(&tp, sizeof(TOKEN_PRIVILEGES));
			tp.PrivilegeCount = 1;
			tp.Privileges[0].Luid = luid;
			tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

			if (AdjustTokenPrivileges(hToken, FALSE, &tp, NULL, NULL, NULL))
			{
				if (GetLastError() == ERROR_SUCCESS)
				{
					fShutdown = ExitWindowsEx(uFlags, 0);
				}
			}
		}
		CloseHandle(hToken);
	}

	if (fShutdown)
	{
		PostMessage(g_hwndApp, WM_CLOSE, 0, 0);
	}
	else
	{
		MessageBox(g_hwndApp, TEXT("ȂƂŃVbg_EoȂłB"), TEXT("Vbg_EG["), MB_OK | MB_TOPMOST | MB_ICONASTERISK);
	}
}
