#include "..\\NVLibCore\\NVLibCore.h"
#include "..\\NVAFLib\\NVAFLib.h"
#include "..\\NVFileLib\\NVFileLib.h"
#include "..\\NVWave\\NVWave.h"

#include <stdio.h>
#include <conio.h>
#include <locale.h>

#define NO_WRITE
#define NO_PRINT
#define USE_FULLBUFFER
#define USE_ENCODER_SETTINGS
#define WRITE_FLOAT64

//#define WRITE_FOURCC NVPCMENC_FOURCC

_tstring SrcFormat;
QLONG qlMaxFileBufferSize;

INVAUDIOFILE PlayList_CreateInterface(LPCTSTR lpcszFileName, DWORD dwFlag, LONG lBitsPerSample);
static NVRESULT NVBufferFile(INVSTREAM invst, QLONG qlMaxFileBufferSize, LPINVSTREAM lpinvstNew);
static NVRESULT WINAPI VSSEncProgress(LPCVOID lpvProgressParam, QWORD qwTotalProgress);

struct VSSENCPARAM
{
	NVAUDIOFILEINFO nvafInfo;
	DWORD dwStartTime;
	QWORD qwWriteTotal;
};

int _tmain(int argc, TCHAR *argv[])
{
	SetConsoleCtrlHandler(NULL, TRUE);
	_tsetlocale(LC_ALL, TEXT("japanese"));
	NVRESULT nvres;
	INVAUDIOFILE invaf = NULL;
	TCHAR lpszSrc[NV_PATHMAX];
	TCHAR lpszDest[NV_PATHMAX];
	VSSENCPARAM param;
	INVSTREAM invstDest = NULL;
	IVSSMANAGER ivsm = NULL; 
	IVSSENCODER ivsse = NULL;
	VSSENCENTRY * lpEntry = NULL;
	NVAUDIOFILECOMMENT * lpnvafc = NULL;
	DWORD dwWriteFourCC = NVPCMENC_FOURCC;
	int cs = -1;
	LPVOID lpvEncParam = NULL;
	timeBeginPeriod(1);

	if (argc > 1)
	{
		_tcscpy_s(lpszSrc, NV_PATHMAX, argv[1]);
	}
	else
	{
		_tprintf(TEXT("\nfR[ht@C͂ĂB\n"));
		_getts_s(lpszSrc, NV_PATHMAX);
	}


	{
		MEMORYSTATUSEX st;
		ZeroMemory(&st, sizeof(MEMORYSTATUSEX));
		st.dwLength = sizeof(MEMORYSTATUSEX);
		GlobalMemoryStatusEx(&st);
		if (st.ullTotalPhys > 0)
		{
			st.ullTotalPhys /= 1024 * 2;
		}
		else
		{
			st.ullTotalPhys = 32 * 1024 / 2;
		}
		qlMaxFileBufferSize = min(st.ullTotalPhys, SSIZE_T_MAX);
	}

	try
	{
		VSSMANAGERCREATE vsmc;
		VSSENCODERCREATE vssec;

#ifdef WRITE_FLOAT64
		invaf = PlayList_CreateInterface(lpszSrc, 0, -64);
#else
		invaf = PlayList_CreateInterface(lpszSrc, 0, 0);
#endif
		if (! invaf)
		{
			throw NVERR_UNDEFINED;
		}

		DWORD dwSize = 0;
		nvres = invaf->GetComment(NVAUDIOFILE_FOURCC, NULL, &dwSize);
		if (nvres == NV_OK && dwSize > 0)
		{
			lpnvafc = (LPNVAUDIOFILECOMMENT) NVMemAlloc(NVMEM_FIXED, dwSize);
			nvres = invaf->GetComment(NVAUDIOFILE_FOURCC, lpnvafc, &dwSize);
			if (nvres)
			{
				throw nvres;
			}
		}

		dwSize = sizeof(NVAUDIOFILEINFO);
		nvres = invaf->GetInfo(NVAUDIOFILE_FOURCC, &param.nvafInfo, &dwSize);
		if (nvres)
		{
			throw nvres;
		}

		nvres = VCreateInstance(VSSMANAGER_FOURCC, VSSMANAGER_FOURCC, (LPVOID *) &ivsm);
		if (nvres)
		{
			throw nvres;
		}

		SetVSSManagerCreate(&vsmc, 0);
		nvres = ivsm->Create(&vsmc);
		if (nvres)
		{
			throw nvres;
		}

		DWORD dwEntryCount = 0;

		nvres = ivsm->EncEnumPlugin(NULL, &dwEntryCount);
		if (nvres)
		{
			throw nvres;
		}

		if (dwEntryCount == 0)
		{
			throw NVERR_UNDEFINED;
		}

		lpEntry = new VSSENCENTRY[dwEntryCount];
		nvres = ivsm->EncEnumPlugin(lpEntry, &dwEntryCount);
		if (nvres)
		{
			throw nvres;
		}

		DWORD i;
		{

			while (cs < 0 && cs < (LONG) dwEntryCount)
			{
				_tprintf(TEXT("o͐tH[}bg̑I\n"));
				for (i = 0; i < dwEntryCount; i++)
				{
#if 1
					_tprintf(TEXT("%d : %s\n"), i, lpEntry[i].SupportedFileType.c_str());
#else
					TCHAR szFourCC[5];
					NVFourCCToString(lpEntry[i].dwFourCC, szFourCC, 5);
					_tprintf(TEXT("%d : %s\n"), i, szFourCC);
#endif
				}
				cs = _getch();
				if (cs == 0x1B)
				{
					//  ESC ŏI
					throw NV_OK;
				}
				cs -= '0';
			}
		}

		if (cs >= (LONG) dwEntryCount)
		{
			throw NVERR_UNDEFINED;
		}
		_tcscpy_s(lpszDest, NV_PATHMAX, lpszSrc);
		_tcscat_s(lpszDest, TEXT("."));
		_tcscat_s(lpszDest, lpEntry[cs].DefaultExtension.c_str());
		dwWriteFourCC =lpEntry[cs].dwFourCC;

#ifdef USE_ENCODER_SETTINGS
		{
			//   ݒ_CAO\Ă݂
			MSG msg;
			HWND hwnd = ivsm->EncConfigDialog(dwWriteFourCC, NULL, NULL, &lpvEncParam);
			while (IsWindow(hwnd))
			{
				if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
				{
					if (! GetMessage(&msg, NULL, 0, 0))
					{
						break;
					}

					if (NVIsDialogMessage(&msg))
					{
						continue;
					}

					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
				else
				{
					WaitMessage();
				}
			}
		}
#endif
		delete [] lpEntry;
		lpEntry = NULL;

		nvres = ivsm->EncCreateInstance(dwWriteFourCC, VSSENCODER_FOURCC, (LPVOID *) &ivsse);
		if (nvres)
		{
			throw nvres;
		}

#ifdef NO_WRITE
		nvres = VCreateInstance(NVSTREAM_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invstDest);
		if (nvres)
		{
			throw nvres;
		}
#else
		nvres = VCreateInstance(NVFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invstDest);
		if (nvres)
		{
			throw nvres;
		}
#endif
		NVSTREAMCREATE nvstc;
		SetNVStreamCreate(&nvstc, NVSTREAM_OPENWRITE, lpszDest);
		nvres = invstDest->Create(&nvstc);
#ifndef NO_WRITE
		if (nvres)
		{
			throw nvres;
		}
#endif
#ifdef NO_PRINT
		SetVSSEncoderCreate(&vssec, 0, invaf, invstDest, lpvEncParam, lpnvafc, NULL, NULL);
#else
		SetVSSEncoderCreate(&vssec, 0, invaf, invstDest, lpvEncParam, lpnvafc, VSSEncProgress, &param);
#endif
		nvres = ivsse->Create(&vssec);
		lpvEncParam = NULL;
		if (nvres)
		{
			throw nvres;
		}
		invaf = NULL;
		invstDest = NULL;
		lpnvafc = NULL;

		_tprintf(TEXT("\n\n%s\n"), lpszSrc);
		_tprintf(TEXT("       \n"));
		_tprintf(TEXT("       _^\n"));
		_tprintf(TEXT("%s\n\n"), lpszDest);
		
		param.dwStartTime = timeGetTime();
		
		_tprintf(TEXT("\n\n"));

		nvres = ivsse->ProcessData();
		if (nvres)
		{
			throw nvres;
		}

		DWORD dwEndTime;
		dwEndTime = timeGetTime() - param.dwStartTime;
		_tprintf(TEXT("\n\n%s\nfR[h %d  %d b %d\n"), SrcFormat.c_str(), dwEndTime / 1000 / 60, (dwEndTime / 1000) % 60, dwEndTime % 1000);
		_tprintf(TEXT("%I64u oCg^b  %3I64u p[Zg\n"), param.qwWriteTotal * 1000 / dwEndTime, param.dwStartTime * 100 / param.nvafInfo.quPlayTime.qw);
		_tprintf(TEXT("Đ     : %I64u ms\nϊ     : %d ms\nĐԔ   : %.3f {\nbot   : %.3f  \n"),
			param.nvafInfo.quPlayTime.qw, dwEndTime, ((DOUBLE) param.nvafInfo.quPlayTime.qw) / dwEndTime,
			((DOUBLE) dwEndTime) * 100 / param.nvafInfo.quPlayTime.qw);
		_tprintf(TEXT("\nL[ĂB\n"));
		_getch();

		ivsse->Release();
		ivsse = NULL;
		ivsm->Release();
		ivsm = NULL;
	}
	catch (NVRESULT nvres)
	{
		if (invstDest)
		{
			invstDest->Release();
		}
		if (ivsse)
		{
			ivsse->Release();
		}
		if (ivsm)
		{
			if (lpvEncParam)
			{
				ivsm->EncFreeParam(dwWriteFourCC, lpvEncParam);
			}
			ivsm->Release();
		}
		if (invaf)
		{
			invaf->Release();
		}
		if (lpnvafc)
		{
			NVMemFree(lpnvafc);
		}

		if (nvres)
		{
			_tprintf(TEXT("\n\nG[܂B\nG[R[hF%08X\n"), nvres);
			_getch();
		}
		else
		{
			_tprintf(TEXT("\n\nvO𒆒f܂B\n"));
		}

		timeEndPeriod(1);
		return nvres;
	}

	timeEndPeriod(1);
	return 0;
}

INVAUDIOFILE PlayList_CreateInterface(LPCTSTR lpcszFileName, DWORD dwFlag, LONG lBitsPerSample)
{
	IVSSMANAGER ivsm = NULL; 
	INVSTREAM invst = NULL;
	INVAUDIOFILE invaf = NULL;
	NVRESULT nvres;

	//  Xg[AL INVAUDIOFILE C^[tF[X擾āAOpenAudioFile Ɉp

	try
	{
		{
			VSSMANAGERCREATE vsmc;

			nvres = VCreateInstance(VSSMANAGER_FOURCC, VSSMANAGER_FOURCC, (LPVOID *) &ivsm);
			if (nvres)
			{
				throw nvres;
			}

			SetVSSManagerCreate(&vsmc, 0);
			nvres = ivsm->Create(&vsmc);
			if (nvres)
			{
				throw nvres;
			}
		}

		{
			INVSTREAM invstNew = NULL;
			NVSTREAMCREATE nvstc;

			nvres = VCreateInstance(NVFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invst);
			if (nvres)
			{
				throw nvres;
			}

			SetNVStreamCreate(&nvstc, NVSTREAM_OPENREAD, lpcszFileName);
			nvres = invst->Create(&nvstc);
			if (nvres)
			{
				throw nvres;
			}
#ifdef USE_FULLBUFFER
			nvres = NVBufferFile(invst, qlMaxFileBufferSize, &invstNew);
			invst = (invstNew) ? invstNew : invst;
#endif
		}

		{
			//  ǉvOC ̏
			{
				DWORD dwFourCC;
				nvres = ivsm->DecGetFileTypeFourCCByStream(invst, &dwFourCC);

				if (nvres == NV_OK && dwFourCC)
				{
					nvres = ivsm->DecCreateInstance(dwFourCC, NVAUDIOFILE_FOURCC, (LPVOID *) &invaf);

					if (nvres)
					{
						throw nvres;
					}
				}
				else
				{
					throw VAFERR_UNSUPPORTED;
				}

				NVAUDIOFILECREATE nvafc;
				//  NVAUDIOFILECREATE 
				nvafc.dwFourCC = NVAUDIOFILE_FOURCC;
				nvafc.dwObjSize = sizeof(NVAUDIOFILECREATE);
				nvafc.dwFlag = NVAUDIOFILE_OPENSTREAM;
				nvafc.invst = invst;
				nvafc.lBitsPerSample = lBitsPerSample;

				//  INVAUDIOFILE 
				nvres = invaf->Create(&nvafc);
				invst = NULL;
				if (nvres)
				{
					throw nvres;
				}

				{
					DWORD i;
					DWORD dwCount;
					LPVSSDECENTRY lpInfo;
					DWORD dwSrcFourCC = invaf->GetFourCC();

					ivsm->DecEnumPlugin(NULL, &dwCount);
					lpInfo = new VSSDECENTRY[dwCount];
					ivsm->DecEnumPlugin(lpInfo, &dwCount);

					for (i = 0; i < dwCount; i++)
					{
						if (lpInfo[i].dwFourCC == dwSrcFourCC)
						{
							SrcFormat = lpInfo[i].SupportedFileType;
							break;
						}
					}
					if (i >= dwCount)
					{
						SrcFormat = TEXT("Unknown");
					}
					delete [] lpInfo;
				}
				ivsm->Release();
				return invaf;
			}
		}
	}
	catch (NVRESULT)
	{
		if (invaf)
		{
			invaf->Release();
		}

		if (invst)
		{
			invst->Release();
		}

		if (ivsm)
		{
			ivsm->Release();
		}
		return NULL;
	}

	//  ɔĂÅ֐m INVAUDIOFILE ł́AΉĂȂƂ
	//  G[
	if (invaf)
	{
		invaf->Release();
	}

	if (invst)
	{
		invst->Release();
	}

	return NULL;
}

static NVRESULT NVBufferFile(INVSTREAM invst, QLONG qlMaxFileBufferSize, LPINVSTREAM lpinvstNew)
{
	NVRESULT nvres;
	INVSTREAM invstNew = NULL;
	QWUNION quCurrent;

	invst->GetCurrentPosition(&quCurrent.ql, NVSTREAM_SEEKBEGIN);

	try
	{
		if (qlMaxFileBufferSize > 0)
		{
			QWUNION quFileSize;
			nvres = invst->GetDataSize(&quFileSize.qw);
			if (nvres)
			{
				throw nvres;
			}

			if (quFileSize.ql < qlMaxFileBufferSize * 1024)
			{
				{
					NVMEMFILECREATE nvmfc;
					TCHAR lpszDataName[NV_PATHMAX];

					nvres = invst->GetDataName(lpszDataName, NV_PATHMAX);
					if (nvres)
					{
						throw nvres;
					}
					SetNVMemFileCreate(&nvmfc, NVMEMFILE_OPENWRITE, lpszDataName, NULL, 0, 0, quFileSize.ql);
					nvres = VCreateInstance(NVMEMFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invstNew);
					if (nvres)
					{
						throw nvres;
					}

					nvres = invstNew->Create(&nvmfc);
					if (nvres)
					{
						throw nvres;
					}

					nvres = invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
					if (nvres)
					{
						throw nvres;
					}
				}

				{
					BYTE lpBuf[65536];
#ifdef	NVSOUND_LOG_ENABLE
					{
						TCHAR lpsz[1024];
						_stprintf_s(lpsz, 1024, TEXT("Try Buffering File %I64u bytes.\n"), quFileSize.qw);
						NVOutputDebugLog(lpsz);
					}
#endif
					while (quFileSize.dwLow)
					{
						DWORD dwRead;
						DWORD dwWrite;

						nvres = invst->Read(lpBuf, min(quFileSize.dwLow, 65536), &dwRead);
						if (dwRead)
						{
							nvres = invstNew->Write(lpBuf, dwRead, &dwWrite);
							if (nvres)
							{
								throw nvres;
							}
							else
							{
								quFileSize.dwLow -= dwWrite;
							}
						}
						else
						{
							throw NVERR_UNDEFINED;
						}
					}
				}
			}
		}
	}
	catch (NVRESULT nvres)
	{
		if (invstNew)
		{
			invstNew->Release();
		}
		invst->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
		*lpinvstNew = NULL;
#ifdef	NVSOUND_LOG_ENABLE
		{
			NVOutputDebugLog(TEXT("Buffering File Failed.\n"));
		}
#endif
		return nvres;
	}

	if (invstNew)
	{
#ifdef	NVSOUND_LOG_ENABLE
		{
			NVOutputDebugLog(TEXT("End Buffering File.\n"));
		}
#endif
		invstNew->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
		invstNew->ChangeOpenMode(NVSTREAM_OPENREAD);

		*lpinvstNew = invstNew;
	}
	else
	{
#ifdef	NVSOUND_LOG_ENABLE
		{
			NVOutputDebugLog(TEXT("Cancel Buffering File.\n"));
		}
#endif
		invst->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);

		*lpinvstNew = NULL;
	}
	return NV_OK;
}


static NVRESULT WINAPI VSSEncProgress(LPCVOID lpvProgressParam, QWORD qwTotalProgress)
{
	const VSSENCPARAM * param = (const VSSENCPARAM *) lpvProgressParam;
	double t = qwTotalProgress * 100.0 / param->nvafInfo.quDecodedSize.qw;
	DWORD dw = (DWORD) (param->nvafInfo.quPlayTime.qw * t / 100.0);
	_tprintf(TEXT("%.2f p[ZgI    %02d : %02d . %02d\r"), t, dw / 60000,  (dw / 1000) % 60, dw % 1000);

	if (GetAsyncKeyState(VK_ESCAPE) & 0x1)
	{
		return NVERR_UNDEFINED;
	}
	return NV_OK;
}