//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile Wrapper W[ \[Xt@C  for  NVAudioFileLibrary                        //
//  NVAFWrap.cpp                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAFWrap.h"



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_NVAFWrap(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVAFWrap;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVAFWrap
//



Class_NVAFWrap::Class_NVAFWrap(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVAFWrap), NVAFWRAP_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVAFWrap::~Class_NVAFWrap(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVAFWrap::Create(LPCVOID lpvParam)
{
//  CX^X̏

	LPCNVAFWRAPCREATE lpcnvafwc = (LPCNVAFWRAPCREATE) lpvParam;
	QLONG qlStartOffset;

	if (lpcnvafwc->dwFourCC != NVAFWRAP_FOURCC)
	{
		return VAFERR_INVALIDPARAM;
	}
	else if (lpcnvafwc->dwObjSize != sizeof(NVAFWRAPCREATE))
	{
		return VAFERR_INVALIDPARAM;
	}
	else if (! VIsValidInterface(lpcnvafwc->invaf))
	{
		return VAFERR_INVALIDPARAM;
	}

	if (lpcnvafwc->qlStartOffset < 0)
	{
		if (lpcnvafwc->qlStartOffset < -1)
		{
			return VAFERR_INVALIDPARAM;
		}
		qlStartOffset = 0;
	}
	else
	{
		qlStartOffset = lpcnvafwc->qlStartOffset;
	}

	{
		NVRESULT nvres;
		NVAUDIOFILEINFO nvafInfo;
		DWORD dwSize = sizeof(NVAUDIOFILEINFO);
		nvres = lpcnvafwc->invaf->GetInfo(NVAUDIOFILE_FOURCC, &nvafInfo, &dwSize);
		if (nvres)
		{
			return nvres;
		}

		LONG lSampleAlign = nvafInfo.dwBitsPerSample * nvafInfo.dwMode / 8;

		if (qlStartOffset * lSampleAlign >= nvafInfo.quDecodedSize.ql)
		{
			return VAFERR_INVALIDPARAM;
		}

		if (lpcnvafwc->qlSampleCount < 0)
		{
			nvafwd.qlDataSize = nvafInfo.quDecodedSize.ql - qlStartOffset * lSampleAlign;
		}
		else
		{
			if ((qlStartOffset + lpcnvafwc->qlSampleCount) * lSampleAlign > nvafInfo.quDecodedSize.ql)
			{
				nvafwd.qlDataSize = nvafInfo.quDecodedSize.ql - qlStartOffset * lSampleAlign;
				//return VAFERR_INVALIDPARAM;
			}
			else
			{
				nvafwd.qlDataSize = lpcnvafwc->qlSampleCount * lSampleAlign;
			}
		}

		{
			QWUNION quStart;
			QWUNION quActual;

			quStart.ql = qlStartOffset * lSampleAlign;
			nvres = lpcnvafwc->invaf->SetCurrentPosition(quStart, NVAUDIOFILE_SEEKBEGIN);
			if (nvres)
			{
				return nvres;
			}
			nvres = lpcnvafwc->invaf->GetCurrentPosition(&quActual, NVAUDIOFILE_SEEKBEGIN);
			if (nvres)
			{
				return nvres;
			}
			nvafwd.qlStartOffset = quActual.ql;
		}

		nvafwd.lSampleAlign = lSampleAlign;
		nvafwd.dwSamplerate = nvafInfo.dwSamplerate;
		if (lpcnvafwc->lpReplayGain)
		{
			nvafwd.ReplayGain = *(lpcnvafwc->lpReplayGain);
		}
		else
		{
			ClearReplayGainInfo(&nvafwd.ReplayGain);
		}
	}

	nvafwd.invaf = lpcnvafwc->invaf;
	nvafwd.qlCurrent = 0;
	vcd.bIsCreated = TRUE;
	nvafd.lpnvafcm = lpcnvafwc->lpnvafcm;

	return NV_OK;
}


NVRESULT Class_NVAFWrap::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg

	if (nvafwd.invaf)
	{
		nvafwd.invaf->Release();
	}
	ZeroMemory(&nvafwd, sizeof(NVAFWRAPDATA));
	//  eNX ResetData Ɉp
	return Class_NVAudioFile::ResetData();
}


NVRESULT Class_NVAFWrap::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVAFWRAP_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVAFWRAP) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVAudioFile::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVAFWrap::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVAFWRAP_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVAudioFile::AddInterface(0);
}


NVRESULT Class_NVAFWrap::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVAudioFile::DeleteInterface();
}


NVRESULT Class_NVAFWrap::GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  tH[}bgƎ̊g擾

	if (nvafwd.invaf)
	{
		NVRESULT nvres;

		if (dwFourCC == REPLAYGAININFO_FOURCC && nvafwd.ReplayGain.dwFlag)
		{
			if (lpvInfo)
			{
				//  obt@w肳Ăꍇ̏
				
				//  obt@̃TCY`FbN
				if (*lpdwSize >= sizeof(REPLAYGAININFO))
				{
					//  obt@\΁ARs[
					CopyMemory(lpvInfo, &nvafwd.ReplayGain, sizeof(REPLAYGAININFO));
					*lpdwSize = sizeof(REPLAYGAININFO);
					return NV_OK;
				}
				else
				{
					//  Ȃ΁AKvȃTCYԂ
					*lpdwSize = sizeof(REPLAYGAININFO);
					return VAFERR_BUFFERTOOSMALL;
				}
			}
			
			//  obt@w肳ĂȂ΁ATCY̖₢킹
			//  KvȃTCYԂ
			
			*lpdwSize = sizeof(REPLAYGAININFO);
			return NV_OK;
		}
		else if (dwFourCC == NVAFWRAP_FOURCC)
		{
			if (lpvInfo)
			{
				if (*lpdwSize >= sizeof(NVAFWRAP_INFO))
				{
					NVAFWRAP_INFO *p = (NVAFWRAP_INFO *) lpvInfo;

					p->dwFourCC = NVAFWRAP_FOURCC;
					p->dwObjSize = sizeof(NVAFWRAP_INFO);
					p->qlStartOffset = nvafwd.qlStartOffset / nvafwd.lSampleAlign;
					p->qlSampleCount = nvafwd.qlDataSize / nvafwd.lSampleAlign;
				}
				else
				{
					*lpdwSize = sizeof(NVAFWRAP_INFO);
					return VAFERR_BUFFERTOOSMALL;
				}
			}

			*lpdwSize = sizeof(NVAFWRAP_INFO);
			return NV_OK;
		}
		else
		{
			nvres = nvafwd.invaf->GetInfo(dwFourCC, lpvInfo, lpdwSize);
			if (nvres)
			{
				return nvres;
			}

			if (dwFourCC == NVAUDIOFILE_FOURCC)
			{
				if (*lpdwSize >= FIELDOFFSET(NVAUDIOFILEINFO, quDecodedSize) + 8)
				{
					((LPNVAUDIOFILEINFO)lpvInfo)->quDecodedSize.ql = nvafwd.qlDataSize;
				}
				if (*lpdwSize >= FIELDOFFSET(NVAUDIOFILEINFO, quPlayTime) + 8)
				{
					((LPNVAUDIOFILEINFO)lpvInfo)->quPlayTime.ql = nvafwd.qlDataSize * 1000 / (((LPNVAUDIOFILEINFO)lpvInfo)->dwSamplerate * nvafwd.lSampleAlign);
				}
			}
		}

		return NV_OK;
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}


NVRESULT Class_NVAFWrap::GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  ȖȂǂ̃Rg擾

	return Class_NVAudioFile::GetComment(dwFourCC, lpvInfo, lpdwSize);
}


NVRESULT Class_NVAFWrap::GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf)
{
//  fR[hf[^̃tH[}bg擾

	if (nvafwd.invaf)
	{
		return nvafwd.invaf->GetPCMWaveFormat(lppcmwf);
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}


NVRESULT Class_NVAFWrap::DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize)
{
//  f[^fR[hA󂯎

	NVRESULT nvres = NVERR_VALUE_UNDEFINED;

	*lplResultSize = 0;

	if (nvafwd.invaf)
	{
		lBufferSize = (LONG) min(lBufferSize, nvafwd.qlDataSize - nvafwd.qlCurrent);
		if (lBufferSize > 0)
		{
			nvres = nvafwd.invaf->DecodeToPCMData(lpBuffer, lBufferSize, lplResultSize);
			nvafwd.qlCurrent += *lplResultSize;
		}
		if (nvafwd.qlCurrent >= nvafwd.qlDataSize)
		{
			return VAFERR_ENDOFDATA;
		}
		else
		{
			if (nvres == VAFERR_VALUE_ENDOFDATA)
			{
				nvafwd.qlDataSize = nvafwd.qlCurrent;
			}
			return nvres;
		}
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}

NVRESULT Class_NVAFWrap::Rewind(void)
{
//  f[^擪܂Ŋ߂

	NVRESULT nvres;

	if (nvafwd.invaf)
	{
		QWUNION quSetPos;

		quSetPos.ql = nvafwd.qlStartOffset;
		nvres = nvafwd.invaf->SetCurrentPosition(quSetPos, NVAUDIOFILE_SEEKBEGIN);
		if (nvres)
		{
			return nvres;
		}
		nvafwd.qlCurrent = 0;

		return NV_OK;
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}

NVRESULT Class_NVAFWrap::FileInfoDialog(HWND hwnd)
{
//  t@C̃_CAO\

	if (nvafwd.invaf)
	{
		return nvafwd.invaf->FileInfoDialog(hwnd);
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}

NVRESULT Class_NVAFWrap::GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag)
{
	NVRESULT nvres;

	if (nvafwd.invaf)
	{
		nvres = nvafwd.invaf->GetCurrentPosition(lpquPosition, dwFlag);
		if (nvres)
		{
			return nvres;
		}

		lpquPosition->ql -= nvafwd.qlStartOffset;

		return NV_OK;
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}


NVRESULT Class_NVAFWrap::SetCurrentPosition(QWUNION quPosition, DWORD dwFlag)
{
	NVRESULT nvres;

	if (nvafwd.invaf)
	{
		QWUNION quSetPos;

		quSetPos.ql = quPosition.ql + nvafwd.qlStartOffset;
		nvres = nvafwd.invaf->SetCurrentPosition(quSetPos, dwFlag);
		if (nvres)
		{
			return nvres;
		}
		nvres = nvafwd.invaf->GetCurrentPosition(&quSetPos, dwFlag);
		if (nvres)
		{
			return nvres;
		}
		nvafwd.qlCurrent = quSetPos.ql - nvafwd.qlStartOffset;

		return NV_OK;
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}


NVRESULT Class_NVAFWrap::ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples)
{
//  QƎ(}CNbP)Tv֕ϊ
	if (nvafwd.invaf)
	{
		return nvafwd.invaf->ReferenceTimeToSamples(quReferenceTime, lpquSamples);
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}


NVRESULT Class_NVAFWrap::SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime)
{
//  TvQƎ(}CNbP)֕ϊ
	if (nvafwd.invaf)
	{
		return nvafwd.invaf->SamplesToReferenceTime(quSamples, lpquReferenceTime);
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}

NVRESULT Class_NVAFWrap::GetReferenceTime(LPQWUNION lpquReferenceTime)
{
	//  ݂̎QƎ(}CNbP)擾
	if (nvafwd.invaf)
	{
		NVRESULT nvres;

		nvres = nvafwd.invaf->GetReferenceTime(lpquReferenceTime);
		if (nvres)
		{
			return nvres;
		}
		lpquReferenceTime->ql -= NVMulDiv64(nvafwd.qlStartOffset, 1000 * 1000, nvafwd.dwSamplerate * nvafwd.lSampleAlign);
		return NV_OK;
	}
	else
	{
		return VAFERR_NOCREATE;
	}
}

NVRESULT Class_NVAFWrap::GetTotalTime(LPQWUNION lpquTotalTime)
{
	//  }CNbPʂőSĐԂ擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquTotalTime->ql = NVMulDiv64(nvafwd.qlDataSize, 1000 * 1000, nvafwd.dwSamplerate * nvafwd.lSampleAlign);
	return NV_OK;
}

NVRESULT Class_NVAFWrap::ReInitialize(QLONG qlStartOffset, QLONG qlSampleCount, LPNVAUDIOFILECOMMENT lpnvafcm, LPREPLAYGAININFO lpReplayGain)
{
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	if (qlStartOffset < 0)
	{
		if (qlStartOffset < -1)
		{
			return VAFERR_INVALIDPARAM;
		}
		qlStartOffset = 0;
	}

	{
		NVRESULT nvres;
		NVAUDIOFILEINFO nvafInfo;
		DWORD dwSize = sizeof(NVAUDIOFILEINFO);
		nvres = nvafwd.invaf->GetInfo(NVAUDIOFILE_FOURCC, &nvafInfo, &dwSize);
		if (nvres)
		{
			return nvres;
		}

		LONG lSampleAlign = nvafInfo.dwBitsPerSample * nvafInfo.dwMode / 8;

		if (qlStartOffset * lSampleAlign >= nvafInfo.quDecodedSize.ql)
		{
			return VAFERR_INVALIDPARAM;
		}

		if (qlSampleCount < 0)
		{
			nvafwd.qlDataSize = nvafInfo.quDecodedSize.ql - qlStartOffset * lSampleAlign;
		}
		else
		{
			if ((qlStartOffset + qlSampleCount) * lSampleAlign > nvafInfo.quDecodedSize.ql)
			{
				nvafwd.qlDataSize = nvafInfo.quDecodedSize.ql - qlStartOffset * lSampleAlign;
				//return VAFERR_INVALIDPARAM;
			}
			else
			{
				nvafwd.qlDataSize = qlSampleCount * lSampleAlign;
			}
		}

		{
			QWUNION quStart;
			QWUNION quActual;

			quStart.ql = qlStartOffset * lSampleAlign;
			nvres = nvafwd.invaf->SetCurrentPosition(quStart, NVAUDIOFILE_SEEKBEGIN);
			if (nvres)
			{
				return nvres;
			}
			nvres = nvafwd.invaf->GetCurrentPosition(&quActual, NVAUDIOFILE_SEEKBEGIN);
			if (nvres)
			{
				return nvres;
			}
			nvafwd.qlStartOffset = quActual.ql;
		}

		nvafwd.lSampleAlign = lSampleAlign;
		nvafwd.dwSamplerate = nvafInfo.dwSamplerate;
		if (lpReplayGain)
		{
			nvafwd.ReplayGain = *lpReplayGain;
		}
		else
		{
			ClearReplayGainInfo(&nvafwd.ReplayGain);
		}
	}

	nvafwd.qlCurrent = 0;
	if (nvafd.lpnvafcm)
	{
		NVMemFree(nvafd.lpnvafcm);
	}
	nvafd.lpnvafcm = lpnvafcm;

	return NV_OK;
}
