//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile Decompression W[ wb_[t@C  for  NVAudioFileLibrary                //
//  NVAudioFile.h                                                                               //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAFLibDef.h"
#include "..\\NVFileLib\\NVFileLib.h"
#include <mbstring.h>


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//


//  I[fBIt@CI[v[htO
#define NVAUDIOFILE_OPENFILE  0x01		//  t@CI[v
#define NVAUDIOFILE_OPENSTREAM 0x02		//  Xg[I[v

//  I[fBIt@CfR[htO
//#define NVAUDIOFILE_USEEQUALIZER 0x10		//  p~
//#define NVAUDIOFILE_USEASYNCDECODE  0x20	//  p~
//#define NVAUDIOFILE_USEDITHER 0x40		//  p~	//  \Ȃ΁AfBUOgp
#define NVAUDIOFILE_GETINFOONLY 0x80	//  擾pɍɃI[vAfR[hp̏Ȃǂ͍sȂ

#define NVAUDIOFILE_DISABLEDEEMPHASIS  0x10000000

//  tO
#define NVAUDIOFILE_CALCREALDECODESIZE 0x80000000		//  fR[hTCY𐳊mɌvZ

//  V[NptO
#define NVAUDIOFILE_SEEKBEGIN   0x01	//  擪̃ItZbgŎw肷
#define NVAUDIOFILE_SEEKCURRENT 0x02	//  ݈ʒũItZbgŎw肷
#define NVAUDIOFILE_SEEKEND     0x04	//  I[̃ItZbgŎw肷

//  CRCŨf[^
//#define NVAUDIOFILE_EQUALIZERMAX 18		//  p~

//  dBlWvZ}N  dB 1000{lwB
#define NVCalcCOEFFromDB(db) (pow(10, ((DOUBLE) (db)) / (20.0 * 1000)))

//  WdBltZ}N  dB 1000{lŕԂBȂ݂ɁAWɂOȉnƃG[ɂȂ̂Œ
#define NVCalcDBFromCOEF(coef) ((LONG) (log10((DOUBLE) (coef)) * 20 * 1000))

//#define NVAUDIOFILE_DITHERLEVEL16  (0.75 / 0x1FFFFF)				//  p~
//#define NVAUDIOFILE_DITHERLEVEL32  ((0.75 / 0x1FFFFF) / 0x1FFFFF)	//  p~


#ifndef SPEAKER_FRONT_LEFT
// Speaker Positions:
#define SPEAKER_FRONT_LEFT              0x1
#define SPEAKER_FRONT_RIGHT             0x2
#define SPEAKER_FRONT_CENTER            0x4
#define SPEAKER_LOW_FREQUENCY           0x8
#define SPEAKER_BACK_LEFT               0x10
#define SPEAKER_BACK_RIGHT              0x20
#define SPEAKER_FRONT_LEFT_OF_CENTER    0x40
#define SPEAKER_FRONT_RIGHT_OF_CENTER   0x80
#define SPEAKER_BACK_CENTER             0x100
#define SPEAKER_SIDE_LEFT               0x200
#define SPEAKER_SIDE_RIGHT              0x400
#define SPEAKER_TOP_CENTER              0x800
#define SPEAKER_TOP_FRONT_LEFT          0x1000
#define SPEAKER_TOP_FRONT_CENTER        0x2000
#define SPEAKER_TOP_FRONT_RIGHT         0x4000
#define SPEAKER_TOP_BACK_LEFT           0x8000
#define SPEAKER_TOP_BACK_CENTER         0x10000
#define SPEAKER_TOP_BACK_RIGHT          0x20000
#endif

#ifndef DEFINE_GUIDEX
#if !defined(_NTRTL_)
    #ifndef DEFINE_GUIDEX
        #define DEFINE_GUIDEX(name) EXTERN_C const CDECL GUID name
    #endif // !defined(DEFINE_GUIDEX)

    #ifndef STATICGUIDOF
        #define STATICGUIDOF(guid) STATIC_##guid
    #endif // !defined(STATICGUIDOF)
#endif // !defined(_NTRTL_)

#if defined(__cplusplus) && _MSC_VER >= 1100
#define DEFINE_GUIDSTRUCT(g, n) struct __declspec(uuid(g)) n
#define DEFINE_GUIDNAMED(n) __uuidof(struct n)
#else // !defined(__cplusplus)
#define DEFINE_GUIDSTRUCT(g, n) DEFINE_GUIDEX(n)
#define DEFINE_GUIDNAMED(n) n
#endif // !defined(__cplusplus)
#endif

#ifndef STATIC_KSDATAFORMAT_SUBTYPE_WAVEFORMATEX
#define STATIC_KSDATAFORMAT_SUBTYPE_WAVEFORMATEX\
    0x00000000L, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71
DEFINE_GUIDSTRUCT("00000000-0000-0010-8000-00aa00389b71", KSDATAFORMAT_SUBTYPE_WAVEFORMATEX);
#define KSDATAFORMAT_SUBTYPE_WAVEFORMATEX DEFINE_GUIDNAMED(KSDATAFORMAT_SUBTYPE_WAVEFORMATEX)
#endif

#ifndef STATIC_KSDATAFORMAT_SUBTYPE_PCM
#define STATIC_KSDATAFORMAT_SUBTYPE_PCM\
    DEFINE_WAVEFORMATEX_GUID(WAVE_FORMAT_PCM)
DEFINE_GUIDSTRUCT("00000001-0000-0010-8000-00aa00389b71", KSDATAFORMAT_SUBTYPE_PCM);
#define KSDATAFORMAT_SUBTYPE_PCM DEFINE_GUIDNAMED(KSDATAFORMAT_SUBTYPE_PCM)
#endif

#ifndef STATIC_KSDATAFORMAT_SUBTYPE_IEEE_FLOAT
#define STATIC_KSDATAFORMAT_SUBTYPE_IEEE_FLOAT\
    DEFINE_WAVEFORMATEX_GUID(WAVE_FORMAT_IEEE_FLOAT)
DEFINE_GUIDSTRUCT("00000003-0000-0010-8000-00aa00389b71", KSDATAFORMAT_SUBTYPE_IEEE_FLOAT);
#define KSDATAFORMAT_SUBTYPE_IEEE_FLOAT DEFINE_GUIDNAMED(KSDATAFORMAT_SUBTYPE_IEEE_FLOAT)
#endif


#define NVAUDIOFILE_CHANNEL_MAX 9
static const DWORD NVAudioFile_ChannelMask[NVAUDIOFILE_CHANNEL_MAX] =	//  }``l̂Ƃ̃Xs[Jzu
{
	0,
	SPEAKER_FRONT_CENTER,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_LOW_FREQUENCY | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT | SPEAKER_FRONT_LEFT_OF_CENTER | SPEAKER_FRONT_RIGHT_OF_CENTER,
	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_LOW_FREQUENCY | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT | SPEAKER_FRONT_LEFT_OF_CENTER | SPEAKER_FRONT_RIGHT_OF_CENTER,
//	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT | SPEAKER_SIDE_LEFT | SPEAKER_SIDE_RIGHT,
//	SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT | SPEAKER_FRONT_CENTER | SPEAKER_LOW_FREQUENCY | SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT | SPEAKER_SIDE_LEFT | SPEAKER_SIDE_RIGHT,
};

//  WDMAudiohCopWAVEFORAMTEXTENSIBLE̒`Ƃ
#ifndef _WAVEFORMATEXTENSIBLE_
#define _WAVEFORMATEXTENSIBLE_
typedef struct {
    WAVEFORMATEX    Format;
    union {
        WORD wValidBitsPerSample;       /* bits of precision  */
        WORD wSamplesPerBlock;          /* valid if wBitsPerSample==0 */
        WORD wReserved;                 /* If neither applies, set to zero. */
    } Samples;
    DWORD           dwChannelMask;      /* which channels are */
                                        /* present in stream  */
    GUID            SubFormat;
} WAVEFORMATEXTENSIBLE, *PWAVEFORMATEXTENSIBLE;
#endif // !_WAVEFORMATEXTENSIBLE_

#if !defined(WAVE_FORMAT_EXTENSIBLE)
#define  WAVE_FORMAT_EXTENSIBLE                 0xFFFE
#endif // !defined(WAVE_FORMAT_EXTENSIBLE)

//
//  Extended PCM waveform format structure based on WAVEFORMATEXTENSIBLE.
//  Use this for multiple channel and hi-resolution PCM data
//
typedef WAVEFORMATEXTENSIBLE    WAVEFORMATPCMEX; /* Format.cbSize = 22 */
typedef WAVEFORMATPCMEX       *PWAVEFORMATPCMEX;
typedef WAVEFORMATPCMEX NEAR *NPWAVEFORMATPCMEX;
typedef WAVEFORMATPCMEX FAR  *LPWAVEFORMATPCMEX;

#if !defined(WAVE_FORMAT_DOLBY_AC3_SPDIF)
#define  WAVE_FORMAT_DOLBY_AC3_SPDIF            0x0092 /* Sonic Foundry */
#endif
#if !defined(WAVE_FORMAT_DTS)
#define  WAVE_FORMAT_DTS                        0x0008 /* Microsoft Corporation */
#endif

#if !defined(WAVE_FORMAT_EX_GUID)
#define INIT_WAVEFORMATEX_GUID(Guid, x)\
{\
    *(Guid) = KSDATAFORMAT_SUBTYPE_WAVEFORMATEX;\
    (Guid)->Data1 = (USHORT)(x);\
}
#endif


//  PCMWAVEFORMAT(Kvł)WAVEFORMATEXTENSIBLEɕϊ֐
inline NVRESULT NVAudioFile_PCMWaveFormatToWaveFormatPCMEx(LPPCMWAVEFORMAT lpSrc, LPWAVEFORMATPCMEX lpDest, BOOL bMME = FALSE);
inline NVRESULT NVAudioFile_PCMWaveFormatToWaveFormatPCMEx(LPPCMWAVEFORMAT lpSrc, LPWAVEFORMATPCMEX lpDest, BOOL bMME)
{
	if (lpSrc->wf.wFormatTag == WAVE_FORMAT_PCM || lpSrc->wf.wFormatTag == WAVE_FORMAT_IEEE_FLOAT)
	{
		if ((! bMME) && ((lpSrc->wf.nChannels > 2) || (lpSrc->wBitsPerSample > 16)))
		{
			//  }``l܂̓nC][V̏ꍇɂEXTENSIBLEg
			lpDest->Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
			lpDest->Format.cbSize = sizeof(WAVEFORMATPCMEX) - sizeof(WAVEFORMATEX);
		}
		else
		{
			//  ȊO͒ʏPCMWAVEFORMATŏ\
			lpDest->Format.wFormatTag = lpSrc->wf.wFormatTag;//WAVE_FORMAT_PCM;
			lpDest->Format.cbSize = 0;
		}
		lpDest->Format.nChannels = lpSrc->wf.nChannels;
		lpDest->Format.nSamplesPerSec = lpSrc->wf.nSamplesPerSec;
		lpDest->Format.wBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->Format.nBlockAlign = (lpSrc->wBitsPerSample >> 3) * lpSrc->wf.nChannels;
		lpDest->Format.nAvgBytesPerSec = lpSrc->wf.nSamplesPerSec * lpDest->Format.nBlockAlign;
		lpDest->Samples.wValidBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->dwChannelMask = (lpSrc->wf.nChannels < NVAUDIOFILE_CHANNEL_MAX) ? NVAudioFile_ChannelMask[lpSrc->wf.nChannels] : 0;
		if (lpSrc->wf.wFormatTag == WAVE_FORMAT_IEEE_FLOAT)
		{
			lpDest->SubFormat = KSDATAFORMAT_SUBTYPE_IEEE_FLOAT;
		}
		else
		{
			lpDest->SubFormat = KSDATAFORMAT_SUBTYPE_PCM;
		}
	}
	else if (lpSrc->wf.wFormatTag == WAVE_FORMAT_DOLBY_AC3_SPDIF)
	{
		if (bMME)
		{
			lpDest->Format.wFormatTag = WAVE_FORMAT_DOLBY_AC3_SPDIF;
			lpDest->Format.cbSize = 0;
		}
		else
		{
			lpDest->Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
			lpDest->Format.cbSize = sizeof(WAVEFORMATEXTENSIBLE) - sizeof(WAVEFORMATEX);
		}

		lpDest->Format.nChannels = lpSrc->wf.nChannels;
		lpDest->Format.nSamplesPerSec = lpSrc->wf.nSamplesPerSec;
		lpDest->Format.wBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->Format.nBlockAlign = (lpSrc->wBitsPerSample >> 3) * lpSrc->wf.nChannels;
		lpDest->Format.nAvgBytesPerSec = lpSrc->wf.nSamplesPerSec * lpDest->Format.nBlockAlign;
		lpDest->Samples.wValidBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->dwChannelMask = 0;
		//lpDest->SubFormat = KSDATAFORMAT_SUBTYPE_AC3_SPDIF;
		INIT_WAVEFORMATEX_GUID(&lpDest->SubFormat, WAVE_FORMAT_DOLBY_AC3_SPDIF);
	}
	else if (lpSrc->wf.wFormatTag == WAVE_FORMAT_DTS)
	{
		if (bMME)
		{
			lpDest->Format.wFormatTag = WAVE_FORMAT_DTS;
			lpDest->Format.cbSize = 0;
		}
		else
		{
			lpDest->Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
			lpDest->Format.cbSize = sizeof(WAVEFORMATEXTENSIBLE) - sizeof(WAVEFORMATEX);
		}

		lpDest->Format.nChannels = lpSrc->wf.nChannels;
		lpDest->Format.nSamplesPerSec = lpSrc->wf.nSamplesPerSec;
		lpDest->Format.wBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->Format.nBlockAlign = (lpSrc->wBitsPerSample >> 3) * lpSrc->wf.nChannels;
		lpDest->Format.nAvgBytesPerSec = lpSrc->wf.nSamplesPerSec * lpDest->Format.nBlockAlign;
		lpDest->Samples.wValidBitsPerSample = lpSrc->wBitsPerSample;
		lpDest->dwChannelMask = 0;
		//lpDest->SubFormat = KSDATAFORMAT_SUBTYPE_DTS;
		INIT_WAVEFORMATEX_GUID(&lpDest->SubFormat, WAVE_FORMAT_DTS);
	}
	else if (lpSrc->wf.wFormatTag == WAVE_FORMAT_EXTENSIBLE)
	{
		CopyMemory(lpDest, lpSrc, sizeof(WAVEFORMATEXTENSIBLE));
	}
	else
	{
		CopyMemory(lpDest, lpSrc, sizeof(PCMWAVEFORMAT));
		lpDest->Format.cbSize = 0;
		return NVERR_UNDEFINED;
	}

	return NV_OK;
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//


//  NVAudioFileW̃TEh
//
//  efR[_œƎ̏ꍇɂ́AoCi݊Ŋĝ𗘗p̂]܂

#define NVAUDIOFILEINFO_FORMATSTRING_MAX (128)
#define NVAUDIOFILEINFO_MODESTRING_MAX (64)
struct NVAUDIOFILEINFO		//  nvafInfo
{
	DWORD dwFourCC;					//  NXʎq(=NVAUDIOFILE_FOURCC)
	DWORD dwObjSize;				//  IuWFNgTCY
	TCHAR lpszDataName[NV_PATHMAX];	//  \[Xt@C
	DWORD dwFileType;				//  t@C^Cv(fR[_CX^XFourCC)
	QWUNION quDataSize;				//  ǂݍ݃f[^TCY
	QWUNION quDecodedSize;			//  fR[h̃f[^TCY
	DWORD dwBitsPerSample;			//  ʎqrbg
	DWORD dwSamplerate;				//  TvOg
	DWORD dwMode;					//  XeI[h
	DWORD dwBitrate;				//  rbg[g
	QWUNION quPlayTime;				//  Đ
	DWORD dwFlag;					//  VBRƂ tO
	TCHAR lpszFormatString[NVAUDIOFILEINFO_FORMATSTRING_MAX];	//  tH[}bg̖
	TCHAR lpszModeString[NVAUDIOFILEINFO_MODESTRING_MAX];		//  XeI[h̖
};
typedef NVAUDIOFILEINFO * LPNVAUDIOFILEINFO;
typedef const NVAUDIOFILEINFO * LPCNVAUDIOFILEINFO;

//  NVAUDIOFILEINFÕtO
#define NVAUDIOFILE_FLAG_VBR 0x01	//  VBRł(RĂȂCBR)
#define NVAUDIOFILE_FLAG_FLOAT 0x02	//  o̓TvFloat`ł



//  NVAudioFileW̃Rg
//
//  szString̒g͎R`ł悢A
//  (LPTSTR) &NVAUDIOFILECOMMENT::szString[NVAUDIOFILEFOMMENT::lOffsetArtist]ŃA[eBXg
//  (LPTSTR) &NVAUDIOFILECOMMENT::szString[NVAUDIOFILEFOMMENT::lOffsetArtist]Ń^Cg
//  Ƃ悤ɁATEXT('\0')ŏI镶QƂł悤ɓeZbgB
//  unionLPTSTR`Ă̂́AxQƂꍇɃItZbgAhXɕϊĎgp邱Ƃz肵̂łA
//  fR[_͏&szString[0]̃ItZbgŊi[悤ɂB
//  YRg񂪂Ȃꍇ́A̕(擪TEXT('\0')̕)QƂ悤ɐݒ肷B
struct NVAUDIOFILECOMMENT
{
	DWORD dwFourCC;		//  NXʎq(=NVAUDIOFILE_FOURCC)
	DWORD dwObjSize;	//  IuWFNgTCY(ȂƂsizeof(NVAUDIOFILECOMMENT)ȏ̒lɂȂ͂)
	union
	{
		LPTSTR lpszArtist;
		LONG lOffsetArtist;	//  A[eBXg̃ItZbg
	};
	union
	{
		LPTSTR lpszTitle;
		LONG lOffsetTitle;	//  ^Cg̃ItZbg
	};
	union
	{
		LPTSTR lpszAlbum;
		LONG lOffsetAlbum;	//  AõItZbg
	};
	union
	{
		LPTSTR lpszDate;
		LONG lOffsetDate;	//  t̃ItZbg
	};
	union
	{
		LPTSTR lpszTrackNumber;
		LONG lOffsetTrackNumber;	//  gbNԍ̃ItZbg
	};
	union
	{
		LPTSTR lpszGenre;
		LONG lOffsetGenre;	//  W̃ItZbg
	};
	union
	{
		LPTSTR lpszComment;
		LONG lOffsetComment;	//  Rg̃ItZbg
	};

	TCHAR szString[1];	//  ۂ̕f[^i[obt@
};

typedef NVAUDIOFILECOMMENT * LPNVAUDIOFILECOMMENT;
typedef const NVAUDIOFILECOMMENT * LPCNVAUDIOFILECOMMENT;

#define FIELD_REPLAYGAIN_TRACK_GAINA "replaygain_track_gain"
#define FIELD_REPLAYGAIN_TRACK_PEAKA "replaygain_track_peak"
#define FIELD_REPLAYGAIN_ALBUM_GAINA "replaygain_album_gain"
#define FIELD_REPLAYGAIN_ALBUM_PEAKA "replaygain_album_peak"

#define FIELD_REPLAYGAIN_TRACK_GAINW L"replaygain_track_gain"
#define FIELD_REPLAYGAIN_TRACK_PEAKW L"replaygain_track_peak"
#define FIELD_REPLAYGAIN_ALBUM_GAINW L"replaygain_album_gain"
#define FIELD_REPLAYGAIN_ALBUM_PEAKW L"replaygain_album_peak"

#ifdef _UNICODE
#define FIELD_REPLAYGAIN_TRACK_GAIN FIELD_REPLAYGAIN_TRACK_GAINW
#define FIELD_REPLAYGAIN_TRACK_PEAK FIELD_REPLAYGAIN_TRACK_PEAKW
#define FIELD_REPLAYGAIN_ALBUM_GAIN FIELD_REPLAYGAIN_ALBUM_GAINW
#define FIELD_REPLAYGAIN_ALBUM_PEAK FIELD_REPLAYGAIN_ALBUM_PEAKW
#else
#define FIELD_REPLAYGAIN_TRACK_GAIN FIELD_REPLAYGAIN_TRACK_GAINA
#define FIELD_REPLAYGAIN_TRACK_PEAK FIELD_REPLAYGAIN_TRACK_PEAKA
#define FIELD_REPLAYGAIN_ALBUM_GAIN FIELD_REPLAYGAIN_ALBUM_GAINA
#define FIELD_REPLAYGAIN_ALBUM_PEAK FIELD_REPLAYGAIN_ALBUM_PEAKA
#endif

#define REPLAYGAIN_TRACK_GAIN 0x01
#define REPLAYGAIN_TRACK_PEAK 0x02
#define REPLAYGAIN_ALBUM_GAIN 0x04
#define REPLAYGAIN_ALBUM_PEAK 0x08

#define REPLAYGAININFO_FOURCC MAKEFOURCC('R', 'P', 'G', 'I')

struct REPLAYGAININFO
{
	DWORD dwFourCC;
	DWORD dwObjSize;
	DWORD dwFlag;
	DOUBLE dTrackGain;
	DOUBLE dTrackPeak;
	DOUBLE dAlbumGain;
	DOUBLE dAlbumPeak;
};
typedef REPLAYGAININFO * LPREPLAYGAININFO;
typedef const REPLAYGAININFO * LPCREPLAYGAININFO;

static inline void ClearReplayGainInfo(LPREPLAYGAININFO lpInfo)
{
	lpInfo->dwFourCC = REPLAYGAININFO_FOURCC;
	lpInfo->dwObjSize = sizeof(REPLAYGAININFO);
	lpInfo->dwFlag = 0;
	lpInfo->dTrackGain = 0.0;
	lpInfo->dTrackPeak = 0.0;
	lpInfo->dAlbumGain = 0.0;
	lpInfo->dAlbumPeak = 0.0;
}

static inline void CombineReplayGainInfo(LPREPLAYGAININFO lpDest, LPREPLAYGAININFO lpSrc)
{
	lpDest->dTrackGain = (lpDest->dwFlag & REPLAYGAIN_TRACK_GAIN) ? lpDest->dTrackGain : lpSrc->dTrackGain;
	lpDest->dTrackPeak = (lpDest->dwFlag & REPLAYGAIN_TRACK_PEAK) ? lpDest->dTrackPeak : lpSrc->dTrackPeak;
	lpDest->dAlbumGain = (lpDest->dwFlag & REPLAYGAIN_ALBUM_GAIN) ? lpDest->dAlbumGain : lpSrc->dAlbumGain;
	lpDest->dAlbumPeak = (lpDest->dwFlag & REPLAYGAIN_ALBUM_PEAK) ? lpDest->dAlbumPeak : lpSrc->dAlbumPeak;
	lpDest->dwFlag = lpDest->dwFlag | lpSrc->dwFlag;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  INVAUDIOFILE
//


//  NXʎq
#define NVAUDIOFILE_FOURCC MAKEFOURCC('V', 'A', 'F', 'C')


/*  INVAUDIOFILE NXWXg (VCOM.ini ւ̋Lq)
[VAFC]

Class_ID = "VAFC"
Module_Name = "NVAFLib.dll"
Entry_Point = "CreateInstance_NVAudioFile"
*/


class Class_NVAudioFile;
typedef Class_NVAudioFile * INVAUDIOFILE;
typedef const Class_NVAudioFile * CINVAUDIOFILE;
typedef INVAUDIOFILE * LPINVAUDIOFILE;
typedef const INVAUDIOFILE * LPCINVAUDIOFILE;


//  INVAUDIOFILE ̏f[^
struct NVAUDIOFILECREATE		//  nvafc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO
	union
	{
		LPCTSTR lpcszDataName;	//  I[vt@C
		INVSTREAM invst;		//  I[vXg[
	};
	LONG lBitsPerSample;		//  o͗ʎqrbg̎w(0̓ftHg)
//	LPDOUBLE lpdEqualizer;		//  CRCUf[^ (p~)
};
typedef NVAUDIOFILECREATE * LPNVAUDIOFILECREATE;
typedef const NVAUDIOFILECREATE * LPCNVAUDIOFILECREATE;


//  INVAUDIOFILE ̕ێf[^
struct NVAUDIOFILEDATA		//  nvafd
{
	LPNVAUDIOFILECOMMENT lpnvafcm;
};
typedef NVAUDIOFILEDATA * LPNVAUDIOFILEDATA;
typedef const NVAUDIOFILEDATA * LPCNVAUDIOFILEDATA;



class NVAFLIB_CLASS_EXPORT Class_NVAudioFile : virtual public Class_VCOM
{
	public:
		Class_NVAudioFile(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVAudioFile(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  tH[}bgƎ̊g擾
		//
		//  DWORD dwFourCC			̌`NXʎq
		//  LPVOID@lpvInfo			󂯎obt@
		//  LPDWORD@lpdwSize		obt@̃TCY
		//
		//  tH[}bgƂɒ߂ꂽgԂB
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  NVAudioFileC^[tF[XW̏ƂāA
		//  NVAudioFileInfo`̂ŁAɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  ȖȂǂ̃Rg擾
		//
		//  DWORD dwFourCC		󂯎\̂̎ʎq
		//  LPVOID lpvInfo		󂯎obt@(\)̃|C^
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  W̌`ƂāANVAudioFileComment`̂ŁA
		//  ɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf);
		//  fR[hf[^̃tH[}bg擾
		//
		//  LPPCMWAVEFORMAT lppcmwf		󂯎obt@
		//
		//  PCMWAVEFORMAT `ŁAfR[hĂf[^̌`擾B
		//  PCMWAVEFORMAT::wf.wFormatTaǵAWAVE_FORMAT_PCM܂WAVE_FORMAT_IEEE_FLOAT݂̂T|[g

	VCOM_CLASSMETHOD
		NVRESULT DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize);
		//  f[^fR[hA󂯎
		//
		//  LPVOID lpBuffer			fR[hꂽf[^󂯎obt@
		//  LONG lBufferSize		擾f[^̗
		//  LPLONG lplResultSize	ۂɎ擾ꂽf[^̗
		//
		//  f[^fR[hāAPCM `Ŏ󂯎B̃tH[}bǵAGetPCMWaveFormat Ŏ擾łtH[}bgɊÂĂB
		//  NV_OK Ԃꍇ́AKvTCỸf[^擾ĂB
		//  VAFERR_VALUE_ENDOFDATA ̏ꍇAۂɎ擾ꂽf[^̗ʂ́AlplResultSize ɕԂB
		//  ̌ĂяóAKVAFERR_VALUE_ENDOFDATA ɂȂB
		//  f[^ɃG[̂́A񕜂łꍇɂ́AVAFERR_VALUE_ERRORRECOVEREDԂB
		//	̏ꍇ́AfR[h͂̂܂ܑsłB
		//  ȊÕG[Ԃꍇ́AfR[h𑱂邱Ƃ͂łȂB
		//  f[^̈ꕔłɏꂽꍇ́AlplResultSize ɎۂɎ擾ꂽf[^̗ʂԂĂB

	VCOM_CLASSMETHOD
		NVRESULT Rewind(void);
		//  f[^擪܂Ŋ߂
		//
		//  ʓIɂSetCurrentPosition(0, NVAUDIOFILE_SEEKBEGIN)ƓA
		//  tH[}bgɂĂ͐擪ւ̃V[N͍ɍs邽ߕʓrp
		//  p~ĂǂȁccH

	VCOM_CLASSMETHOD
		NVRESULT FileInfoDialog(HWND hwnd);
		//  t@C̃_CAO\
		//
		//  HWND hwnd		eEBhẼnh
		//
		//  t@C̏Rg[hX_CAO\B
		//  ɍ쐬ς݂̏ꍇɂ́AQdɕ\Ȃ悤ɒ
		//  ܂AAddRef() Release()gāA
		//  \ɃfR[_N[YĂvȂ悤ɂĂKvB
		//  _CAÓANVRegisterDialog()NVUnRegisterDialog()ŁA
		//  bZ[W[vłƏ悤ɂKvB

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŎ擾
		//
		//  LPQWUNION lpquPosition	擾錻݈ʒũItZbg
		//  DWORD dwFlag			ItZbg̊ʒu

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QWUNION quPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŐݒ
		//
		//  QWUNION quPosition	ݒ肷錻݈ʒũItZbg
		//  DWORD dwFlag		ItZbg̊ʒu
		//
		//  \ȌoCgPʂł̃V[Ns悤ɂׂA
		//  ݂Lilithł́Ǎ덷ĂvȂɂȂĂB
		//  bp[vOCȂǁÃfR[_TvPʂmsPʂł
		//  V[NsȂɂ́A̒PʂɊۂ߂Ă\ȂB
		//  ÂƂthLgɖL̂S邱ƁB

	VCOM_CLASSMETHOD
		NVRESULT ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples);
		//  QƎ(}CNbP)Tv֕ϊ
		//
		//  QWUNION quReferenceTime		QƎ(}CNbP)
		//  LPQWUNION lpquSamples		Tv
	VCOM_CLASSMETHOD
		NVRESULT SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime);
		//  TvQƎ(}CNbP)֕ϊ
		//
		//  QWUNION quSamples			Tv
		//  LPQWUNION lpquReferenceTime	QƎ(}CNbP)
	VCOM_CLASSMETHOD
		NVRESULT GetReferenceTime(LPQWUNION lpquReferenceTime);
		//  ݂̎QƎ(}CNbP)擾
		//
		//  LPQWUNION lpquReferenceTime		QƎ(}CNbP)

	VCOM_CLASSMETHOD
		NVRESULT GetTotalTime(LPQWUNION lpquTotalTime);
		//  }CNbPʂőSĐԂ擾
		//
		//  LPQWUNION lpquTotalTime		SĐ(}CNbP)

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B
protected:
	NVAUDIOFILEDATA nvafd;

};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_NVAudioFile(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVAUDIOFILE CX^X쐬ÃC^[tF[XԂ


inline void SetNVAudioFileCreate(LPNVAUDIOFILECREATE lpnvafc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample = 0);
//  NVAUDIOFILECREATE \̏֐
//
//  LPNVAUDIOFILECREATE lpnvafc		\
//  DWORD dwFlag					ZbgtO
//  LPCTSTR lpcszDataName			I[vt@CA܂̓Xg[̃C^[tF[X

inline LPNVAUDIOFILECOMMENT NVAFBuildComment(LPCTSTR lpcszArtist, LPCTSTR lpcszTitle, LPCTSTR lpcszAlbum, LPCTSTR lpcszDate,
											 LPCTSTR lpcszTrackNumber, LPCTSTR lpcszGenre, LPCTSTR lpcszComment);
//  NVAUDIOFILECOMMENT 쐬wp[֐
//
//  ^ꂽɁANVMemAlloc()֐ŃAP[VāA
//  NVAUDIOFILECOMMENT`̃f[^ԂB
//  gIAKNVMemFree()Ń邱ƁB
//  ׂċ̏̕ꍇANVAUDIOFILECOMMENT쐬̂ŁANULLԂ邱Ƃ͂ȂB

inline LPNVAUDIOFILECOMMENT NVAudioFile_GetSIF(INVSTREAM invst, LPCTSTR lpcszTrack = NULL);
//  RIFFSIFǂݍރwp[֐
//
//  INVSTREAM͂ƂāARIFFSIFǂ݁ANVAUDIOFILECOMMENT`ŕԂB
//  NVMemAlloc()ŃAP[VŕԂ̂ŁAgINVMemFree()ŉ邱ƁB
//  lStartOffsetȍ~̂݌̂ŁALIST`NÕItZbgw肷邱ƁB
//  SIFɂ͖{gbNԍ̂ŁAlpcszTrackŃgbNԍ^邱Ƃ\B
//  NVLibrarẙgL[ƂăgbNԍi[Ă邱Ƃ̂ŁA
//  SIFɂ𔭌ꍇ́AD悷悤ɂȂĂB
//  SIFłȂꍇANULLԂ悤ɂȂĂB

inline NVRESULT NVAudioFile_WriteSIF(INVSTREAM invst, LPCNVAUDIOFILECOMMENT lpnvafc);
//  RIFFSIFރwp[֐
//
//  INVSTREAM݈̌ʒuARIFFSIFށB
//  NVAUDIOFILECOMMENTɋ̕񂪂ꍇɂ́AɂĂ͊i[ȂB
//  ׂċłꍇɂ́ASIF̍쐬sȂB

inline void NVReplaceString(LPTSTR lpszString, LPCTSTR lpcszTarget, TCHAR c);
//  񒆂̎w肵Zbgw肵ɒuwp[֐
//
//  NVLibrarył́ARg\Ń^usȂ̂ŁA
//  gĒu悤ɂĂ


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetNVAudioFileCreate(LPNVAUDIOFILECREATE lpnvafc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample)
{
	lpnvafc->dwFourCC = NVAUDIOFILE_FOURCC;
	lpnvafc->dwObjSize = sizeof(NVAUDIOFILECREATE);
	lpnvafc->dwFlag = dwFlag;
	lpnvafc->lpcszDataName = lpcszDataName;
	lpnvafc->lBitsPerSample = lBitsPerSample;

	return;
}


inline LPNVAUDIOFILECOMMENT NVAFBuildComment(LPCTSTR lpcszArtist, LPCTSTR lpcszTitle, LPCTSTR lpcszAlbum, LPCTSTR lpcszDate,
											 LPCTSTR lpcszTrackNumber, LPCTSTR lpcszGenre, LPCTSTR lpcszComment)
{
	DWORD dwSize = sizeof(NVAUDIOFILECOMMENT) - sizeof(TCHAR);// + 16;/*DebugTrailByte*/;
	LPNVAUDIOFILECOMMENT lpnvafcm = NULL;
	DWORD dwOffset = 0;
	DWORD dwArtistLen;
	DWORD dwTitleLen;
	DWORD dwAlbumLen;
	DWORD dwDateLen;
	DWORD dwTrackNumberLen;
	DWORD dwGenreLen;
	DWORD dwCommentLen;
	LPCTSTR lpcszDummy = TEXT("\0");

	lpcszArtist = lpcszArtist ? lpcszArtist : lpcszDummy;
	lpcszTitle = lpcszTitle ? lpcszTitle : lpcszDummy;
	lpcszAlbum = lpcszAlbum ? lpcszAlbum : lpcszDummy;
	lpcszDate = lpcszDate ? lpcszDate : lpcszDummy;
	lpcszTrackNumber = lpcszTrackNumber ? lpcszTrackNumber : lpcszDummy;
	lpcszGenre = lpcszGenre ? lpcszGenre : lpcszDummy;
	lpcszComment = lpcszComment ? lpcszComment : lpcszDummy;

	dwArtistLen = (DWORD) _tcslen(lpcszArtist) + 1;
	dwSize += dwArtistLen * sizeof(TCHAR);
	dwTitleLen = (DWORD) _tcslen(lpcszTitle) + 1;
	dwSize += dwTitleLen * sizeof(TCHAR);
	dwAlbumLen = (DWORD) _tcslen(lpcszAlbum) + 1;
	dwSize += dwAlbumLen * sizeof(TCHAR);
	dwDateLen = (DWORD) _tcslen(lpcszDate) + 1;
	dwSize += dwDateLen * sizeof(TCHAR);
	dwTrackNumberLen = (DWORD) _tcslen(lpcszTrackNumber) + 1;
	dwSize += dwTrackNumberLen * sizeof(TCHAR);
	dwGenreLen = (DWORD) _tcslen(lpcszGenre) + 1;
	dwSize += dwGenreLen * sizeof(TCHAR);
	dwCommentLen = (DWORD) _tcslen(lpcszComment) + 1;
	dwSize += dwCommentLen * sizeof(TCHAR);

	lpnvafcm = (LPNVAUDIOFILECOMMENT) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, dwSize);
	lpnvafcm->dwFourCC = NVAUDIOFILE_FOURCC;
	lpnvafcm->dwObjSize = dwSize;

	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwArtistLen, lpcszArtist);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetArtist = dwOffset;
	dwOffset += dwArtistLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwTitleLen, lpcszTitle);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetTitle = dwOffset;
	dwOffset += dwTitleLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwAlbumLen, lpcszAlbum);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetAlbum = dwOffset;
	dwOffset += dwAlbumLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwDateLen, lpcszDate);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetDate = dwOffset;
	dwOffset += dwDateLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwTrackNumberLen, lpcszTrackNumber);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetTrackNumber = dwOffset;
	dwOffset += dwTrackNumberLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwGenreLen, lpcszGenre);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetGenre = dwOffset;
	dwOffset += dwGenreLen;
	_tcscpy_s(&lpnvafcm->szString[dwOffset], dwCommentLen, lpcszComment);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetComment = dwOffset;
	//dwOffset += dwCommnetLen;

#ifdef _DEBUG
	{
		NVRESULT nvres;
		LONG lOffset = -1;
		nvres = NVMemCheckDebugArea(lpnvafcm, &lOffset);
		if (nvres)
		{
			_tprintf(TEXT("NVAFBuildComment Buffer over run!!! Memory : %08I64X, Offset : %d\n"), lpnvafcm, lOffset);
		}
	}
#endif
	return lpnvafcm;
}

#ifdef _UNICODE
inline LPNVAUDIOFILECOMMENT NVAFBuildCommentAtoW(LPCSTR lpcszArtist, LPCSTR lpcszTitle, LPCSTR lpcszAlbum, LPCSTR lpcszDate,
											 LPCSTR lpcszTrackNumber, LPCSTR lpcszGenre, LPCSTR lpcszComment)
{
	DWORD dwSize = sizeof(NVAUDIOFILECOMMENT) - sizeof(TCHAR);// + 16;/*DebugTrailByte*/;
	LPNVAUDIOFILECOMMENT lpnvafcm = NULL;
	DWORD dwOffset = 0;
	DWORD dwArtistLen;
	DWORD dwTitleLen;
	DWORD dwAlbumLen;
	DWORD dwDateLen;
	DWORD dwTrackNumberLen;
	DWORD dwGenreLen;
	DWORD dwCommentLen;

	LPCSTR lpcszDummy = "\0";

	lpcszArtist = lpcszArtist ? lpcszArtist : lpcszDummy;
	lpcszTitle = lpcszTitle ? lpcszTitle : lpcszDummy;
	lpcszAlbum = lpcszAlbum ? lpcszAlbum : lpcszDummy;
	lpcszDate = lpcszDate ? lpcszDate : lpcszDummy;
	lpcszTrackNumber = lpcszTrackNumber ? lpcszTrackNumber : lpcszDummy;
	lpcszGenre = lpcszGenre ? lpcszGenre : lpcszDummy;
	lpcszComment = lpcszComment ? lpcszComment : lpcszDummy;

	dwArtistLen = MultiByteToWideChar(CP_ACP, 0, lpcszArtist, -1, NULL, 0);
	dwSize += dwArtistLen * sizeof(TCHAR);
	dwTitleLen = MultiByteToWideChar(CP_ACP, 0, lpcszTitle, -1, NULL, 0);
	dwSize += dwTitleLen * sizeof(TCHAR);
	dwAlbumLen = MultiByteToWideChar(CP_ACP, 0, lpcszAlbum, -1, NULL, 0);
	dwSize += dwAlbumLen * sizeof(TCHAR);
	dwDateLen = MultiByteToWideChar(CP_ACP, 0, lpcszDate, -1, NULL, 0);
	dwSize += dwDateLen * sizeof(TCHAR);
	dwTrackNumberLen = MultiByteToWideChar(CP_ACP, 0, lpcszTrackNumber, -1, NULL, 0);
	dwSize += dwTrackNumberLen * sizeof(TCHAR);
	dwGenreLen = MultiByteToWideChar(CP_ACP, 0, lpcszGenre, -1, NULL, 0);
	dwSize += dwGenreLen * sizeof(TCHAR);
	dwCommentLen = MultiByteToWideChar(CP_ACP, 0, lpcszComment, -1, NULL, 0);
	dwSize += dwCommentLen * sizeof(TCHAR);

	lpnvafcm = (LPNVAUDIOFILECOMMENT) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, dwSize);
	lpnvafcm->dwFourCC = NVAUDIOFILE_FOURCC;
	lpnvafcm->dwObjSize = dwSize;

	MultiByteToWideChar(CP_ACP, 0, lpcszArtist, -1, &lpnvafcm->szString[dwOffset], dwArtistLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetArtist = dwOffset;
	dwOffset += dwArtistLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszTitle, -1, &lpnvafcm->szString[dwOffset], dwTitleLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetTitle = dwOffset;
	dwOffset += dwTitleLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszAlbum, -1, &lpnvafcm->szString[dwOffset], dwAlbumLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetAlbum = dwOffset;
	dwOffset += dwAlbumLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszDate, -1, &lpnvafcm->szString[dwOffset], dwDateLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetDate = dwOffset;
	dwOffset += dwDateLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszTrackNumber, -1, &lpnvafcm->szString[dwOffset], dwTrackNumberLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetTrackNumber = dwOffset;
	dwOffset += dwTrackNumberLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszGenre, -1, &lpnvafcm->szString[dwOffset], dwGenreLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetGenre = dwOffset;
	dwOffset += dwGenreLen;
	MultiByteToWideChar(CP_ACP, 0, lpcszComment, -1, &lpnvafcm->szString[dwOffset], dwCommentLen);
	NVReplaceString(&lpnvafcm->szString[dwOffset], TEXT("\n\r\t"), TEXT(' '));
	lpnvafcm->lOffsetComment = dwOffset;
	//dwOffset += dwCommnetLen;

#ifdef _DEBUG
	{
		NVRESULT nvres;
		LONG lOffset = -1;
		nvres = NVMemCheckDebugArea(lpnvafcm, &lOffset);
		if (nvres)
		{
			_tprintf(TEXT("NVAFBuildCommentAtoW Buffer over run!!! Memory : %08X, Offset : %d\n"), lpnvafcm, lOffset);
		}
	}
#endif
	return lpnvafcm;
}
#endif


inline LPNVAUDIOFILECOMMENT NVAudioFile_GetSIF(INVSTREAM invst, LPCTSTR lpcszTrack)
{
	union
	{
		struct
		{
			DWORD dwTag;
			DWORD dwDataSize;
		};
		QWORD Header;
	};
	DWORD dwRead;
	NVRESULT nvres;
	QWUNION quCurrent;

	nvres = invst->GetCurrentPosition(&quCurrent.ql, NVSTREAM_SEEKBEGIN);
	if (nvres)
	{
		return NULL;
	}

	do
	{
		//  t@C̐擪Ɉړ
		nvres = invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
		if (nvres)
		{
			break;
		}
		
		//  擪^Oǂݏo
		nvres = invst->Read(&dwTag, sizeof(DWORD), &dwRead);
		if (nvres)
		{
			break;
		}

		//  RIFF t@CłȂ΃G[
		if (dwTag != MAKEFOURCC('R', 'I', 'F', 'F'))
		{
			break;
		}

		{
			//  t@CTCYt@C^Cvǂݏo
			nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				break;
			}
		}

		//  `N^Oƃ`NTCY擾
		nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			break;
		}
		
		//  LIST `N܂ŌJԂ
		while (dwTag != MAKEFOURCC('L', 'I', 'S', 'T'))
		{
			//  ̃`N̐擪܂ňړ
			nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01), NVSTREAM_SEEKCURRENT);
			
			//  ̃`N擾
			nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				break;
			}
		}
		if (nvres || dwTag != MAKEFOURCC('L', 'I', 'S', 'T'))
		{
			break;
		}

		if (dwDataSize <= 4)
		{
			break;
		}

		//  LIST `N SIF 擾
		
		nvres = invst->Read(&dwTag, sizeof(DWORD), &dwRead);
		if (nvres || (dwTag != MAKEFOURCC('I', 'N', 'F', 'O')))
		{
			break;
		}

		{
			DWORD dwRead;
			DWORD dwSize;
			DWORD dwCurSize = 0;
			CHAR * dummy = "";
			LPSTR lpszArtist = dummy;
			LPSTR lpszTitle = dummy;
			LPSTR lpszAlbum = dummy;
			LPSTR lpszYear = dummy;
			LPCSTR lpszTrackNumber = dummy;
			LPSTR lpszGenre = dummy;
			LPSTR lpszComment = dummy;
			LPBYTE lpBuf;

			dwDataSize -= 4;
			lpBuf = (LPBYTE) NVMemAlloc(NVMEM_FIXED, dwDataSize + 1);
			nvres = invst->Read(lpBuf, dwDataSize, &dwRead);
			if (nvres)
			{
				if (nvres == VSTMERR_VALUE_ENDOFDATA && dwRead < dwDataSize)
				{
					ZeroMemory(lpBuf + dwRead, dwDataSize - dwRead);
				}
				else
				{
					NVMemFree(lpBuf);
					break;
				}
			}
			lpBuf[dwDataSize] = '\0';

			while (dwCurSize + 8 <= dwDataSize)
			{
				dwTag = *((LPDWORD) &lpBuf[dwCurSize]);
				dwSize = *((LPDWORD) &lpBuf[dwCurSize + 4]);
				dwSize += (dwSize & 0x01);
				if (dwCurSize + 8 + dwSize > dwDataSize)
				{
					break;
				}
				switch (dwTag)
				{
				case MAKEFOURCC('I', 'N', 'A', 'M'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszTitle = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'S', 'B', 'J'):
					{
						lpBuf[dwCurSize] = '\0';
						if (lpszTitle == dummy)
						{
							lpszTitle = (LPSTR) &lpBuf[dwCurSize + 8];
						}
					}
					break;
				case MAKEFOURCC('I', 'A', 'R', 'T'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszArtist = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'P', 'R', 'D'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszAlbum = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'C', 'M', 'T'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszComment = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'C', 'R', 'D'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszYear = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'G', 'N', 'R'):
					{
						lpBuf[dwCurSize] = '\0';
						lpszGenre = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				case MAKEFOURCC('I', 'T', 'R', 'K'):
					{
						//  ƎgiL[Mjy-~~~~
						lpBuf[dwCurSize] = '\0';
						lpszTrackNumber = (LPSTR) &lpBuf[dwCurSize + 8];
					}
					break;
				default:
					{
						lpBuf[dwCurSize] = '\0';
					}
				}
				dwCurSize += 8 + dwSize;
			}//	end of while (dwCurSize + 8 <= dwDataSize)

			if (dwCurSize <= dwDataSize)
			{
				lpBuf[dwCurSize] = '\0';
			}
			else
			{
				lpBuf[dwDataSize] = '\0';
			}

			nvres = invst->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
			{
				LPNVAUDIOFILECOMMENT lpnvafc;
#ifdef _UNICODE
				LPSTR lp = NULL;
				if (lpcszTrack && lpszTrackNumber[0] == '\0')
				{
					int len = WideCharToMultiByte(CP_ACP, 0, lpcszTrack, -1, NULL, 0, NULL, NULL);
					lp = new CHAR[len];
					WideCharToMultiByte(CP_ACP, 0, lpcszTrack, -1, lp, len, NULL, NULL);
					lpszTrackNumber = lp;
				}
				lpnvafc = NVAFBuildCommentAtoW(lpszArtist, lpszTitle, lpszAlbum, lpszYear, lpszTrackNumber, lpszGenre, lpszComment);
				if (lp)
				{
					delete [] lp;
				}
#else
				if (lpcszTrack && lpszTrackNumber[0] == '\0')
				{
					lpszTrackNumber = lpcszTrack;
				}
				lpnvafc = NVAFBuildComment(lpszArtist, lpszTitle, lpszAlbum, lpszYear, lpszTrackNumber, lpszGenre, lpszComment);
#endif
				NVMemFree(lpBuf);
				return lpnvafc;
			}
		}
	} while (0);

	nvres = invst->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
	return NULL;
}

inline NVRESULT NVAudioFile_WriteSIF(INVSTREAM invst, LPCNVAUDIOFILECOMMENT lpnvafc)
{
	if (lpnvafc)
	{
		NVRESULT nvres;
		DWORD dw;
		DWORD dw2;
		DWORD dwWrite;
		DWORD dwListLen = 0;
#ifdef _UNICODE
		DWORD dwTitleLen = lpnvafc->szString[lpnvafc->lOffsetTitle] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetTitle], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwArtistLen = lpnvafc->szString[lpnvafc->lOffsetArtist] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetArtist], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwAlbumLen = lpnvafc->szString[lpnvafc->lOffsetAlbum] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetAlbum], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwDateLen = lpnvafc->szString[lpnvafc->lOffsetDate] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetDate], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwTrackNumberLen = lpnvafc->szString[lpnvafc->lOffsetTrackNumber] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetTrackNumber], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwGenreLen = lpnvafc->szString[lpnvafc->lOffsetGenre] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetGenre], -1, NULL, 0, NULL, NULL) : 0;
		DWORD dwCommentLen = lpnvafc->szString[lpnvafc->lOffsetComment] ? WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetComment], -1, NULL, 0, NULL, NULL) : 0;
#else
		DWORD dwTitleLen = lpnvafc->szString[lpnvafc->lOffsetTitle] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetTitle]) + 1 : 0;
		DWORD dwArtistLen = lpnvafc->szString[lpnvafc->lOffsetArtist] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetArtist]) + 1 : 0;
		DWORD dwAlbumLen = lpnvafc->szString[lpnvafc->lOffsetAlbum] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetAlbum]) + 1 : 0;
		DWORD dwDateLen = lpnvafc->szString[lpnvafc->lOffsetDate] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetDate]) + 1 : 0;
		DWORD dwTrackNumberLen = lpnvafc->szString[lpnvafc->lOffsetTrackNumber] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetTrackNumber]) + 1 : 0;
		DWORD dwGenreLen = lpnvafc->szString[lpnvafc->lOffsetGenre] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetGenre]) + 1 : 0;
		DWORD dwCommentLen = lpnvafc->szString[lpnvafc->lOffsetComment] ? (DWORD) _tcslen(&lpnvafc->szString[lpnvafc->lOffsetComment]) + 1 : 0;
#endif
		dwListLen += dwTitleLen;
		dwListLen += dwTitleLen;
		dwListLen += dwArtistLen;
		dwListLen += dwAlbumLen;
		dwListLen += dwDateLen;
		dwListLen += dwTrackNumberLen;
		dwListLen += dwGenreLen;
		dwListLen += dwCommentLen;
		dw2 = 0;

		if (dwListLen)
		{
			dwListLen += (dwTitleLen ? 8 : 0) + (dwTitleLen & 0x01);
			dwListLen += (dwTitleLen ? 8 : 0) + (dwTitleLen & 0x01);
			dwListLen += (dwArtistLen ? 8 : 0) + (dwArtistLen & 0x01);
			dwListLen += (dwAlbumLen ? 8 : 0) + (dwAlbumLen & 0x01);
			dwListLen += (dwDateLen ? 8 : 0) + (dwDateLen & 0x01);
			dwListLen += (dwTrackNumberLen ? 8 : 0) + (dwTrackNumberLen & 0x01);
			dwListLen += (dwGenreLen ? 8 : 0) + (dwGenreLen & 0x01);
			dwListLen += (dwCommentLen ? 8 : 0) + (dwCommentLen & 0x01);
			dwListLen += 4;
			nvres = invst->SetCurrentPosition(0, NVSTREAM_SEEKEND);

			dw = MAKEFOURCC('L', 'I', 'S', 'T');
			invst->Write(&dw, 4, &dwWrite);
			invst->Write(&dwListLen, 4, &dwWrite);
			dw = MAKEFOURCC('I', 'N', 'F', 'O');
			invst->Write(&dw, 4, &dwWrite);
			if (dwDateLen)
			{
				dw = MAKEFOURCC('I', 'C', 'R', 'D');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwDateLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwDateLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetDate], -1, lp, dwDateLen, NULL, NULL);
					invst->Write(lp, dwDateLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetDate], dwDateLen, &dwWrite);
#endif
				if (dwDateLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwAlbumLen)
			{
				dw = MAKEFOURCC('I', 'P', 'R', 'D');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwAlbumLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwAlbumLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetAlbum], -1, lp, dwAlbumLen, NULL, NULL);
					invst->Write(lp, dwAlbumLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetAlbum], dwAlbumLen, &dwWrite);
#endif
				if (dwAlbumLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwTitleLen)
			{
				dw = MAKEFOURCC('I', 'S', 'B', 'J');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwTitleLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwTitleLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetTitle], -1, lp, dwTitleLen, NULL, NULL);
					invst->Write(lp, dwTitleLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetTitle], dwTitleLen, &dwWrite);
#endif
				if (dwTitleLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
				dw = MAKEFOURCC('I', 'N', 'A', 'M');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwTitleLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwTitleLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetTitle], -1, lp, dwTitleLen, NULL, NULL);
					invst->Write(lp, dwTitleLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetTitle], dwTitleLen, &dwWrite);
#endif
				if (dwTitleLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwTrackNumberLen)
			{
				//  SIF ɂ̓gbNԍȂ́HHH
				//  ɓƎdlƂĝsR(L[`)m
				dw = MAKEFOURCC('I', 'T', 'R', 'K');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwTrackNumberLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwTrackNumberLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetTrackNumber], -1, lp, dwTrackNumberLen, NULL, NULL);
					invst->Write(lp, dwTrackNumberLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetTrackNumber], dwTrackNumberLen, &dwWrite);
#endif
				if (dwTrackNumberLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwGenreLen)
			{
				dw = MAKEFOURCC('I', 'G', 'N', 'R');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwGenreLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwGenreLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetGenre], -1, lp, dwGenreLen, NULL, NULL);
					invst->Write(lp, dwGenreLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetGenre], dwGenreLen, &dwWrite);
#endif
				if (dwGenreLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwCommentLen)
			{
				dw = MAKEFOURCC('I', 'C', 'M', 'T');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwCommentLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwCommentLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetComment], -1, lp, dwCommentLen, NULL, NULL);
					invst->Write(lp, dwCommentLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetComment], dwCommentLen, &dwWrite);
#endif
				if (dwCommentLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
			if (dwArtistLen)
			{
				dw = MAKEFOURCC('I', 'A', 'R', 'T');
				invst->Write(&dw, 4, &dwWrite);
				invst->Write(&dwArtistLen, 4, &dwWrite);
#ifdef _UNICODE
				{
					LPSTR lp = new CHAR [dwArtistLen];
					WideCharToMultiByte(CP_ACP, 0, &lpnvafc->szString[lpnvafc->lOffsetArtist], -1, lp, dwArtistLen, NULL, NULL);
					invst->Write(lp, dwArtistLen, &dwWrite);
					delete [] lp;
				}
#else
				invst->Write(&lpnvafc->szString[lpnvafc->lOffsetArtist], dwArtistLen, &dwWrite);
#endif
				if (dwArtistLen & 0x01)
				{
					invst->Write(&dw2, 1, &dwWrite);
				}
			}
		}
	}

	return NV_OK;
}

inline void NVReplaceString(LPTSTR lpszString, LPCTSTR lpcszTarget, TCHAR c)
{
	if (lpszString)
	{
		for ( ; ; )
		{
#ifdef _UNICODE
			lpszString = (LPTSTR) wcspbrk((const wchar_t *)lpszString, (const wchar_t *)lpcszTarget);
#else
			lpszString = (LPTSTR) _mbspbrk((unsigned char *)lpszString, (unsigned char *)lpcszTarget);
#endif
			if (NULL == lpszString)
			{
				break;
			}

			*lpszString = c;
		}
	}
	return;
}

#pragma pack(pop)

#ifdef __cplusplus
}
#endif
