//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  VCOM Sound Stream Manager W[ \[Xt@C  for  NVAudioFileLibrary                //
//  VSSManager.cpp                                                                              //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "VSSManager.h"



static NVRESULT VSSM_SearchLibrary(LPVSSMANAGERDATA lpvsmd);
static LONG CheckLowerPriorityPlugin(DWORD dwFourCC);

extern NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VInternalAddInterface(IVCOM ivcom);


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_VSSManager(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_VSSManager;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_VSSManager
//



Class_VSSManager::Class_VSSManager(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_VSSManager), VSSMANAGER_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_VSSManager::~Class_VSSManager(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_VSSManager::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	//  ʂ̌^ɃLXg
	LPCVSSMANAGERCREATE lpcvsmc = (LPCVSSMANAGERCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VAFERR_ALREADYUSED;
	}

	//  ̐`FbN
	//  NX̎ʎqƈ̎ʎqr
	if (lpcvsmc->dwFourCC != VSSMANAGER_FOURCC)
	{
		return VAFERR_INVALIDPARAMTYPE;
	}
	if (lpcvsmc->dwObjSize != sizeof(VSSMANAGERCREATE))
	{
		return VAFERR_INVALIDPARAMSIZE;
	}

	vsmd.lpDecList = new VSSDECLIST;
	vsmd.lpEncList = new VSSENCLIST;
	vsmd.lpFXList = new VSSFXLIST;
	VSSM_SearchLibrary(&vsmd);

	vcd.bIsCreated = TRUE;

	return NV_OK;
}


NVRESULT Class_VSSManager::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg

	if (vsmd.lpDecList)
	{
		vsmd.lpDecList->clear();
		delete vsmd.lpDecList;
		vsmd.lpDecList = NULL;
	}

	if (vsmd.lpEncList)
	{
		vsmd.lpEncList->clear();
		delete vsmd.lpEncList;
		vsmd.lpEncList = NULL;
	}

	if (vsmd.lpFXList)
	{
		vsmd.lpFXList->clear();
		delete vsmd.lpFXList;
		vsmd.lpFXList = NULL;
	}

	//  eNX ResetData Ɉp
	return Class_VCOM::ResetData();
}


NVRESULT Class_VSSManager::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == VSSMANAGER_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (IVSSMANAGER) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VCOM::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_VSSManager::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, VSSMANAGER_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VCOM::AddInterface(0);
}


NVRESULT Class_VSSManager::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VCOM::DeleteInterface();
}


NVRESULT Class_VSSManager::DecGetFileTypeFourCC(LPCTSTR lpcszFileName, LPDWORD lpdwFourCC)
{
	INVSTREAM invst;
	NVSTREAMCREATE nvstc;
	NVRESULT nvres;

	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}
	SetNVStreamCreate(&nvstc, NVSTREAM_OPENREAD, lpcszFileName);
	nvres = VCreateInstance(NVFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invst);
	if (nvres)
	{
		return nvres;
	}

	nvres = invst->Create(&nvstc);
	if (nvres)
	{
		invst->Release();

		return VAFERR_INVALIDPARAM;
	}

	nvres = DecGetFileTypeFourCCByStream(invst, lpdwFourCC);
	invst->Release();
	return nvres;
}

NVRESULT Class_VSSManager::DecGetFileTypeFourCCByStream(INVSTREAM invst, LPDWORD lpdwFourCC)
{
	size_t i;
	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpDecList->size(); i++)
	{
		NVRESULT nvres;
		nvres = (*vsmd.lpDecList)[i].IsSupported(invst, (*vsmd.lpDecList)[i].dwFourCC);
		if (nvres == NV_OK)
		{
			*lpdwFourCC = (*vsmd.lpDecList)[i].dwFourCC;
			return NV_OK;
		}
	}

	*lpdwFourCC = 0;
	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSManager::DecCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface)
{
	size_t i;
	NVRESULT nvres;
	IVCOM ivcom = NULL;

	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpDecList->size(); i++)
	{
		if ((*vsmd.lpDecList)[i].dwFourCC == dwInstanceFourCC)
		{
			break;
		}
	}

	if (i >= vsmd.lpDecList->size())
	{
		return VAFERR_UNSUPPORTED;
	}

	nvres = (*vsmd.lpDecList)[i].CreateInstance(dwInstanceFourCC, &ivcom);
	if (nvres || ivcom == NULL)
	{
		return nvres;
	}

	VInternalAddInterface(ivcom);

	nvres = ivcom->QueryInterface(dwInterfaceFourCC, lplpvInterface);
	ivcom->Release();

	return nvres;
}

NVRESULT Class_VSSManager::DecEnumPlugin(LPVSSDECENTRY lpInfo, LPDWORD lpdwCount)
{
	DWORD i;
	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}
	if (lpInfo)
	{
		for (i = 0; i < (DWORD) vsmd.lpDecList->size() && i < *lpdwCount; i++)
		{
			lpInfo[i] = (*vsmd.lpDecList)[i];
		}
		*lpdwCount = i;
		return NV_OK;
	}
	else
	{
		*lpdwCount = (DWORD) vsmd.lpDecList->size();
		return NV_OK;
	}
}

HWND Class_VSSManager::DecConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner)
{
	size_t i;
	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return NULL;
	}
	for (i = 0; i < vsmd.lpDecList->size(); i++)
	{
		if ((*vsmd.lpDecList)[i].dwFourCC == dwFourCC)
		{
			return (*vsmd.lpDecList)[i].ConfigDialog(dwFourCC, hInstance, hwndOwner);
		}
	}

	return NULL;
}

NVRESULT Class_VSSManager::DecSetPriority(DWORD dwFourCC, DWORD dwPriority)
{
	size_t i;
	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpDecList->size(); i++)
	{
		if ((*vsmd.lpDecList)[i].dwFourCC == dwFourCC)
		{
			(*vsmd.lpDecList)[i].dwPriority = dwPriority;
		}
	}

	if (i >= vsmd.lpDecList->size())
	{
		return VAFERR_UNSUPPORTED;
	}

	return NV_OK;
}

NVRESULT Class_VSSManager::DecWriteSetting(void)
{
	TCHAR szConfigFileName[NV_PATHMAX];
	if ((! vcd.bIsCreated) || (! vsmd.lpDecList))
	{
		return VAFERR_NOCREATE;
	}

	NVGetConfigFileDirectory(szConfigFileName, NV_PATHMAX);
	PathAppend(szConfigFileName, TEXT("VSS.cfg"));

	{
		size_t i, j;
		int n;
		for (n = 0; n < (int) (vsmd.lpDecList->size() - 1); n++)
		{
			for (j = n + 1; j < vsmd.lpDecList->size(); j++)
			{
				if ((*vsmd.lpDecList)[n].dwPriority < (*vsmd.lpDecList)[j].dwPriority)
				{
					VSSDECENTRY vss;

					vss = (*vsmd.lpDecList)[j];
					(*vsmd.lpDecList)[j] = (*vsmd.lpDecList)[n];
					(*vsmd.lpDecList)[n] = vss;
				}
			}
		}

		for (i = 0; i < vsmd.lpDecList->size(); i++)
		{
			TCHAR szFourCC[5];
			TCHAR szPriority[32];

			(*vsmd.lpDecList)[i].dwPriority = (DWORD) (vsmd.lpDecList->size() - i);
			NVFourCCToString((*vsmd.lpDecList)[i].dwFourCC, szFourCC, 5);
			_stprintf_s(szPriority, 32, TEXT("%d"), (*vsmd.lpDecList)[i].dwPriority);
			WritePrivateProfileString(szFourCC, TEXT("Priority"), szPriority, szConfigFileName);
		}
	}
	return NV_OK;
}

NVRESULT Class_VSSManager::EncCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface)
{
	size_t i;
	NVRESULT nvres;
	IVCOM ivcom = NULL;

	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpEncList->size(); i++)
	{
		if ((*vsmd.lpEncList)[i].dwFourCC == dwInstanceFourCC)
		{
			break;
		}
	}

	if (i >= vsmd.lpEncList->size())
	{
		return VAFERR_UNSUPPORTED;
	}

	nvres = (*vsmd.lpEncList)[i].CreateInstance(dwInstanceFourCC, &ivcom);
	if (nvres || ivcom == NULL)
	{
		return nvres;
	}

	VInternalAddInterface(ivcom);

	nvres = ivcom->QueryInterface(dwInterfaceFourCC, lplpvInterface);
	ivcom->Release();

	return nvres;
}

NVRESULT Class_VSSManager::EncEnumPlugin(LPVSSENCENTRY lpInfo, LPDWORD lpdwCount)
{
	DWORD i;
	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return VAFERR_NOCREATE;
	}
	if (lpInfo)
	{
		for (i = 0; i < (DWORD) vsmd.lpEncList->size() && i < *lpdwCount; i++)
		{
			lpInfo[i] = (*vsmd.lpEncList)[i];
		}
		*lpdwCount = i;
		return NV_OK;
	}
	else
	{
		*lpdwCount = (DWORD) vsmd.lpEncList->size();
		return NV_OK;
	}
}

HWND Class_VSSManager::EncConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam)
{
	size_t i;
	if (lplpvParam)
	{
		*lplpvParam = NULL;
	}
	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return NULL;
	}
	for (i = 0; i < vsmd.lpEncList->size(); i++)
	{
		if ((*vsmd.lpEncList)[i].dwFourCC == dwFourCC)
		{
			return (*vsmd.lpEncList)[i].ConfigDialog(dwFourCC, hInstance, hwndOwner, lplpvParam);
		}
	}

	return NULL;
}

NVRESULT Class_VSSManager::EncFreeParam(DWORD dwFourCC, LPVOID lpvParam)
{
	size_t i;
	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpEncList->size(); i++)
	{
		if ((*vsmd.lpEncList)[i].dwFourCC == dwFourCC)
		{
			return (*vsmd.lpEncList)[i].FreeParam(lpvParam);
		}
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSManager::EncGetParam(DWORD dwFourCC, LPVOID *lplpvParam)
{
	size_t i;
	*lplpvParam = NULL;
	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpEncList->size(); i++)
	{
		if ((*vsmd.lpEncList)[i].dwFourCC == dwFourCC)
		{
			if ((*vsmd.lpEncList)[i].GetParam)
			{
				return (*vsmd.lpEncList)[i].GetParam(dwFourCC, lplpvParam);
			}
		}
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSManager::EncCopyParam(DWORD dwFourCC, LPVOID *lplpvDest, LPVOID lpvSrc)
{
	size_t i;
	*lplpvDest = NULL;
	if ((! vcd.bIsCreated) || (! vsmd.lpEncList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpEncList->size(); i++)
	{
		if ((*vsmd.lpEncList)[i].dwFourCC == dwFourCC)
		{
			if ((*vsmd.lpEncList)[i].CopyParam)
			{
				return (*vsmd.lpEncList)[i].CopyParam(dwFourCC, lplpvDest, lpvSrc);
			}
		}
	}

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_VSSManager::FXCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface)
{
	size_t i;
	NVRESULT nvres;
	IVCOM ivcom = NULL;

	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpFXList->size(); i++)
	{
		if ((*vsmd.lpFXList)[i].dwFourCC == dwInstanceFourCC)
		{
			break;
		}
	}

	if (i >= vsmd.lpFXList->size())
	{
		return VAFERR_UNSUPPORTED;
	}

	nvres = (*vsmd.lpFXList)[i].CreateInstance(dwInstanceFourCC, &ivcom);
	if (nvres || ivcom == NULL)
	{
		return nvres;
	}

	VInternalAddInterface(ivcom);

	nvres = ivcom->QueryInterface(dwInterfaceFourCC, lplpvInterface);
	ivcom->Release();

	return nvres;
}

NVRESULT Class_VSSManager::FXEnumPlugin(LPVSSFXENTRY lpInfo, LPDWORD lpdwCount)
{
	DWORD i;
	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return VAFERR_NOCREATE;
	}
	if (lpInfo)
	{
		for (i = 0; i < (DWORD) vsmd.lpFXList->size() && i < *lpdwCount; i++)
		{
			lpInfo[i] = (*vsmd.lpFXList)[i];
		}
		*lpdwCount = i;
		return NV_OK;
	}
	else
	{
		*lpdwCount = (DWORD) vsmd.lpFXList->size();
		return NV_OK;
	}
}

HWND Class_VSSManager::FXConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam)
{
	size_t i;
	*lplpvParam = NULL;
	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return NULL;
	}
	for (i = 0; i < vsmd.lpFXList->size(); i++)
	{
		if ((*vsmd.lpFXList)[i].dwFourCC == dwFourCC)
		{
			return (*vsmd.lpFXList)[i].ConfigDialog(dwFourCC, hInstance, hwndOwner, lplpvParam);
		}
	}

	return NULL;
}

NVRESULT Class_VSSManager::FXFreeParam(DWORD dwFourCC, LPVOID lpvParam)
{
	size_t i;
	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpFXList->size(); i++)
	{
		if ((*vsmd.lpFXList)[i].dwFourCC == dwFourCC)
		{
			return (*vsmd.lpFXList)[i].FreeParam(lpvParam);
		}
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSManager::FXGetParam(DWORD dwFourCC, LPVOID *lplpvParam)
{
	size_t i;
	*lplpvParam = NULL;
	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpFXList->size(); i++)
	{
		if ((*vsmd.lpFXList)[i].dwFourCC == dwFourCC)
		{
			if ((*vsmd.lpFXList)[i].GetParam)
			{
				return (*vsmd.lpFXList)[i].GetParam(dwFourCC, lplpvParam);
			}
		}
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSManager::FXCopyParam(DWORD dwFourCC, LPVOID *lplpvDest, LPVOID lpvSrc)
{
	size_t i;
	*lplpvDest = NULL;
	if ((! vcd.bIsCreated) || (! vsmd.lpFXList))
	{
		return VAFERR_NOCREATE;
	}
	for (i = 0; i < vsmd.lpFXList->size(); i++)
	{
		if ((*vsmd.lpFXList)[i].dwFourCC == dwFourCC)
		{
			if ((*vsmd.lpFXList)[i].CopyParam)
			{
				return (*vsmd.lpFXList)[i].CopyParam(dwFourCC, lplpvDest, lpvSrc);
			}
		}
	}

	return VAFERR_UNSUPPORTED;
}


static NVRESULT VSSM_SearchLibrary(LPVSSMANAGERDATA lpvsmd)
{
	TCHAR szConfigFileName[NV_PATHMAX];
	{
		WIN32_FIND_DATA wfd;
		HANDLE hffd;
		TCHAR szFileName[NV_PATHMAX];
		LPTSTR lpszFilePart;
		int nFilePartLen;
		BOOL bRet;

		NVGetConfigFileDirectory(szConfigFileName, NV_PATHMAX);
		PathAppend(szConfigFileName, TEXT("VSS.cfg"));
		NVGetPluginDirectory(szFileName, NV_PATHMAX);
		PathAddBackslash(szFileName);
		lpszFilePart = szFileName + _tcslen(szFileName);
		nFilePartLen = (int) (NV_PATHMAX - _tcslen(szFileName));

		_tcscpy_s(lpszFilePart, nFilePartLen, TEXT("*.vss"));
		hffd = NVFindFirstFile(szFileName, &wfd);
		if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
		{
			return NV_OK;
		}

		do
		{
			HMODULE hModule;
			_tcscpy_s(lpszFilePart, nFilePartLen, wfd.cFileName);
			hModule = LoadLibrary(szFileName);
			if (hModule != NULL && hModule != INVALID_HANDLE_VALUE)
			{
				VSSGETPLUGININFO VSSGetPluginInfo;
				VSSGetPluginInfo = (VSSGETPLUGININFO) GetProcAddress(hModule, "VSSGetPluginInfo");
				if (VSSGetPluginInfo)
				{
					NVRESULT nvres;
					VSSPLUGININFO Info;
					nvres = VSSGetPluginInfo(&Info);
					if (nvres == NV_OK && Info.dwVersion >= 0x3000)
					{
						{
							HMODULE hDummy;
							VLoadLibraryByFileName(szFileName, &hDummy);
						}

						if (Info.VSSDecGetInfo)
						{
							VSSDECINFO DecInfo;
							DWORD i;

							nvres = Info.VSSDecGetInfo(&DecInfo);
							if (nvres == NV_OK)
							{
								for (i = 0; i < DecInfo.dwSupportedFileCount; i++)
								{
									VSSDECENTRY vss;
									TCHAR szFourCC[5];

									NVFourCCToString(DecInfo.lpcdwSupportedFourCC[i], szFourCC, 5);
									vss.dwPriority = GetPrivateProfileInt(szFourCC, TEXT("Priority"),
										CheckLowerPriorityPlugin(DecInfo.lpcdwSupportedFourCC[i]),
										szConfigFileName);
									vss.dwFourCC = DecInfo.lpcdwSupportedFourCC[i];
									vss.SupportedFileType.assign(DecInfo.lplpcszSupportedFileType[i]);
									vss.LibraryName.assign(Info.lpcszLibraryName);
									vss.AuthorName.assign(Info.lpcszAuthorName);
									vss.Description.assign(Info.lpcszDescription);
									vss.URL.assign(Info.lpcszURL);
									vss.IsSupported = DecInfo.IsSupported;
									vss.CreateInstance = DecInfo.CreateInstance;
									vss.ConfigDialog = DecInfo.ConfigDialog;
									lpvsmd->lpDecList->push_back(vss);
								}
							}
						}

						if (Info.VSSEncGetInfo)
						{
							VSSENCINFO EncInfo;
							DWORD i;

							nvres = Info.VSSEncGetInfo(&EncInfo);
							if (nvres == NV_OK)
							{
								for (i = 0; i < EncInfo.dwSupportedFileCount; i++)
								{
									VSSENCENTRY vss;
//									TCHAR szFourCC[5];

//									NVFourCCToString(EncInfo.lpcdwSupportedFourCC[i], szFourCC, 5);
									vss.dwPriority = 0;
									vss.dwFourCC = EncInfo.lpcdwSupportedFourCC[i];
									vss.SupportedFileType.assign(EncInfo.lplpcszSupportedFileType[i]);
									vss.LibraryName.assign(Info.lpcszLibraryName);
									vss.AuthorName.assign(Info.lpcszAuthorName);
									vss.Description.assign(Info.lpcszDescription);
									vss.URL.assign(Info.lpcszURL);
									vss.DefaultExtension.assign(EncInfo.lplpcszDefaultExtension[i]);
									vss.CreateInstance = EncInfo.CreateInstance;
									vss.ConfigDialog = EncInfo.ConfigDialog;
									vss.FreeParam = EncInfo.FreeParam;
									vss.GetParam = EncInfo.GetParam;
									vss.CopyParam = EncInfo.CopyParam;
									lpvsmd->lpEncList->push_back(vss);
								}
							}
						}

						if (Info.VSSFXGetInfo)
						{
							VSSFXINFO FXInfo;
							DWORD i;

							nvres = Info.VSSFXGetInfo(&FXInfo);
							if (nvres == NV_OK)
							{
								for (i = 0; i < FXInfo.dwSupportedFileCount; i++)
								{
									VSSFXENTRY vss;
									//TCHAR szFourCC[5];

									//NVFourCCToString(FXInfo.lpcdwSupportedFourCC[i], szFourCC, 5);
									vss.dwPriority = 0;
									vss.dwFourCC = FXInfo.lpcdwSupportedFourCC[i];
									vss.SupportedFileType.assign(FXInfo.lplpcszSupportedFileType[i]);
									vss.LibraryName.assign(Info.lpcszLibraryName);
									vss.AuthorName.assign(Info.lpcszAuthorName);
									vss.Description.assign(Info.lpcszDescription);
									vss.URL.assign(Info.lpcszURL);
									vss.CreateInstance = FXInfo.CreateInstance;
									vss.ConfigDialog = FXInfo.ConfigDialog;
									vss.FreeParam = FXInfo.FreeParam;
									vss.GetParam = FXInfo.GetParam;
									vss.CopyParam = FXInfo.CopyParam;
									lpvsmd->lpFXList->push_back(vss);
								}
							}
						}
					}
				}
				FreeLibrary(hModule);
			}

			bRet = NVFindNextFile(hffd, &wfd);
		} while (bRet);
		NVFindClose(hffd);
	}


	{
		size_t i, j;
		int n;
		for (n = 0; n < (int)(lpvsmd->lpDecList->size() - 1); n++)
		{
			for (j = n + 1; j < lpvsmd->lpDecList->size(); j++)
			{
				if ((*lpvsmd->lpDecList)[n].dwPriority < (*lpvsmd->lpDecList)[j].dwPriority)
				{
					VSSDECENTRY vss;

					vss = (*lpvsmd->lpDecList)[j];
					(*lpvsmd->lpDecList)[j] = (*lpvsmd->lpDecList)[n];
					(*lpvsmd->lpDecList)[n] = vss;
				}
			}
		}

		for (i = 0; i < lpvsmd->lpDecList->size(); i++)
		{
			TCHAR szFourCC[5];
			TCHAR szPriority[32];

			(*lpvsmd->lpDecList)[i].dwPriority = (DWORD) (lpvsmd->lpDecList->size() - i);
			NVFourCCToString((*lpvsmd->lpDecList)[i].dwFourCC, szFourCC, 5);
			_stprintf_s(szPriority, 32, TEXT("%d"), (*lpvsmd->lpDecList)[i].dwPriority);
			WritePrivateProfileString(szFourCC, TEXT("Priority"), szPriority, szConfigFileName);
		}
	}

	return NV_OK;
}

static LONG CheckLowerPriorityPlugin(DWORD dwFourCC)
{
	switch (dwFourCC)
	{
	case MAKEFOURCC('M', 'P', 'G', 'E'):
		return 0;
	case MAKEFOURCC('O', 'F', 'L', 'D'):
		return 0;
	case MAKEFOURCC('V', 'D', 'S', 'W'):
		return 0;
	default:
		return 1;
	}
}