//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  VCOM Sound Stream Manager W[ wb_[t@C  for  NVAudioFileLibrary              //
//  VSSManager.h                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAudioFile.h"

#include <vector>

#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//

//  VSS Category D
typedef NVRESULT (WINAPI * VSSDECISSUPPORTED) (INVSTREAM invst, DWORD dwFourCC);
typedef NVRESULT (WINAPI * VSSDECCREATEINSTANCE) (DWORD dwFourCC, LPIVCOM lpivcom);
typedef HWND (WINAPI * VSSDECCONFIGDIALOG) (DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner);

struct VSSDECINFO
{
	DWORD dwSupportedFileCount;					//  T|[gނ̐
	const DWORD *lpcdwSupportedFourCC;			//  T|[gNXʎq
	const LPCTSTR *lplpcszSupportedFileType;	//  FourCC ɑΉt@C̎

	VSSDECISSUPPORTED IsSupported;				//  t@C`FbN֐
	VSSDECCREATEINSTANCE CreateInstance;		//  fR[_CX^X֐
	VSSDECCONFIGDIALOG ConfigDialog;			//  ݒp[__CAO\֐
};
typedef VSSDECINFO * LPVSSDECINFO;
typedef const VSSDECINFO * LPCVSSDECINFO;

//  VSS Category E
typedef NVRESULT (WINAPI * VSSENCCREATEINSTANCE) (DWORD dwFourCC, LPIVCOM lpivcom);
typedef HWND (WINAPI * VSSENCCONFIGDIALOG) (DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam);
typedef NVRESULT (WINAPI * VSSENCFREEPARAM) (LPVOID lpvParam);
typedef NVRESULT (WINAPI * VSSENCGETPARAM) (DWORD dwFourCC, LPVOID * lplpvParam);
typedef NVRESULT (WINAPI * VSSENCCOPYPARAM) (DWORD dwFourCC, LPVOID * lplpvDest, LPVOID lpvSrc);

struct VSSENCINFO
{
	DWORD dwSupportedFileCount;					//  T|[gނ̐
	const DWORD *lpcdwSupportedFourCC;			//  T|[gNXʎq
	const LPCTSTR *lplpcszSupportedFileType;	//  FourCC ɑΉt@C̎
	const LPCTSTR *lplpcszDefaultExtension;		//  W̊gq

	VSSENCCREATEINSTANCE CreateInstance;		//  fR[_CX^X֐
	VSSENCCONFIGDIALOG ConfigDialog;			//  ݒp[__CAO\֐
	VSSENCFREEPARAM FreeParam;					//  ݒp[^֐
	VSSENCGETPARAM GetParam;					//  ݂̃p[^擾֐
	VSSENCCOPYPARAM CopyParam;					//  p[^Rs[֐
};
typedef VSSENCINFO * LPVSSENCINFO;
typedef const VSSENCINFO * LPCVSSENCINFO;

//  VSS Category F
typedef NVRESULT (WINAPI * VSSFXCREATEINSTANCE) (DWORD dwFourCC, LPIVCOM lpivcom);
typedef HWND (WINAPI * VSSFXCONFIGDIALOG) (DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam);
typedef NVRESULT (WINAPI * VSSFXFREEPARAM) (LPVOID lpvParam);
typedef NVRESULT (WINAPI * VSSFXGETPARAM) (DWORD dwFourCC, LPVOID * lplpvParam);
typedef NVRESULT (WINAPI * VSSFXCOPYPARAM) (DWORD dwFourCC, LPVOID * lplpvDest, LPVOID lpvSrc);


struct VSSFXINFO
{
	DWORD dwSupportedFileCount;					//  T|[gނ̐
	const DWORD *lpcdwSupportedFourCC;			//  T|[gNXʎq
	const LPCTSTR *lplpcszSupportedFileType;	//  FourCC ɑΉt@C̎

	VSSFXCREATEINSTANCE CreateInstance;			//  fR[_CX^X֐
	VSSFXCONFIGDIALOG ConfigDialog;				//  ݒp[__CAO\֐
	VSSFXFREEPARAM FreeParam;					//  ݒp[^֐
	VSSENCGETPARAM GetParam;					//  ݂̃p[^擾֐
	VSSFXCOPYPARAM CopyParam;					//  p[^Rs[֐
};
typedef VSSFXINFO * LPVSSFXINFO;
typedef const VSSFXINFO * LPCVSSFXINFO;

typedef NVRESULT (WINAPI * VSSDECGETINFO) (LPVSSDECINFO lpInfo);
typedef NVRESULT (WINAPI * VSSENCGETINFO) (LPVSSENCINFO lpInfo);
typedef NVRESULT (WINAPI * VSSFXGETINFO) (LPVSSFXINFO lpInfo);

struct VSSPLUGININFO
{
	DWORD dwVersion;			//  o[Wԍ
	LPCTSTR lpcszLibraryName;	//  Cu
	LPCTSTR lpcszAuthorName;	//  Җ
	LPCTSTR lpcszURL;			//  URL
	LPCTSTR lpcszDescription;	//  ̑

	VSSDECGETINFO VSSDecGetInfo;	//  fR[_擾
	VSSENCGETINFO VSSEncGetInfo;	//  GR[_擾
	VSSFXGETINFO VSSFXGetInfo;		//  tB^擾
};
typedef VSSPLUGININFO * LPVSSPLUGININFO;
typedef const VSSPLUGININFO * LPCVSSPLUGININFO;

typedef NVRESULT (WINAPI * VSSGETPLUGININFO)(LPVSSPLUGININFO lpInfo);

struct VSSDECENTRY
{
	DWORD dwPriority;
	DWORD dwFourCC;
	_tstring SupportedFileType;
	_tstring LibraryName;
	_tstring AuthorName;
	_tstring Description;
	_tstring URL;
	VSSDECISSUPPORTED IsSupported;			//  t@C`FbN֐
	VSSDECCREATEINSTANCE CreateInstance;		//  fR[_CX^X֐
	VSSDECCONFIGDIALOG ConfigDialog;			//  ݒp[__CAO\֐
};
typedef VSSDECENTRY * LPVSSDECENTRY;
typedef const VSSDECENTRY * LPCVSSDECENTRY;

typedef std::vector<VSSDECENTRY> VSSDECLIST;
typedef VSSDECLIST * LPVSSDECLIST;
typedef const VSSDECLIST * LPCVSSDECLIST;

struct VSSENCENTRY
{
	DWORD dwPriority;
	DWORD dwFourCC;
	_tstring SupportedFileType;
	_tstring LibraryName;
	_tstring AuthorName;
	_tstring Description;
	_tstring URL;
	_tstring DefaultExtension;
	VSSENCCREATEINSTANCE CreateInstance;		//  fR[_CX^X֐
	VSSENCCONFIGDIALOG ConfigDialog;			//  ݒp[__CAO\֐
	VSSENCFREEPARAM FreeParam;					//  ݒp[^֐
	VSSENCGETPARAM GetParam;					//  ݂̃p[^擾֐
	VSSENCCOPYPARAM CopyParam;					//  p[^Rs[֐
};
typedef VSSENCENTRY * LPVSSENCENTRY;
typedef const VSSENCENTRY * LPCVSSENCENTRY;

typedef std::vector<VSSENCENTRY> VSSENCLIST;
typedef VSSENCLIST * LPVSSENCLIST;
typedef const VSSENCLIST * LPCVSSENCLIST;

struct VSSFXENTRY
{
	DWORD dwPriority;
	DWORD dwFourCC;
	_tstring SupportedFileType;
	_tstring LibraryName;
	_tstring AuthorName;
	_tstring Description;
	_tstring URL;
	VSSFXCREATEINSTANCE CreateInstance;		//  fR[_CX^X֐
	VSSFXCONFIGDIALOG ConfigDialog;			//  ݒp[__CAO\֐
	VSSFXFREEPARAM FreeParam;				//  ݒp[^֐
	VSSFXGETPARAM GetParam;					//  ݂̃p[^擾֐
	VSSFXCOPYPARAM CopyParam;					//  p[^Rs[֐
};
typedef VSSFXENTRY * LPVSSFXENTRY;
typedef const VSSFXENTRY * LPCVSSFXENTRY;

typedef std::vector<VSSFXENTRY> VSSFXLIST;
typedef VSSFXLIST * LPVSSFXLIST;
typedef const VSSFXLIST * LPCVSSFXLIST;



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  IVSSManager
//


//  NXʎq
#define VSSMANAGER_FOURCC MAKEFOURCC('V', 'S', 'S', 'M')


/*  IVSSM NXWXg (VCOM.ini ւ̋Lq)
[VSSM]

Class_ID = "VSSM"
Module_Name = "NVAFLib.dll"
Entry_Point = "CreateInstance_VSSManager"
Dependence = ""
*/


class Class_VSSManager;
typedef Class_VSSManager * IVSSMANAGER;
typedef const Class_VSSManager * CIVSSMANAGER;
typedef IVSSMANAGER * LPIVSSMANAGER;
typedef const IVSSMANAGER * LPCIVSSMANAGER;


//  IVSSMANAGER ̏f[^
struct VSSMANAGERCREATE		//  vsmc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO
};
typedef VSSMANAGERCREATE * LPVSSMANAGERCREATE;
typedef const VSSMANAGERCREATE * LPCVSSMANAGERCREATE;


//  IVSSMANAGER ̕ێf[^
struct VSSMANAGERDATA		//  vssmd
{
	LPVSSDECLIST lpDecList;
	LPVSSENCLIST lpEncList;
	LPVSSFXLIST lpFXList;
};
typedef VSSMANAGERDATA * LPVSSMANAGERDATA;
typedef const VSSMANAGERDATA * LPCVSSMANAGERDATA;



class NVAFLIB_CLASS_EXPORT Class_VSSManager : virtual public Class_VCOM
{
	public:
		Class_VSSManager(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_VSSManager(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT DecGetFileTypeFourCC(LPCTSTR lpcszFileName, LPDWORD lpdwFourCC);
	VCOM_CLASSMETHOD
		NVRESULT DecGetFileTypeFourCCByStream(INVSTREAM invst, LPDWORD lpdwFourCC);
	VCOM_CLASSMETHOD
		NVRESULT DecCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface);
	VCOM_CLASSMETHOD
		NVRESULT DecEnumPlugin(LPVSSDECENTRY lpInfo, LPDWORD lpdwCount);
	VCOM_CLASSMETHOD
		HWND DecConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner);
	VCOM_CLASSMETHOD
		NVRESULT DecSetPriority(DWORD dwFourCC, DWORD dwPriority);
	VCOM_CLASSMETHOD
		NVRESULT DecWriteSetting(void);

	VCOM_CLASSMETHOD
		NVRESULT EncCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface);
	VCOM_CLASSMETHOD
		NVRESULT EncEnumPlugin(LPVSSENCENTRY lpInfo, LPDWORD lpdwCount);
	VCOM_CLASSMETHOD
		HWND EncConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam);
	VCOM_CLASSMETHOD
		NVRESULT EncFreeParam(DWORD dwFourCC, LPVOID lpvParam);
	VCOM_CLASSMETHOD
		NVRESULT EncGetParam(DWORD dwFourCC, LPVOID *lplpvParam);
	VCOM_CLASSMETHOD
		NVRESULT EncCopyParam(DWORD dwFourCC, LPVOID *lplpvDest, LPVOID lpvSrc);

	VCOM_CLASSMETHOD
		NVRESULT FXCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface);
	VCOM_CLASSMETHOD
		NVRESULT FXEnumPlugin(LPVSSFXENTRY lpInfo, LPDWORD lpdwCount);
	VCOM_CLASSMETHOD
		HWND FXConfigDialog(DWORD dwFourCC, HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam);
	VCOM_CLASSMETHOD
		NVRESULT FXFreeParam(DWORD dwFourCC, LPVOID lpvParam);
	VCOM_CLASSMETHOD
		NVRESULT FXGetParam(DWORD dwFourCC, LPVOID *lplpvParam);
	VCOM_CLASSMETHOD
		NVRESULT FXCopyParam(DWORD dwFourCC, LPVOID *lplpvDest, LPVOID lpvSrc);
protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B
protected:
	VSSMANAGERDATA vsmd;

};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_VSSManager(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  IVSSMANAGER CX^X쐬ÃC^[tF[XԂ


inline void SetVSSManagerCreate(LPVSSMANAGERCREATE lpvsmc, DWORD dwFlag);
//  VSSMANAGERCREATE \̏֐
//
//  LPVSSMANAGERCREATE lpvsmc		\
//  DWORD dwFlag					ZbgtO



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetVSSManagerCreate(LPVSSMANAGERCREATE lpvsmc, DWORD dwFlag)
{
	lpvsmc->dwFourCC = VSSMANAGER_FOURCC;
	lpvsmc->dwObjSize = sizeof(VSSMANAGERCREATE);
	lpvsmc->dwFlag = dwFlag;

	return;
}



#pragma pack(pop)

#ifdef __cplusplus
}
#endif
