//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  ėpW[  \[Xt@C  for  NVLibraryCore                                          //
//  NVCommon.cpp                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVCommon.h"
#include <mbctype.h>
#include "NVMemory.h"
#include <mbstring.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <intrin.h>


#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "version.lib")


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  萔̒`
//

const static LONG lplThreadPriority[THREAD_PRIORITY_MAX] = {
	THREAD_PRIORITY_IDLE, THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL,
	THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST, THREAD_PRIORITY_TIME_CRITICAL,
};

static LPNVDLGLIST lpnvdlglst;

CRITICAL_SECTION crSafeLock;

NVRESULT NVPrepareSafeLock(void);
NVRESULT NVUnPrepareSafeLock(void);

extern DWORD dwVCOMCPUType;

#define NVDEADLOCK_GUARD 10000

static int CALLBACK FontEnumProc(const LOGFONT *lpclf, const TEXTMETRIC *lpctm, DWORD FontType, LPARAM lParam);

CRITICAL_SECTION crDialogList;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//

LONGLONG NVLIBCORE_EXPORT NVLIBCORE_API NVMulAddDiv64(LONGLONG a, LONGLONG b, LONGLONG c, LONGLONG d)
{
    /*  Compute the absolute values to avoid signed arithmetic problems */
    ULARGE_INTEGER ua, ub;
    DWORDLONG uc;

    ua.QuadPart = (DWORDLONG)(a >= 0 ? a : -a);
    ub.QuadPart = (DWORDLONG)(b >= 0 ? b : -b);
    uc          = (DWORDLONG)(c >= 0 ? c : -c);
    BOOL bSign = (a < 0) ^ (b < 0);

    /*  Do long multiplication */
    ULARGE_INTEGER p[2];
    p[0].QuadPart  = UInt32x32To64(ua.LowPart, ub.LowPart);

    /*  This next computation cannot overflow into p[1].HighPart because
        the max number we can compute here is:

                 (2 ** 32 - 1) * (2 ** 32 - 1) +  // ua.LowPart * ub.LowPart
    (2 ** 32) *  (2 ** 31) * (2 ** 32 - 1) * 2    // x.LowPart * y.HighPart * 2

    == 2 ** 96 - 2 ** 64 + (2 ** 64 - 2 ** 33 + 1)
    == 2 ** 96 - 2 ** 33 + 1
    < 2 ** 96
    */

    ULARGE_INTEGER x;
    x.QuadPart     = UInt32x32To64(ua.LowPart, ub.HighPart) +
                     UInt32x32To64(ua.HighPart, ub.LowPart) +
                     p[0].HighPart;
    p[0].HighPart  = x.LowPart;
    p[1].QuadPart  = UInt32x32To64(ua.HighPart, ub.HighPart) + x.HighPart;

    if (d != 0) {
        ULARGE_INTEGER ud[2];
        if (bSign) {
            ud[0].QuadPart = (DWORDLONG)(-d);
            if (d > 0) {
                /*  -d < 0 */
                ud[1].QuadPart = (DWORDLONG)(LONGLONG)-1;
            } else {
                ud[1].QuadPart = (DWORDLONG)0;
            }
        } else {
            ud[0].QuadPart = (DWORDLONG)d;
            if (d < 0) {
                ud[1].QuadPart = (DWORDLONG)(LONGLONG)-1;
            } else {
                ud[1].QuadPart = (DWORDLONG)0;
            }
        }
        /*  Now do extended addition */
        ULARGE_INTEGER uliTotal;

        /*  Add ls DWORDs */
        uliTotal.QuadPart  = (DWORDLONG)ud[0].LowPart + p[0].LowPart;
        p[0].LowPart       = uliTotal.LowPart;

        /*  Propagate carry */
        uliTotal.LowPart   = uliTotal.HighPart;
        uliTotal.HighPart  = 0;

        /*  Add 2nd most ls DWORDs */
        uliTotal.QuadPart += (DWORDLONG)ud[0].HighPart + p[0].HighPart;
        p[0].HighPart      = uliTotal.LowPart;

        /*  Propagate carry */
        uliTotal.LowPart   = uliTotal.HighPart;
        uliTotal.HighPart  = 0;

        /*  Add MS DWORDLONGs - no carry expected */
        p[1].QuadPart     += ud[1].QuadPart + uliTotal.QuadPart;

        /*  Now see if we got a sign change from the addition */
        if ((LONG)p[1].HighPart < 0) {
            bSign = !bSign;

            /*  Negate the current value (ugh!) */
            p[0].QuadPart  = ~p[0].QuadPart;
            p[1].QuadPart  = ~p[1].QuadPart;
            p[0].QuadPart += 1;
            p[1].QuadPart += (p[0].QuadPart == 0);
        }
    }

    /*  Now for the division */
    if (c < 0) {
        bSign = !bSign;
    }


    /*  This will catch c == 0 and overflow */
    if (uc <= p[1].QuadPart) {
        return bSign ? (LONGLONG)0x8000000000000000 :
                       (LONGLONG)0x7FFFFFFFFFFFFFFF;
    }

    DWORDLONG ullResult;

    /*  Do the division */
    /*  If the dividend is a DWORD_LONG use the compiler */
    if (p[1].QuadPart == 0) {
        ullResult = p[0].QuadPart / uc;
        return bSign ? -(LONGLONG)ullResult : (LONGLONG)ullResult;
    }

    /*  If the divisor is a DWORD then its simpler */
    ULARGE_INTEGER ulic;
    ulic.QuadPart = uc;
    if (ulic.HighPart == 0) {
        ULARGE_INTEGER uliDividend;
        ULARGE_INTEGER uliResult;
        DWORD dwDivisor = (DWORD)uc;
        // ASSERT(p[1].HighPart == 0 && p[1].LowPart < dwDivisor);
        uliDividend.HighPart = p[1].LowPart;
        uliDividend.LowPart = p[0].HighPart;
#ifndef USE_LARGEINT
        uliResult.HighPart = (DWORD)(uliDividend.QuadPart / dwDivisor);
        p[0].HighPart = (DWORD)(uliDividend.QuadPart % dwDivisor);
        uliResult.LowPart = 0;
        uliResult.QuadPart = p[0].QuadPart / dwDivisor + uliResult.QuadPart;
#else
        /*  NOTE - this routine will take exceptions if
            the result does not fit in a DWORD
        */
        if (uliDividend.QuadPart >= (DWORDLONG)dwDivisor) {
            uliResult.HighPart = EnlargedUnsignedDivide(
                                     uliDividend,
                                     dwDivisor,
                                     &p[0].HighPart);
        } else {
            uliResult.HighPart = 0;
        }
        uliResult.LowPart = EnlargedUnsignedDivide(
                                 p[0],
                                 dwDivisor,
                                 NULL);
#endif
        return bSign ? -(LONGLONG)uliResult.QuadPart :
                        (LONGLONG)uliResult.QuadPart;
    }


    ullResult = 0;

    /*  OK - do long division */
    for (int i = 0; i < 64; i++) {
        ullResult <<= 1;

        /*  Shift 128 bit p left 1 */
        p[1].QuadPart <<= 1;
        if ((p[0].HighPart & 0x80000000) != 0) {
            p[1].LowPart++;
        }
        p[0].QuadPart <<= 1;

        /*  Compare */
        if (uc <= p[1].QuadPart) {
            p[1].QuadPart -= uc;
            ullResult += 1;
        }
    }

    return bSign ? - (LONGLONG)ullResult : (LONGLONG)ullResult;
}


int NVLIBCORE_EXPORT NVLIBCORE_API NVCreateEscapeCode(LPTSTR pszString, int nLength)
{
	LPTSTR pszCur = pszString;
	while (pszCur[0])
	{
#ifndef _UNICODE
		if (IsDBCSLeadByteEx(CP_ACP, pszCur[0]))
		{
			pszCur++;
		}
		else
#endif
		{
			if (pszCur[0] == TEXT('\\'))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('\\');
				pszCur++;
			}
			else if (pszCur[0] == TEXT('\r'))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('r');
				pszCur++;
			}
			else if (pszCur[0] == TEXT('\n'))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('n');
				pszCur++;
			}
			else if (pszCur[0] == TEXT('\t'))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('t');
				pszCur++;
			}
			else if (pszCur[0] == TEXT('\''))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('\'');
				pszCur++;
			}
			else if (pszCur[0] == TEXT('\"'))
			{
				memmove_s(pszCur + 2, (pszString + nLength - pszCur - 2) * sizeof(TCHAR), pszCur + 1, (pszString + nLength - pszCur - 2) * sizeof(TCHAR));
				pszCur[0] = TEXT('\\');
				pszCur[1] = TEXT('\"');
				pszCur++;
			}
		}
		pszCur++;
	}
	return 0;
}

int NVLIBCORE_EXPORT NVLIBCORE_API NVProcessEscapeCode(LPTSTR pszString, int nLength)
{
	LPTSTR pszCur = pszString;
	while (pszCur[0] && pszCur[1])
	{
#ifndef _UNICODE
		if (IsDBCSLeadByteEx(CP_ACP, pszCur[0]))
		{
			pszCur++;
		}
		else
#endif
		{
			if (pszCur[0] == TEXT('\\'))
			{
				if (pszCur[1] == TEXT('\\'))
				{
					pszCur[0] = TEXT('\\');
				}
				else if (pszCur[1] == TEXT('0'))
				{
					pszCur[0] = TEXT('\0');
				}
				else if (pszCur[1] == TEXT('r'))
				{
					pszCur[0] = TEXT('\r');
				}
				else if (pszCur[1] == TEXT('n'))
				{
					pszCur[0] = TEXT('\n');
				}
				else if (pszCur[1] == TEXT('t'))
				{
					pszCur[0] = TEXT('\t');
				}
				else if (pszCur[1] == TEXT('\''))
				{
					pszCur[0] = TEXT('\'');
				}
				else if (pszCur[1] == TEXT('\"'))
				{
					pszCur[0] = TEXT('\"');
				}
				else
				{
					pszCur++;
					continue;
				}
				_tcscpy_s(pszCur + 1, (pszString + nLength - pszCur - 2), pszCur + 2);
			}
		}
		pszCur++;
	}

	return 0;
}

int NVLIBCORE_EXPORT NVLIBCORE_API NVLoadString(HINSTANCE hInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax)
{
	int ret = LoadString(hInstance, uID, lpBuffer, nBufferMax);
	if (ret >= 2)
	{
		NVProcessEscapeCode(lpBuffer, nBufferMax);
	}

	return ret;
}

int NVLIBCORE_EXPORT NVLIBCORE_API NVGetConfigFileDirectory(LPTSTR pszConfigFileDirectory, int len)
{
	extern TCHAR g_szConfigFileDirectory[NV_PATHMAX];

	if (pszConfigFileDirectory)
	{
		_tcsncpy_s(pszConfigFileDirectory, len, g_szConfigFileDirectory, len - 1);
	}

	return (int) _tcslen(g_szConfigFileDirectory) + 1;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetPluginDirectory(LPTSTR pszPluginDirectory, int len)
{
	TCHAR szPluginDirectory[NV_PATHMAX];

	GetModuleFileName(NULL, szPluginDirectory, NV_PATHMAX);
	PathRemoveFileSpec(szPluginDirectory);
	PathAppend(szPluginDirectory, TEXT("Plugin"));
	_tcsncpy_s(pszPluginDirectory, len, szPluginDirectory, len - 1);
	return NV_OK;
}

#include <list>

typedef std::list<_tstring> STRLIST;
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVPathCanonicalize(LPTSTR pszDest, LPCTSTR pszSrc, int len)
{
	STRLIST strList;

	pszDest[0] = TEXT('\0');
	for ( ; ; )
	{
		LONG i = 0;
		TCHAR tmp[NV_PATHMAX];

		NVGetFirstPath(pszSrc, &i);
		if (i <= 0 && (! pszSrc[0]))
		{
			break;
		}

		if (pszSrc[i] == TEXT('\\'))
		{
			i++;
		}
		_tcsncpy_s(tmp, NV_PATHMAX, pszSrc, min(i + 1, NV_PATHMAX) - 1);
		tmp[i] = TEXT('\0');
		if (_tcsicmp(tmp, TEXT(".\\")) == 0 || _tcsicmp(tmp, TEXT(".")) == 0)
		{
		}
		else if (_tcsicmp(tmp, TEXT("..\\")) == 0 || _tcsicmp(tmp, TEXT("..")) == 0)
		{
			strList.pop_back();
		}
		else
		{
			strList.push_back(tmp);
		}
		pszSrc += i;
	}

	STRLIST::iterator it;

	for (it = strList.begin(); it != strList.end(); it++)
	{
		_tcsncpy_s(pszDest, len, it->c_str(), len - 1);
		pszDest += it->size();
		len -= (int) it->size();
		if (len <= 0)
		{
			break;
		}
	}

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVPathCanonicalizeToString(_tstring& stDest, LPCTSTR pszSrc)
{
	STRLIST strList;

	stDest.clear();
	for ( ; ; )
	{
		LONG i = 0;
		TCHAR tmp[NV_PATHMAX];

		NVGetFirstPath(pszSrc, &i);
		if (i <= 0 && (! pszSrc[0]))
		{
			break;
		}

		if (pszSrc[i] == TEXT('\\'))
		{
			i++;
		}
		_tcsncpy_s(tmp, NV_PATHMAX, pszSrc, min(i + 1, NV_PATHMAX) - 1);
		tmp[i] = TEXT('\0');
		if (_tcsicmp(tmp, TEXT(".\\")) == 0 || _tcsicmp(tmp, TEXT(".")) == 0)
		{
		}
		else if (_tcsicmp(tmp, TEXT("..\\")) == 0 || _tcsicmp(tmp, TEXT("..")) == 0)
		{
			strList.pop_back();
		}
		else
		{
			strList.push_back(tmp);
		}
		pszSrc += i;
	}

	STRLIST::iterator it;

	for (it = strList.begin(); it != strList.end(); it++)
	{
		stDest.append(*it);
	}

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileVersion(LPTSTR lpszPath, LPQLONG lpqlFileVersion)
{   
    if(lpszPath == NULL)
	{
		if (lpqlFileVersion == NULL)
		{
			return NVERR_UNDEFINED;
		}
		else
		{
			*lpqlFileVersion = 0;
			return NV_OK;
		}
	}
	else if (lpqlFileVersion == NULL)
	{
		return NVERR_UNDEFINED;
	}

    DWORD dwHandle = 0;
    UINT uiSize;

	*lpqlFileVersion = 0;

    uiSize = GetFileVersionInfoSize(lpszPath, &dwHandle);
    if (uiSize > 0)
    {
        BYTE * lpFileVersionBuffer = new BYTE[uiSize];
        if (lpFileVersionBuffer == NULL)
		{
            return NVERR_UNDEFINED;
		}

        if (GetFileVersionInfo(lpszPath, 0, uiSize, lpFileVersionBuffer))
        {
            VS_FIXEDFILEINFO * lpVersion = NULL;

            if (VerQueryValue(lpFileVersionBuffer, TEXT("\\"), (LPVOID *) &lpVersion, &uiSize) && lpVersion != NULL)
            {
                *(((LPLONG)lpqlFileVersion) + 0) = lpVersion->dwFileVersionLS;
                *(((LPLONG)lpqlFileVersion) + 1) = lpVersion->dwFileVersionMS;
                delete [] lpFileVersionBuffer;
                return NV_OK;
            }
        }

        delete [] lpFileVersionBuffer;
    }

    return NVERR_UNDEFINED;
}

DWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileAttributes(LPCTSTR lpFileName)
{
#ifdef _UNICODE
	TCHAR szFileName[NV_PATHMAX];

	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);

	const static LPCTSTR lpPreFix[2] = { TEXT("\\\\?\\"), TEXT("\\\\?\\UNC") };
	const static DWORD dwPreLen[2] = { 4, 7 };
	DWORD dwPreFlag = (_tcslen(szFileName) > 2 && szFileName[0] == TEXT('\\') && szFileName[1] == TEXT('\\')) ? 1 : 0;

	TCHAR sz[NV_PATHMAX + 7];
	CopyMemory(sz, lpPreFix[dwPreFlag], dwPreLen[dwPreFlag] * sizeof(WCHAR));
	_tcscpy_s(sz + dwPreLen[dwPreFlag], NV_PATHMAX, szFileName + dwPreFlag);
	return GetFileAttributes(sz);
#else
	#pragma message("ӁFMultiByte ł NVGetFileAttributes ́AMAX_PATH ȏ̃tpXɃANZXł܂B")
	TCHAR szFileName[NV_PATHMAX];

	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);

	return GetFileAttributes(szFileName);
#endif
}

HANDLE NVLIBCORE_EXPORT NVLIBCORE_API NVFindFirstFile(LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData)
{
#ifdef _UNICODE
	TCHAR szFileName[NV_PATHMAX];

	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);

	const static LPCTSTR lpPreFix[2] = { TEXT("\\\\?\\"), TEXT("\\\\?\\UNC") };
	const static DWORD dwPreLen[2] = { 4, 7 };
	DWORD dwPreFlag = (_tcslen(szFileName) > 2 && szFileName[0] == TEXT('\\') && szFileName[1] == TEXT('\\')) ? 1 : 0;

	TCHAR sz[NV_PATHMAX + 7];
	CopyMemory(sz, lpPreFix[dwPreFlag], dwPreLen[dwPreFlag] * sizeof(WCHAR));
	_tcscpy_s(sz + dwPreLen[dwPreFlag], NV_PATHMAX, szFileName + dwPreFlag);
	return FindFirstFile(sz, lpFindFileData);
#else
	#pragma message("ӁFMultiByte ł NVFindFirstFile ́AMAX_PATH ȏ̃tpXɃANZXł܂B")
	TCHAR szFileName[NV_PATHMAX];

	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);

	return FindFirstFile(szFileName, lpFindFileData);
#endif
}

/*
BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVFindNextFile(HANDLE hFindFile, LPWIN32_FIND_DATA lpFindFileData)
{
	return FindNextFileWProc(hFindFile, &ffd);
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVFindClose(HANDLE hFindFile)
{
	return FindCloseWProc(hFindFile);
}
*/

HANDLE NVLIBCORE_EXPORT NVLIBCORE_API NVCreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
												   LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
												   DWORD dwFlagsAndAttributes, HANDLE hTemplateFile)
{
#ifdef _UNICODE
	TCHAR szFileName[NV_PATHMAX];
	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);

	const static LPCTSTR lpPreFix[2] = { TEXT("\\\\?\\"), TEXT("\\\\?\\UNC") };
	const static DWORD dwPreLen[2] = { 4, 7 };
	DWORD dwPreFlag = (_tcslen(szFileName) > 2 && szFileName[0] == TEXT('\\') && szFileName[1] == TEXT('\\')) ? 1 : 0;

	TCHAR sz[NV_PATHMAX + 7];
	CopyMemory(sz, lpPreFix[dwPreFlag], dwPreLen[dwPreFlag] * sizeof(WCHAR));
	_tcscpy_s(sz + dwPreLen[dwPreFlag], NV_PATHMAX, szFileName + dwPreFlag);
	return CreateFile(sz, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);
#else
	#pragma message("ӁFMultiByte ł NVCreateFile ́AMAX_PATH ȏ̃tpXɃANZXł܂B")
	TCHAR szFileName[NV_PATHMAX];

	NVPathCanonicalize(szFileName, lpFileName, NV_PATHMAX);
	return CreateFile(szFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);
#endif
}

static int CALLBACK FontEnumProc(const LOGFONT *lpclf, const TEXTMETRIC *lpctm, DWORD FontType, LPARAM lParam)
{
	if (lParam)
	{
		*((LONG *)lParam) = FontType;
	}
	return FontType;
}

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetFontType(LPCTSTR lpcszFontFaceName)
{
	LONG FontType = 0;
	HDC hdc = CreateCompatibleDC(NULL);

	EnumFontFamilies(hdc, lpcszFontFaceName, FontEnumProc, (LPARAM)(&FontType));
	DeleteDC(hdc);
	return FontType;
}


BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVIsUTF8(LPCSTR utf8, LONG lLength)
{
	LONG len = (lLength >= 0) ? lLength : lstrlenA(utf8) + 1;
	DWORD result = 0;
	LONG i;
	LONG count;
	DWORD cur;

	while (len > 0)
	{
		cur = *utf8;
		
		if ((cur & 0x80) == 0)
		{
			count = 1;
		}
		else if ((cur & 0xE0) == 0xC0)
		{
			count = 2;
		}
		else if ((cur & 0xF0) == 0xE0)
		{
			count = 3;
		}
		else if ((cur & 0xF8) == 0xF0)
		{
			count = 4;
		}
		else if ((cur & 0xFC) == 0xF8)
		{
			count = 5;
		}
		else if ((cur & 0xFE) == 0xFC)
		{
			count = 6;
		}
		else
		{
			return FALSE;
		}

		if (len < count)
		{
			return FALSE;
		}

		if (count == 2 && (cur & 0x1E) == 0)
		{
			return FALSE;
		}

		if (count == 1)
		{
			result = cur;
		}
		else
		{
			result = (0xFF >> (count +1)) & cur;
		}

		for (i = 1; i < count; i++)
		{
			if ((utf8[i] & 0xC0) != 0x80)
			{
				return FALSE;
			}
			if (result == 0 && i == 2 && ((utf8[i] & 0x7F) >> (7 - count)) == 0)
			{
				return FALSE;
			}
			result = (result << 6) | (utf8[i] & 0x3F);
		}
		len -= count;
		utf8 += count;
	}

	return TRUE;
}

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVUTF8ToWideChar(LPWSTR wide, LONG lDestLen, LPCSTR utf8, LONG lSrcLen)
{
	LONG dmax = lDestLen;
	LONG smax = (lSrcLen >= 0) ? lSrcLen : lstrlenA(utf8) + 1;
	LONG dlen;
	DWORD result;
	LONG count;
	LONG i;
	DWORD cur;
	LPCSTR lpCur = utf8;
	WCHAR LastChar = L'\0';

	dlen = 0;
	while (smax > 0)
	{
		cur = *lpCur;

		if ((cur & 0x80) == 0)
		{
			count = 1;
		}
		else if ((cur & 0xE0) == 0xC0)
		{
			count = 2;
		}
		else if ((cur & 0xF0) == 0xE0)
		{
			count = 3;
		}
		else if ((cur & 0xF8) == 0xF0)
		{
			count = 4;
		}
		else if ((cur & 0xFC) == 0xF8)
		{
			count = 5;
		}
		else if ((cur & 0xFE) == 0xFC)
		{
			count = 6;
		}
		else
		{
			if (wide && LastChar != L'\0')
			{
				if (dmax > dlen)
				{
					wide[dlen] = L'\0';
				}
				else if (dmax > 0)
				{
					wide[dmax - 1] = L'\0';
				}
			}
			return -1;
		}

		if (smax < count)
		{
			if (wide && LastChar != L'\0')
			{
				if (dmax > dlen)
				{
					wide[dlen] = L'\0';
				}
				else if (dmax > 0)
				{
					wide[dmax - 1] = L'\0';
				}
			}
			return -1;
		}

		if (count == 2 && (cur & 0x1E) == 0)
		{
			if (wide && LastChar != L'\0')
			{
				if (dmax > dlen)
				{
					wide[dlen] = L'\0';
				}
				else if (dmax > 0)
				{
					wide[dmax - 1] = L'\0';
				}
			}
			return -1;
		}

		if (count == 1)
		{
			result = cur;
		}
		else
		{
			result = (0xFF >> (count + 1)) & cur;
		}

		for (i = 1; i < count; i++)
		{
			if ((lpCur[i] & 0xC0) != 0x80)
			{
				if (wide && LastChar != L'\0')
				{
					if (dmax > dlen)
					{
						wide[dlen] = L'\0';
					}
					else if (dmax > 0)
					{
						wide[dmax - 1] = L'\0';
					}
				}
				return -1;
			}

			if (result == 0 && i == 2 && ((lpCur[i] & 0x7F) >> (7 - count)) == 0)
			{
				if (wide && LastChar != L'\0')
				{
					if (dmax > dlen)
					{
						wide[dlen] = L'\0';
					}
					else if (dmax > 0)
					{
						wide[dmax - 1] = L'\0';
					}
				}
				return -1;
			}

			result = (result << 6) | (lpCur[i] & 0x3F);
		}

		if (result > 0xFFFF)
		{
			if (wide && LastChar != L'\0')
			{
				if (dmax > dlen)
				{
					wide[dlen] = L'\0';
				}
				else if (dmax > 0)
				{
					wide[dmax - 1] = L'\0';
				}
			}
			return -1;
		}

		if (wide && dmax > dlen)
		{
			wide[dlen++] = (WCHAR) result;
			LastChar = (WCHAR) result;
		}
		else
		{
			dlen++;
		}

		lpCur += count;
		smax -= count;
	}

	if (wide && LastChar != L'\0')
	{
		if (dmax > dlen)
		{
			wide[dlen] = L'\0';
		}
		else if (dmax > 0)
		{
			wide[dmax - 1] = L'\0';
			dlen = dmax - 1;
		}
	}
	return dlen;
}

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVWideCharToUTF8(LPSTR utf8, LONG lDestLen, LPCWSTR wide, LONG lSrcLen)
{
	LONG dmax = lDestLen;
	LONG smax = (lSrcLen >= 0) ? lSrcLen : lstrlenW(wide) + 1;
	LPSTR lpCur = utf8;
	LONG dlen;
	DWORD cur;
	LONG count;
	CHAR LastChar = '\0';

	dlen = 0;
	while (smax > 0)
	{
		cur = *(wide++);
		smax--;
		if (cur >= 0xD800 && cur < 0xE000)
		{
			if (lpCur && LastChar != '\0')
			{
				if (dmax > (dlen + 1))
				{
					lpCur[0] = '\0';
				}
				else if (dmax > 0)
				{
					utf8[dmax - 1] = '\0';
				}
			}
			return -1;
		}
		if (cur < 0x80)
		{
			count = 1;
		}
		else if (cur < 0x800)
		{
			count = 2;
		}
		else if (cur < 0x10000)
		{
			count = 3;
		}
		else if (cur < 0x200000)
		{
			count = 4;
		}
		else if (cur < 0x4000000)
		{
			count = 5;
		}
		else if (cur <= 0x7FFFFFFF)
		{
			count = 6;
		}
		else
		{
			if (lpCur && LastChar != '\0')
			{
				if (dmax > (dlen + 1))
				{
					lpCur[0] = '\0';
				}
				else if (dmax > 0)
				{
					utf8[dmax - 1] = '\0';
				}
			}
			return -1;
		}

		if (lpCur && dmax >= (dlen + count))
		{
			switch (count)
			{
			case 6:
				lpCur[5] = (CHAR) (0x80 | (cur & 0x3F));
				cur >>= 6;
				cur |= 0x4000000;
			case 5:
				lpCur[4] = (CHAR) (0x80 | (cur & 0x3F));
				cur >>= 6;
				cur |= 0x200000;
			case 4:
				lpCur[3] = (CHAR) (0x80 | (cur & 0x3F));
				cur >>= 6;
				cur |= 0x10000;
			case 3:
				lpCur[2] = (CHAR) (0x80 | (cur & 0x3F));
				cur >>= 6;
				cur |= 0x800;
			case 2:
				lpCur[1] = (CHAR) (0x80 | (cur & 0x3F));
				cur >>= 6;
				cur |= 0xC0;
			case 1:
				lpCur[0] = (CHAR) cur;
				LastChar = (CHAR) cur;
			}
			lpCur += count;
			dlen += count;
		}
		else
		{
			dlen += count;
		}
	}

	if (lpCur && LastChar != '\0')
	{
		if (dmax > (dlen + 1))
		{
			lpCur[0] = '\0';
		}
		else if (dmax > 0)
		{
			utf8[dmax - 1] = '\0';
		}
	}

	return dlen;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVClipWindowPos(HWND hwnd)
{
//  ^XNo[ɏdȂ鎞EBhEʒu␳Ă݂֐
//  }`fBXvClāAʂ͂ݏoꍇɂ͏Ȃ
	DesktopWorkArea WorkArea;
	WorkArea.Update();
	WorkArea.ClipWindow(hwnd);

	return NV_OK;
}


NVRESULT NVPrepareDialogList(void)
{
	if (! lpnvdlglst)
	{
		lpnvdlglst = new NVDLGLIST;
		InitializeCriticalSection(&crDialogList);
	}

	return NV_OK;
}

NVRESULT NVUnPrepareDialogList(void)
{
	if (lpnvdlglst)
	{
		delete lpnvdlglst;
		lpnvdlglst = NULL;
		DeleteCriticalSection(&crDialogList);
	}

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVRegisterDialog(HWND hwnd)
{
	EnterCriticalSection(&crDialogList);
	lpnvdlglst->insert(std::make_pair(hwnd, hwnd));
	LeaveCriticalSection(&crDialogList);

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVUnRegisterDialog(HWND hwnd)
{
	NVDLGLIST::iterator it;

	EnterCriticalSection(&crDialogList);
	it = lpnvdlglst->find(hwnd);
	if (it != lpnvdlglst->end())
	{
		lpnvdlglst->erase(it);
	}
	LeaveCriticalSection(&crDialogList);

	return NV_OK;
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVIsDialogMessage(LPMSG lpmsg)
{
	NVDLGLIST::iterator it;

	EnterCriticalSection(&crDialogList);
	for (it = lpnvdlglst->begin(); it != lpnvdlglst->end(); it++)
	{
		HWND hwnd = (*it).second;
		LeaveCriticalSection(&crDialogList);
		if (IsDialogMessage(hwnd, lpmsg))
		{
			return TRUE;
		}
		EnterCriticalSection(&crDialogList);
		it = lpnvdlglst->find(hwnd);
	}

	LeaveCriticalSection(&crDialogList);
	return FALSE;
}

LPCTSTR NVLIBCORE_EXPORT NVLIBCORE_API NVGetCommandOption(LPCTSTR lpcszCommandLine, LPTSTR lpszOption, DWORD dwSize)
{
#ifdef _UNICODE
	if (dwSize < 1)
	{
		return NULL;
	}

	dwSize--;

	if (! lpcszCommandLine)
	{
		lpcszCommandLine = GetCommandLine();
	}

	while (*lpcszCommandLine == TEXT(' ') && *lpcszCommandLine != TEXT('\0'))
	{
		lpcszCommandLine++;
	}

	if (*lpcszCommandLine == TEXT('\"'))
	{
		lpcszCommandLine++;
		while (*lpcszCommandLine != TEXT('\"') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			*(lpszOption++) = *(lpcszCommandLine++);
			dwSize--;
		}
		if (*lpcszCommandLine == TEXT('\"'))
		{
			lpcszCommandLine++;
		}
		*lpszOption = TEXT('\0');
	}
	else if (*lpcszCommandLine)
	{
		while (*lpcszCommandLine != TEXT(' ') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			*(lpszOption++) = *(lpcszCommandLine++);
			dwSize--;
		}
		*lpszOption = TEXT('\0');
	}
	else
	{
		return NULL;
	}

	return lpcszCommandLine;
#else
	if (dwSize < 1)
	{
		return NULL;
	}

	dwSize--;

	if (! lpcszCommandLine)
	{
		lpcszCommandLine = GetCommandLine();
	}

	while (*lpcszCommandLine == TEXT(' ') && *lpcszCommandLine != TEXT('\0'))
	{
		lpcszCommandLine = (LPCTSTR) _mbsinc((unsigned char *)lpcszCommandLine);
	}

	if (*lpcszCommandLine == TEXT('\"'))
	{
		lpcszCommandLine = (LPCTSTR) _mbsinc((unsigned char *)lpcszCommandLine);
		while (*lpcszCommandLine != TEXT('\"') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			if (IsDBCSLeadByteEx(0, *lpcszCommandLine))
			{
				if (dwSize < 2)
				{
					break;
				}
				*(lpszOption++) = *(lpcszCommandLine++);
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize -= 2;
			}
			else
			{
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize--;
			}
		}
		if (*lpcszCommandLine == TEXT('\"'))
		{
			lpcszCommandLine++;
		}
		*lpszOption = TEXT('\0');
	}
	else if (*lpcszCommandLine)
	{
		while (*lpcszCommandLine != TEXT(' ') && *lpcszCommandLine != TEXT('\0') && dwSize)
		{
			if (IsDBCSLeadByteEx(0, *lpcszCommandLine))
			{
				if (dwSize < 2)
				{
					break;
				}
				*(lpszOption++) = *(lpcszCommandLine++);
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize -= 2;
			}
			else
			{
				*(lpszOption++) = *(lpcszCommandLine++);
				dwSize--;
			}
		}
		*lpszOption = TEXT('\0');
	}
	else
	{
		return NULL;
	}

	return lpcszCommandLine;
#endif
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetProgramFileName(LPTSTR lpszBuf, DWORD dwLength)
{
	if (GetModuleFileName((HMODULE)GetModuleHandle(NULL), lpszBuf, dwLength))
	{
		return NV_OK;
	}
	else
	{
		return (NVGetCommandOption(NULL, lpszBuf, dwLength)) ? NV_OK : NVERR_UNDEFINED;
	}
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetLongFileName(LPTSTR lpszFileName, int nLength)
{
//  t@COt@Cl[ɕϊ

	WIN32_FIND_DATA ffd;
	HANDLE hffd;
	LONG i = 0;
	LONG j;
	LONG k;
	TCHAR lpszLongName[NV_PATHMAX] = TEXT("");
	TCHAR lpszBuf[NV_PATHMAX];
	TCHAR lpszAbsFileName[NV_PATHMAX];

/*  Ƃ̏œɒêŕKvȂH
	if (lpszFileName[0] == TEXT('\\') && lpszFileName[1] == TEXT('\\'))
	{
		//  lbg[NpXȂ̂ŏłȂ
		//  
		return NVERR_UNDEFINED;
	}
*/
	{
		LPTSTR lpszDummy;
		GetFullPathName(lpszFileName, nLength, lpszAbsFileName, &lpszDummy);
	}

	j = (LONG) _tcslen(lpszAbsFileName);
	//  FindFirstFile 𗘗păOt@Cl[𓾂
	do
	{
		//  ݂̈ʒu珉߂̃pX擾
		NVGetFirstPath(lpszAbsFileName + i, &k);
		if (k == 0)
		{
			//  w肳ꂽobt@Ȃ̂ŃG[
			return NVERR_UNDEFINED;
		}

		//  ݂̈ʒuAP̃pX܂ło
		_tcsncpy_s(lpszBuf, NV_PATHMAX, lpszAbsFileName, i + k);
		lpszBuf[i + k] = TEXT('\0');

		//  hCuȂ悤ɂBnr̃o[WɂẮAC:\ Ȃ񂩂FindFirstFileɈȂ݂Ȃ̂ŁB
		if (lpszBuf[2] == TEXT('\0') && _istalpha((int)lpszBuf[0]) && lpszBuf[1] == TEXT(':'))
		{
			_tcscat_s(lpszLongName, NV_PATHMAX, lpszBuf);
		}
		else
		{
			//  ݂邩ǂ`FbN
			hffd = NVFindFirstFile(lpszBuf, &ffd);
			if (hffd != NULL && hffd != INVALID_HANDLE_VALUE)
			{
				NVFindClose(hffd);
				_tcscat_s(lpszLongName, NV_PATHMAX, TEXT("\\"));
				_tcscat_s(lpszLongName, NV_PATHMAX, ffd.cFileName);
			}
			else
			{
				_tcsncpy_s(lpszLongName + _tcslen(lpszLongName), NV_PATHMAX, lpszAbsFileName + i, k);
			}
		}

		//  ݈ʒui߂āAJԂ
		i += k + 1;
	} while (i < j);

	//  hCû݂̂Ƃ͍Ōオ\\ŏI悤ɂB
	//  ɃtpXԂ̂ŁȀł悢B
	lpszLongName[2] = TEXT('\\');
	_tcsncpy_s(lpszFileName, nLength, lpszLongName, nLength - 1);
	return NV_OK;
}


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileList(LPCTSTR lpcszFileName, LPTSTR *lplpszResult, LPDWORD lpdwCount, DWORD dwFlag)
{
//  w̃fBNgȉ̑St@CXg擾

	TCHAR lpszFileName[NV_PATHMAX];

	_tcscpy_s(lpszFileName, NV_PATHMAX, lpcszFileName);

	WIN32_FIND_DATA wfd;
	HANDLE hff;

	//  ݂t@Ci܂̓fBNgjǂ`FbN
	hff = NVFindFirstFile(lpszFileName, &wfd);
	if (hff == NULL || hff == INVALID_HANDLE_VALUE)
	{
		return NV_OK;
	}
	NVFindClose(hff);

	//  Ot@Cl[ɕϊ
	PathRemoveFileSpec(lpszFileName);
	PathAppend(lpszFileName, wfd.cFileName);

	if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
	{
		//  fBNgꍇ̏
		TCHAR lpszDirectoryName[NV_PATHMAX];
		BOOL ret;

		//  fBNg̑St@CChJ[h𐶐
		_tcscpy_s(lpszDirectoryName, NV_PATHMAX, lpszFileName);
		PathAppend(lpszFileName, TEXT("*.*"));

		if (dwFlag & (NVGETFILELIST_INCLUDEDIRECTORY | NVGETFILELIST_DIRECTORYONLY))
		{
			//  fBNg񋓂ꍇ

			//  obt@ȂΊmۂAΊg
			if (! *lplpszResult)
			{
				*lplpszResult = (LPTSTR) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, NV_PATHMAX);
			}
			else
			{
				*lplpszResult = (LPTSTR) NVMemReAlloc(*lplpszResult, ((*lpdwCount) + 1) * NV_PATHMAX, NVMEM_FIXED | NVMEM_ZEROINIT);
			}

			//  obt@Ɋi[B
			_tcscpy_s((*lplpszResult) + (*lpdwCount) * NV_PATHMAX, NV_PATHMAX, lpszDirectoryName);
			(*lpdwCount)++;
		}

		//  fBNgɃt@C邩ǂ`FbN
		hff = NVFindFirstFile(lpszFileName, &wfd);
		if (hff == NULL || hff == INVALID_HANDLE_VALUE)
		{
			//  ȂΏI
			return NV_OK;
		}

		//  t@Cꍇ̏

		if (_tcscmp(wfd.cFileName, TEXT(".")) && _tcscmp(wfd.cFileName, TEXT("..")))
		{
			//  ̂gAefBNgȊȌꍇAċAł̃t@Ci܂̓fBNgj
			_tcscpy_s(lpszFileName, NV_PATHMAX, lpszDirectoryName);
			PathAppend(lpszFileName, wfd.cFileName);
			NVGetFileList(lpszFileName, lplpszResult, lpdwCount, dwFlag);
		}

		//  ȂȂ܂ŁAJԂ
		for ( ; ; )
		{
			ret = NVFindNextFile(hff, &wfd);
			if (! ret)
			{
				break;
			}
			if (_tcscmp(wfd.cFileName, TEXT(".")) && _tcscmp(wfd.cFileName, TEXT("..")))
			{
				_tcscpy_s(lpszFileName, NV_PATHMAX, lpszDirectoryName);
				PathAppend(lpszFileName, wfd.cFileName);
				NVGetFileList(lpszFileName, lplpszResult, lpdwCount, dwFlag);
			}
		}

		//  nhďI
		NVFindClose(hff);
	}
	else
	{
		//  t@Cłꍇ
		if (! (dwFlag & NVGETFILELIST_DIRECTORYONLY))
		{
			//  fBNĝݗ񋓂łȂ΁Aobt@mہ^gāAi[
			if (! *lplpszResult)
			{
				*lplpszResult = (LPTSTR) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, NV_PATHMAX);
			}
			else
			{
				*lplpszResult = (LPTSTR) NVMemReAlloc(*lplpszResult, ((*lpdwCount) + 1) * NV_PATHMAX, NVMEM_FIXED | NVMEM_ZEROINIT);
			}

			_tcscpy_s((*lplpszResult) + (*lpdwCount) * NV_PATHMAX, NV_PATHMAX, lpszFileName);
			(*lpdwCount)++;
		}
	}

	return NV_OK;
}


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFirstPath(LPCTSTR lpcszFileName, LPLONG lplFirstPath)
{
//  pX̂ŏ̃fBNg擾

	LPCTSTR lpszBuf = lpcszFileName;
	LONG i;

#ifdef _UNICODE
	//  '\' ܂ŁACfbNXi߂
	for (i = 0; lpszBuf[i]; )
	{
		if (lpszBuf[i] == TEXT('\\'))
		{
			break;
		}
		else
		{
			i++;
		}
	}
#else
	//  '\' ܂ŁACfbNXi߂
	for (i = 0; lpszBuf[i]; )
	{
		if (IsDBCSLeadByteEx(0, lpszBuf[i]))
		{
			if (lpszBuf[i + 1] == TEXT('\0'))
			{
				break;
			}
			else
			{
				i += 2;
			}
		}
		else
		{
			if (lpszBuf[i] == TEXT('\\'))
			{
				break;
			}
			else
			{
				i++;
			}
		}
	}
#endif

	//  ŏ'\'̗ʒu܂͂Ȃ΂OԂ
	*lplFirstPath = i;

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVCreateDirectory(LPCTSTR lpcszDirectoryName)
{
//  fBNg쐬

	HANDLE hff;
	WIN32_FIND_DATA wfd;
	LONG k;
	TCHAR lpszBuf[NV_PATHMAX];
	LONG i = 0;
	LONG j = (LONG) _tcslen(lpcszDirectoryName);
	BOOL ret;

	//  pX𕪉ȂAfBNg쐬Ă
	do
	{
		//  ݂̈ʒu珉߂̃pX擾
		NVGetFirstPath(lpcszDirectoryName + i, &k);
		if (k == 0)
		{
			//  w肳ꂽobt@Ȃ̂ŃG[
			return NVERR_UNDEFINED;
		}

		//  ݂̈ʒuAP̃pX܂ło
		_tcsncpy_s(lpszBuf, NV_PATHMAX, lpcszDirectoryName, i + k);
		lpszBuf[i + k] = TEXT('\0');

		//  hCuȂ悤ɂBnr̃o[WɂẮAC:\ Ȃ񂩂FindFirstFileɈȂ݂Ȃ̂ŁB
		if (! (lpszBuf[2] == TEXT('\0') && _istalpha((int)lpszBuf[0]) && lpszBuf[1] == TEXT(':')))
		{
			//  ݂邩ǂ`FbN
			hff = NVFindFirstFile(lpszBuf, &wfd);
			if (hff == NULL || hff == INVALID_HANDLE_VALUE)
			{
				//  ݂Ȃ΁A쐬
				ret = CreateDirectory(lpszBuf, NULL);
				if (! ret)
				{
					return NVERR_UNDEFINED;
				}
			}
			else
			{
				NVFindClose(hff);
			}
		}

		//  ݈ʒui߂āAJԂ
		i += k + 1;
	} while (i < j);

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVCreateDirectoryFromFileName(LPCTSTR lpcszFileName)
{
//  fBNg쐬
	TCHAR szDirectory[NV_PATHMAX];

	_tcscpy_s(szDirectory, NV_PATHMAX, lpcszFileName);
	PathRemoveFileSpec(szDirectory);
	NVCreateDirectory(szDirectory);

	return NV_OK;
}

DWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetCPUType(LPTSTR lpszModel, DWORD dwLength, LPDWORD lpdwModel, LPTSTR pszCpuName)
{
	DWORD dwCPUType = 0;		//  ߂li[pϐ
	DWORD dwFlag = 0;			//  tO擾pϐ
	DWORD dwModel = 0;
	DWORD dwExt = 0;
	DWORD dwFlagEx = 0;
	DWORD dwMaxCpuId = 0;
	union
	{
		CHAR szBuf[12 + 1];
		struct
		{
			DWORD dw0;
			DWORD dw1;
			DWORD dw2;
		};
	} Ident;

	Ident.szBuf[0] = '\0';
	Ident.szBuf[12] = '\0';

	int cpuinfo[4];

	__cpuid(cpuinfo, 0);
	Ident.dw0 = (DWORD) cpuinfo[1];
	Ident.dw1 = (DWORD) cpuinfo[3];
	Ident.dw2 = (DWORD) cpuinfo[2];

	__cpuid(cpuinfo, 1);
	dwModel = cpuinfo[0];
	dwFlag = cpuinfo[3];
	dwFlagEx = cpuinfo[2];

	__cpuid(cpuinfo, 0x80000000);
	dwMaxCpuId = cpuinfo[0];
	if (dwMaxCpuId >= 0x80000001)
	{
		__cpuid(cpuinfo, 0x80000001);
		dwExt = cpuinfo[3];
	}

	if (dwFlag & 0x00800000)
	{
		dwCPUType |= CPUTYPE_MMX;
	}

	if ((dwFlag & 0x03008000) == 0x03008000)
	{
		dwCPUType |= CPUTYPE_SSE;

		//  rrd𗘗p\̏ꍇAnrT|[gĂ邩ǂׂ
		//  OubN̒ŁArrd߂s
		__try
		{
			__m128 xmm0 = _mm_setzero_ps();
			_mm_or_ps(xmm0, xmm0);
			//__asm xorps xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdtO
				dwCPUType &= (~CPUTYPE_SSE);
			}
		}
	}

	if ((dwFlag & 0x05008000) == 0x05008000)
	{
		dwCPUType |= CPUTYPE_SSE2;

		//  rrdQ𗘗p\̏ꍇAnrT|[gĂ邩ǂׂ
		//  OubN̒ŁArrdQ߂s
		__try
		{
			__m128d xmm0 = _mm_setzero_pd();
			_mm_or_pd(xmm0, xmm0);
			//xorpd xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdQtO
				dwCPUType &= (~CPUTYPE_SSE2);
			}
		}
	}

	if ((dwFlagEx & 0x1) == 0x1)
	{
		dwCPUType |= CPUTYPE_SSE3;
		//  rrdR𗘗p\̏ꍇAnrT|[gĂ邩ǂׂ
		//  OubN̒ŁArrdR߂s
		__try
		{
			__m128 xmm0 = _mm_setzero_ps();
			_mm_hadd_ps(xmm0, xmm0);
			//haddps xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdQtO
				dwCPUType &= (~CPUTYPE_SSE3);
			}
		}
	}

	if ((dwFlagEx & (0x1 << 9)) == (0x1 << 9))
	{
		dwCPUType |= CPUTYPE_SSSE3;
		__try
		{
			__m128i xmm0 = _mm_setzero_si128();
			_mm_hadd_epi16(xmm0, xmm0);
			//hadd_epi16 xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdQtO
				dwCPUType &= (~CPUTYPE_SSSE3);
			}
		}
	}
	if ((dwFlagEx & (0x1 << 19)) == (0x1 << 19))
	{
		dwCPUType |= CPUTYPE_SSE41;
		__try
		{
			__m128 xmm0 = _mm_setzero_ps();
			_mm_blend_ps(xmm0, xmm0, 0);
			//blendps xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdQtO
				dwCPUType &= (~CPUTYPE_SSE41);
			}
		}
	}
	if ((dwFlagEx & (0x1 << 20)) == (0x1 << 20))
	{
		dwCPUType |= CPUTYPE_SSE42;
/*
		__try
		{
			__m128 xmm0 = _mm_setzero_ps();
			_mm_blend_ps(xmm0, xmm0, 0);
			//blendps xmm0, xmm0;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
			{
				//  Ȗ߂ɂOꍇAnrT|[gĂȂ̂ŁArrdQtO
				dwCPUType &= (~CPUTYPE_SSE42);
			}
		}
*/
	}

	if ((dwExt & 0x80000000) == 0x80000000)
	{
		dwCPUType |= CPUTYPE_3DNOW;
	}

	if ((dwExt & 0x40000000) == 0x40000000)
	{
		dwCPUType |= CPUTYPE_E3DNOW;
	}

	if (dwMaxCpuId >= 0x80000004 && pszCpuName)
	{
		int i = 0;
		int CpuInfo[4] = { 0, };
		char szName[49];
		szName[48] = '\0';

		for (i = 0; i < 3; i++)
		{
			__cpuid(CpuInfo, 0x80000002 + i);
			CopyMemory(szName + 4 * 4 * i, CpuInfo, 4 * 4);
		}

		char *p = szName;
		while (*p == ' ')
		{
			p++;
		}

#ifdef _UNICODE
		MultiByteToWideChar(CP_ACP, 0, p, -1, pszCpuName, 49);
#else
		_tcscpy_s(pszCpuName, 49, p);
#endif
	}
	else if (pszCpuName)
	{
		pszCpuName[0] = TEXT('\0');
	}

	if (lpszModel && dwLength)
	{
#ifdef _UNICODE
		MultiByteToWideChar(CP_ACP, 0, Ident.szBuf, -1, lpszModel, dwLength);
#else
		_tcsncpy_s(lpszModel, dwLength, Ident.szBuf, dwLength - 1);
#endif
	}
	if (lpdwModel)
	{
		*lpdwModel = dwModel;
	}

	if (dwVCOMCPUType != (DWORD) -1)
	{
		return dwVCOMCPUType;
	}
	else
	{
		return dwCPUType;
	}
}

QWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetCPUFreq(BOOL bChangePriority)
{
	QWORD qwFreq;			//  botg
	DWORD dwFlag;			//  tO擾pϐ

	int cpuinfo[4];
	__cpuid(cpuinfo, 1);
	dwFlag = cpuinfo[3];

	if (dwFlag & 0x00000010)
	{
		HANDLE hProcess;
		HANDLE hThread;
		UINT uPriorityClass;
		UINT uThreadPriority;
		QWORD qwCount1;
		QWORD qwCount2;
		LARGE_INTEGER pfcfreq;
		BOOL ret;

		if (bChangePriority)
		{
			hProcess = GetCurrentProcess();
			hThread = GetCurrentThread();
			uPriorityClass = GetPriorityClass(hProcess);
			uThreadPriority = GetThreadPriority(hThread);
			SetPriorityClass(hProcess, REALTIME_PRIORITY_CLASS);
			SetThreadPriority(hThread, THREAD_PRIORITY_TIME_CRITICAL);

			while (GetPriorityClass(hProcess) != REALTIME_PRIORITY_CLASS)
			{
				Sleep(0);
			}

			while (GetThreadPriority(hThread) != THREAD_PRIORITY_TIME_CRITICAL)
			{
				Sleep(0);
			}
		}

		DWORD_PTR dwPrevThreadAffinityMask;

		dwPrevThreadAffinityMask = SetThreadAffinityMask(GetCurrentThread(), 0x1);

		ret = QueryPerformanceFrequency(&pfcfreq);
		if (ret && pfcfreq.QuadPart >= 100)
		{
			LARGE_INTEGER li1, li2, li3;
			QueryPerformanceCounter(&li1);
			li3.QuadPart = pfcfreq.QuadPart / 100;

			qwCount1 = __rdtsc();

			do
			{
				QueryPerformanceCounter(&li2);
			} while (li2.QuadPart - li1.QuadPart < li3.QuadPart);

			qwCount2 = __rdtsc();
			qwFreq = (qwCount2 - qwCount1) * pfcfreq.QuadPart / (li2.QuadPart - li1.QuadPart);
		}
		else
		{
			qwCount1 = __rdtsc();

			Sleep(100);

			qwCount2 = __rdtsc();
			qwFreq = (qwCount2 - qwCount1) * 10;
		}

		if (dwPrevThreadAffinityMask)
		{
			SetThreadAffinityMask(GetCurrentThread(), dwPrevThreadAffinityMask);
		}

		if (bChangePriority)
		{
			SetThreadPriority(hThread, uThreadPriority);
			SetPriorityClass(hProcess, uPriorityClass);
		}
	}
	else
	{
		return 0;
	}

	return qwFreq;
}

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetThreadPriorityIndex(LONG lThreadPriority)
{
//  Xbh̃vCIeBCfbNXɕϊ

	//  قe[uƂ킹ĂAe[ûق傫Ȃ炻CfbNXƂ
	LONG i;
	for (i = 0; i < THREAD_PRIORITY_MAX; i++)
	{
		if (lThreadPriority <= lplThreadPriority[i])
		{
			break;
		}
	}

	if (i >= THREAD_PRIORITY_MAX)
	{
		//  e[u̍ől (THREAD_PRIORITY_TIME_CRITICAL)傫΁AőlɃNbv
		i = 6;
	}

	return i;
}


LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetThreadPriorityValue(LONG lThreadPriorityIndex)
{
//  Xbh̃vCIeB̃CfbNXlɕϊ

	//  O`U͈̔͂ɃNbsOĂAe[uQ
	lThreadPriorityIndex = min(lThreadPriorityIndex, THREAD_PRIORITY_MAX - 1);
	lThreadPriorityIndex = max(lThreadPriorityIndex, 0);

	return lplThreadPriority[lThreadPriorityIndex];
}


BOOL NVLIBCORE_EXPORT NVLIBCORE_API SetRect64(LPRECT64 lprc, LONGLONG left, LONGLONG top, LONGLONG right, LONGLONG bottom)
{
//  RECT64 p̏֐
	lprc->left = left;
	lprc->top = top;
	lprc->right = right;
	lprc->bottom = bottom;

	return TRUE;
}


BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect64(LPRECT64 lprcResult, LPRECT64 lprc1, LPRECT64 lprc2)
{
//  RECT64 p IntersectRect

	lprcResult->left = max(lprc1->left, lprc2->left);				//  d̈ left vZ
	lprcResult->top = max(lprc1->top, lprc2->top);					//  d̈ top vZ
	lprcResult->right = min(lprc1->right, lprc2->right);			//  d̈ right vZ
	lprcResult->bottom = min(lprc1->bottom, lprc2->bottom);			//  d̈ bottom vZ

	//  Lȋ`f
	if (lprcResult->left < lprcResult->right && lprcResult->top < lprcResult->bottom)
	{
		return TRUE;
	}
	else
	{
		//  ȋ`̏ꍇAOɃZbg
		ZeroMemory(&lprcResult, sizeof(RECT64));
		return FALSE;
	}
}


BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect64_32(LPRECT64 lprcResult, LPRECT64 lprc1, LPRECT lprc2)
{
//  RECT64 p IntersectRect

	lprcResult->left = max(lprc1->left, lprc2->left);				//  d̈ left vZ
	lprcResult->top = max(lprc1->top, lprc2->top);					//  d̈ top vZ
	lprcResult->right = min(lprc1->right, lprc2->right);			//  d̈ right vZ
	lprcResult->bottom = min(lprc1->bottom, lprc2->bottom);			//  d̈ bottom vZ

	//  Lȋ`f
	if (lprcResult->left < lprcResult->right && lprcResult->top < lprcResult->bottom)
	{
		return TRUE;
	}
	else
	{
		//  ȋ`̏ꍇAOɃZbg
		ZeroMemory(&lprcResult, sizeof(RECT64));
		return FALSE;
	}
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect32_64(LPRECT64 lprcResult, LPRECT lprc1, LPRECT64 lprc2)
{
//  RECT64 p IntersectRect

	lprcResult->left = max(lprc1->left, lprc2->left);				//  d̈ left vZ
	lprcResult->top = max(lprc1->top, lprc2->top);					//  d̈ top vZ
	lprcResult->right = min(lprc1->right, lprc2->right);			//  d̈ right vZ
	lprcResult->bottom = min(lprc1->bottom, lprc2->bottom);			//  d̈ bottom vZ

	//  Lȋ`f
	if (lprcResult->left < lprcResult->right && lprcResult->top < lprcResult->bottom)
	{
		return TRUE;
	}
	else
	{
		//  ȋ`̏ꍇAOɃZbg
		ZeroMemory(&lprcResult, sizeof(RECT64));
		return FALSE;
	}
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect32_32(LPRECT64 lprcResult, LPRECT lprc1, LPRECT lprc2)
{
//  RECT64 p IntersectRect

	lprcResult->left = max(lprc1->left, lprc2->left);				//  d̈ left vZ
	lprcResult->top = max(lprc1->top, lprc2->top);					//  d̈ top vZ
	lprcResult->right = min(lprc1->right, lprc2->right);			//  d̈ right vZ
	lprcResult->bottom = min(lprc1->bottom, lprc2->bottom);			//  d̈ bottom vZ

	//  Lȋ`f
	if (lprcResult->left < lprcResult->right && lprcResult->top < lprcResult->bottom)
	{
		return TRUE;
	}
	else
	{
		//  ȋ`̏ꍇAOɃZbg
		ZeroMemory(&lprcResult, sizeof(RECT64));
		return FALSE;
	}
}


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileNameFromShortcut(HWND hwnd, LPCTSTR lpszShortcut, LPTSTR lpszFileName, DWORD dwLength)
{ 
    HRESULT hres;
    IShellLink *iLink = NULL;
	IPersistFile *iFile = NULL;
 
    *lpszFileName = 0;
 
	try
	{
		hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *) &iLink);
		if (FAILED(hres))
		{
			throw NVERR_UNDEFINED;
		}

		hres = iLink->QueryInterface(IID_IPersistFile, (LPVOID *) &iFile);
		if (FAILED(hres))
		{
			throw NVERR_UNDEFINED;
		}

#ifdef _UNICODE
		hres = iFile->Load(lpszShortcut, STGM_READ);
		if (FAILED(hres))
		{
			throw NVERR_UNDEFINED;
		}
#else
		{
			WCHAR wsz[NV_PATHMAX];
			MultiByteToWideChar(CP_ACP, 0, lpszShortcut, -1, wsz, NV_PATHMAX);

			hres = iFile->Load(wsz, STGM_READ);
			if (FAILED(hres))
			{
				throw NVERR_UNDEFINED;
			}
		}
#endif

		hres = iLink->Resolve(hwnd, SLR_ANY_MATCH | SLR_NO_UI);
		if (FAILED(hres))
		{
			throw NVERR_UNDEFINED;
		}

		{
			WIN32_FIND_DATA wfd;

			hres = iLink->GetPath(lpszFileName, dwLength, &wfd, 0/*SLGP_SHORTPATH*/);
			if (FAILED(hres))
			{
				throw NVERR_UNDEFINED;
			}
		}

		iFile->Release();
		iLink->Release();
	}
	catch (NVRESULT nvres)
	{
		if (iFile)
		{
			iFile->Release();
		}
		if (iLink)
		{
			iLink->Release();
		}

		return nvres;
	}

    return NV_OK;
} 

NVRESULT NVPrepareSafeLock(void)
{
	if (! crSafeLock.LockSemaphore)
	{
		InitializeCriticalSection(&crSafeLock);
	}

	return NV_OK;
}

NVRESULT NVUnPrepareSafeLock(void)
{
	if (crSafeLock.LockSemaphore)
	{
		DeleteCriticalSection(&crSafeLock);
		ZeroMemory(&crSafeLock, sizeof(CRITICAL_SECTION));
	}

	return NV_OK;
}

//#define LOCK_DEBUG
#ifdef LOCK_DEBUG
inline void LockDebugProc(DWORD dwFourCC, LPTSTR lpszString)
{
	TCHAR szFourCC[5];
	static FILE *fp = NULL;
	if (! fp)
	{
		_tfopen_s(&fp, TEXT("Z:\\LockDebug.txt"), TEXT("a, ccs=UTF-16LE"));
	}
	if (fp)
	{
		NVFourCCToString(dwFourCC, szFourCC, 5);
		_ftprintf(fp, TEXT("%s : %s\n"), szFourCC, lpszString);
		fflush(fp);
		//fclose(fp);
	}

	return;
}
#define LockDebug(cc, str) LockDebugProc((cc), (str))
#else
#define LockDebug(cc, str)
#endif


#ifdef NVSAFELOCK_DEADLOCK_ASSERT
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom, LPCTSTR pszFileName, long lLine, LPCTSTR pszDate, LPCTSTR pszTime)
#else
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom)
#endif
{
	EnterCriticalSection(&crSafeLock);
	NVRESULT nvres;
	if (! ivcom)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_VALUE_UNDEFINED;
	}

	__try
	{
		if (ivcom->vcd.ivcom != ivcom)
		{
			LeaveCriticalSection(&crSafeLock);
			return NVERR_UNDEFINED;
		}
		LockDebug(ivcom->vcd.dwFourCC, TEXT("LockingStart"));
		nvres = ivcom->TryLockObject();
		if (nvres == VCOMERR_VALUE_CANTLOCKOBJECT)
		{
			HANDLE lphEvent[2];
			DWORD dwRet;
			lphEvent[0] = ivcom->vcd.hEventLost;
			lphEvent[1] = ivcom->vcd.hMutexLock;
			LeaveCriticalSection(&crSafeLock);
			dwRet = WaitForMultipleObjects(2, lphEvent, FALSE, NVDEADLOCK_GUARD);
			switch (dwRet)
			{
			case WAIT_OBJECT_0 + 1:
				{
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
					ivcom->vcd.dwLockingThread = GetCurrentThreadId();
					ivcom->vcd.lRecursionCount++;
#endif
					LockDebug(ivcom->vcd.dwFourCC, TEXT("LockingEnd"));
					return NV_OK;
				}
			case WAIT_TIMEOUT:
				{
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
					TCHAR szText[2048];
					_stprintf_s(szText, 2048, TEXT("Dead lock detected.\nThis application will be unoperatable.\nCurrentThreadId:%08X\nDeadThreadId:%08X\nSourceFile:%s\nLineNumber:%d\nDate:%s\nTime:%s\n"),
						GetCurrentThreadId(), ivcom->vcd.dwLockingThread, pszFileName, lLine, pszDate, pszTime);
					MessageBox(HWND_DESKTOP, szText, TEXT("Dead lock detected."), MB_OK | MB_TOPMOST | MB_ICONASTERISK);
#endif
					LockDebug(ivcom->vcd.dwFourCC, TEXT("DeadLockDetected"));
					return VCOMERR_VALUE_CANTLOCKOBJECT;
				}
			default:
				{
					LockDebug(ivcom->vcd.dwFourCC, TEXT("LockingFailed"));
					return NVERR_UNDEFINED;
				}
			}
		}
		else if (nvres)
		{
			LockDebug(ivcom->vcd.dwFourCC, TEXT("LockingFailed"));
			LeaveCriticalSection(&crSafeLock);
			return nvres;
		}
		LockDebug(ivcom->vcd.dwFourCC, TEXT("LockingEnd"));
		LeaveCriticalSection(&crSafeLock);
		return NV_OK;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_UNDEFINED;
	}
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalTrySafeLock(IVCOM ivcom)
{
	EnterCriticalSection(&crSafeLock);
	NVRESULT nvres;
	if (! ivcom)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_UNDEFINED;
	}

	__try
	{
		if (ivcom->vcd.ivcom != ivcom)
		{
			LeaveCriticalSection(&crSafeLock);
			return NVERR_UNDEFINED;
		}
		nvres = ivcom->TryLockObject();
		LeaveCriticalSection(&crSafeLock);
		return nvres;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_UNDEFINED;
	}
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeUnLock(IVCOM ivcom)
{
	EnterCriticalSection(&crSafeLock);
	if (! ivcom)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_UNDEFINED;
	}
	__try
	{
		ivcom->UnLockObject();
		LeaveCriticalSection(&crSafeLock);
		return NV_OK;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		LeaveCriticalSection(&crSafeLock);
		return NVERR_UNDEFINED;
	}
}

HMODULE NVLIBCORE_EXPORT NVLIBCORE_API NVGetResourceDLL(void)
{
	HMODULE hModule = NULL;
	NVRESULT nvres;
	TCHAR szResourceDLL[NV_PATHMAX];


	_stprintf_s(szResourceDLL, NV_PATHMAX, TEXT("Resource0x%04X.dll"), GetUserDefaultLCID() & 0xFFFF);
	nvres = VLoadLibraryByFileName(szResourceDLL, &hModule);
	if (nvres)
	{
		nvres = VLoadLibraryByFileName(DEFAULT_RESOURCE_FILENAME, &hModule);
		if (nvres)
		{
			return NULL;
		}
	}

	return hModule;
}