//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVLibraryCore CW[ \[Xt@C  for  NVLibraryCore                           //
//  NVLibCore.cpp                                                                               //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

//#define _WIN32_DCOM
#include "NVLibCoreDef.h"
#include "NVMemory.h"
#include <CommCtrl.h>
#include <rpcsal.h>
#include <objbase.h>
#include "VCOM.h"
#include "NVCommon.h"
#include <shlobj.h>



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  O[oϐ̒`
//


HINSTANCE hinstNVLibCore;				//  DLL W[̃CX^Xnh
LONG lNVLibCoreAttatchedProcess = 0;				//  A^b`ꂽvZX̐
TCHAR g_szConfigFileDirectory[NV_PATHMAX];

#ifdef NVERROR_REPORT_ENABLE
FILE *fpFatalReport = NULL;
FILE *fpNormalReport = NULL;
#endif

extern NVRESULT NVPrepareDialogList(void);
extern NVRESULT NVUnPrepareDialogList(void);
extern NVRESULT NVPrepareSafeLock(void);
extern NVRESULT NVUnPrepareSafeLock(void);



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  O[o֐̒`
//

#ifdef NVERROR_REPORT_ENABLE

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReport(LPCTSTR lpcszFile, LONG lLine, LPCTSTR lpcszDate, LPCTSTR lpcszTime, LPCTSTR lpcszErrorName, DWORD nvres, DWORD dwFlag)
{
	switch (dwFlag)
	{
	case NVERR_SAFE:
		break;
	case NVERR_NORMAL:
		{
			time_t timenow;
			tm *tmnow;

			time(&timenow);
			tmnow = localtime(&timenow);

			if (fpNormalReport)
			{
				_ftprintf(fpNormalReport, TEXT("\nSourceFile : %s\nLine : %d\nCompileDate: %s : %s\nErrorName : %s\nErrorCode : %X\nCurrentTime : %s"),
					lpcszFile, lLine, lpcszDate, lpcszTime, lpcszErrorName, nvres, _tasctime(tmnow));
			}
		}
		break;
	default:
		{
			time_t timenow;
			tm *tmnow;

			time(&timenow);
			tmnow = localtime(&timenow);

			if (fpFatalReport)
			{
				_ftprintf(fpFatalReport, TEXT("\nSourceFile : %s\nLine : %d\nCompileDate: %s : %s\nErrorName : %s\nErrorCode : %X\nCurrentTime : %s"),
					lpcszFile, lLine, lpcszDate, lpcszTime, lpcszErrorName, nvres, _tasctime(tmnow));
			}
		}
		break;
	}

	return (NVRESULT) nvres;
}
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportStart(void)
{
	time_t timenow;
	tm *tmnow;
	TCHAR lpszBuf[1024];

	time(&timenow);
	tmnow = localtime(&timenow);

	_tcsftime(lpszBuf, 256, TEXT("LilithFatalErrorReport_%y-%m-%d=%H-%M-%S.txt"), tmnow);
	fpFatalReport = NVOpenDebugLogFile(lpszBuf, TEXT("w"));
	if (fpFatalReport)
	{
		fprintf(fpFatalReport, TEXT("\n\n\n=============== START ===============\n\nFatal Error Logging Start\nCurrentTime : %s\n"), _tasctime(tmnow));
	}

	_tcsftime(lpszBuf, 256, TEXT("LilithNormalErrorReport_%y-%m-%d=%H-%M-%S.txt"), tmnow);
	fpNormalReport = NVOpenDebugLogFile(lpszBuf, TEXT("w"));
	if (fpNormalReport)
	{
		fprintf(fpNormalReport, TEXT("\n\n\n=============== START ===============\n\nNormal Error Logging Start\nCurrentTime : %s\n"), _tasctime(tmnow));
	}
	return;
}
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportEnd(void)
{
	time_t timenow;
	tm *tmnow;

	time(&timenow);
	tmnow = localtime(&timenow);

	if (fpFatalReport)
	{
		fprintf(fpFatalReport, TEXT("\n\n\nFatal Error Logging Safe End\nCurrentTime : %s\n\n================ END ================\n\n"), _tasctime(tmnow));
		fclose(fpFatalReport);
		fpFatalReport = NULL;
	}

	if (fpNormalReport)
	{
		fprintf(fpNormalReport, TEXT("\n\n\nNormal Error Logging Safe End\nCurrentTime : %s\n\n================ END ================\n\n"), _tasctime(tmnow));
		fclose(fpNormalReport);
		fpNormalReport = NULL;
	}

	return;
}

#else

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReport(LPCTSTR lpcszFile, LONG lLine, LPCTSTR lpcszDate, LPCTSTR lpcszTime, DWORD nvres)
{
	return nvres;
}
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportStart(void)
{
	return;
}
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportEnd(void)
{
	return;
}

#endif

BOOL APIENTRY DllMain(HINSTANCE hThisInstance, DWORD dwNotification, LPVOID lpReserved)
{
	//  vZX̃A^b`^f^b`̏
	if (dwNotification == DLL_PROCESS_ATTACH)
	{
		//  A^b`ꂽvZX̃JEg
		if (InterlockedIncrement(&lNVLibCoreAttatchedProcess) == 1)
		{
			//  Xbh̃A^b`ʒmȂ悤ɂ
			DisableThreadLibraryCalls(hThisInstance);

#ifdef _CHECK_MEMORY_LEAK_
			::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif"
			NVERRORLOGSTART;

			INITCOMMONCONTROLSEX iccex = { sizeof(INITCOMMONCONTROLSEX), ICC_WIN95_CLASSES };
			NVRESULT nvres;
			HRESULT hres;

			hinstNVLibCore = hThisInstance;		//  CX^Xnh̕ۑ

			timeBeginPeriod(1);

			OSVERSIONINFO vi;
			vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
			GetVersionEx(&vi);

			GetModuleFileName(NULL, g_szConfigFileDirectory, NV_PATHMAX);
			PathRemoveFileSpec(g_szConfigFileDirectory);
			PathAppend(g_szConfigFileDirectory, TEXT("Config"));
			DWORD dwAttr = GetFileAttributes(g_szConfigFileDirectory);
			if (dwAttr == INVALID_FILE_ATTRIBUTES || (! (dwAttr & FILE_ATTRIBUTE_DIRECTORY)))
			{
				SHGetSpecialFolderPath(NULL, g_szConfigFileDirectory, CSIDL_APPDATA , FALSE);

				PathAppend(g_szConfigFileDirectory, TEXT("Project9k\\uLilith"));
				NVCreateDirectory(g_szConfigFileDirectory);
			}

			hres = CoInitialize(NULL);
			//hres = CoInitializeEx(NULL, COINIT_MULTITHREADED);
			if (FAILED(hres))
			{
				MessageBox(NULL, TEXT("An error occurred while initializing COM system."), TEXT("NVLibCore.dll Load Error!"), MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST);
				return FALSE;
			}
			InitCommonControlsEx(&iccex);		//  CommonControl ̏

			nvres = NVPrepareSafeLock();
			if (nvres)
			{
				//  [JCYΏہ
				MessageBox(NULL, TEXT("An error occurred while initializing synchronize systems."), TEXT("NVLibCore.dll Load Error!"), MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST);
				return FALSE;
			}

			nvres = NVMemPrepare();						//  Cup
			if (nvres)
			{
				//  [JCYΏہ
				MessageBox(NULL, TEXT("An error occurred while initializing memory library."), TEXT("NVLibCore.dll Load Error!"), MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST);
				return FALSE;
			}

			nvres = VCOM_Prepare();
			if (nvres)
			{
				NVMemUnPrepare();

				//  [JCYΏہ
				MessageBox(NULL, TEXT("An error occurred while initializeing VCOM library.\nVCOM.cfg file may not be found."), TEXT("NVLibCore.dll Load Error!"), MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST);
				return FALSE;
			}

			NVPrepareDialogList();
		}
	}
	else if (dwNotification == DLL_PROCESS_DETACH)
	{
		//  A^b`ꂽvZX̃JEg
		//  ÓIf[^̉
		if (InterlockedDecrement(&lNVLibCoreAttatchedProcess) == 0)
		{
			NVUnPrepareDialogList();

//  [NoݒŃRpCꂽƂ̏
#ifdef NVMEM_FINDMEMORYLEAK
			
			{
				SIZE_T cb;
				SIZE_T cb2;

				cb = NVMemGetAllocatedSize();		//  AP[gꂽTCY擾
				cb2 = NVMemGetAllocatedCount();		//  AP[gꂽ擾

				//  OłȂ΁AvÔǂŃJYĂ
				if (cb || cb2)
				{
					//  [JCYΏہ
					TCHAR lpszMessage[256];
#ifdef WIN64
					_stprintf_s(lpszMessage, 256, TEXT("%I64u oCg %I64u ̃ubNĂ܂B"), cb, cb2);
#else
					_stprintf_s(lpszMessage, 256, TEXT("%d oCg %d ̃ubNĂ܂B"), cb, cb2);
#endif
					OutputDebugString(lpszMessage);
					//MessageBox(NULL, lpszMessage, TEXT("NVLibCore Memory Leak !!!"), MB_ICONEXCLAMATION | MB_OK | MB_TOPMOST);
				}
			}
#endif
			timeEndPeriod(1);
			VCOM_UnPrepare();
			NVMemUnPrepare();	//  Cu
			NVUnPrepareSafeLock();
			CoUninitialize();
			NVERRORLOGEND;
#ifdef _DEBUG
			::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif
		}
	}

	return TRUE;
}

