//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVLibraryCore `t@C  for  NVLibraryCore                                              //
//  NVLibCoreDef.h                                                                              //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////


#pragma once


//#define NVERROR_REPORT_ENABLE


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVShare.h"



#ifdef NVERROR_REPORT_ENABLE
#include <stdio.h>
#include <time.h>
#endif



#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)


/*
#ifndef NVLIBCORE_EXPORTS
#ifdef _DEBUG
	#pragma comment(lib, "..\\DebugLib\\NVLibCore.lib")
#else
	#pragma comment(lib, "..\\ReleaseLib\\NVLibCore.lib")
#endif
#endif
*/




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//

//  DLLGNX|[gp

#define NVLIBCORE_API __stdcall

#ifdef NVLIBCORE_EXPORTS

#define NVLIBCORE_CLASS_EXPORT __declspec(dllexport)
#define NVLIBCORE_EXPORT
//#define NVLIBCORE_EXPORT __declspec(dllexport)

#else

#define NVLIBCORE_CLASS_EXPORT __declspec(dllimport)
#define NVLIBCORE_EXPORT __declspec(dllimport)

#endif	//  #ifdef NVLIBCORE_EXPORTS


//  AT[g
#ifdef NVASSERT_ENABLE

#define NVASSERT(string) assert((string))
#define NVASSERT2(string) assert(! (string))

#else

#define NVASSERT(string) (string)
#define NVASSERT2(string) (string)

#endif	//  #ifdef NVASSERT_ENABLE


//  fobO
#ifdef _DEBUG

#define NVOutputDebugString(lpOutputString) OutputDebugString(lpOutputString)

#else

#define NVOutputDebugString(lpOutputString)

#endif	//  #ifdef NDEBUG



//  IuWFNgp

typedef DWORD NVRESULT;
typedef HANDLE NVHANDLE;

typedef unsigned __int64 QWORD;
typedef QWORD * LPQWORD;
typedef const QWORD * LPCQWORD;
typedef __int64 QLONG;
typedef QLONG * LPQLONG;
typedef const QLONG * LPCQLONG;

union  QWUNION
{
	struct
	{
		union
		{
			DWORD dwLow;
			LONG lLow;
		};
		union
		{
			DWORD dwHigh;
			LONG lHigh;
		};
	};
	QWORD qw;
	QLONG ql;
};
typedef QWUNION * LPQWUNION;
typedef const QWUNION * LPCQWUNION;

//#define LONG_MIN ((LONG) 0x80000000)
//#define LONG_MAX ((LONG) 0x7FFFFFFF)

//#define SHORT_MIN ((SHORT) 0x8000)
//#define SHORT_MAX ((SHORT) 0x7FFF)


#define NV_INVALIDHANDLE ((NVHANDLE) (0))

typedef const BYTE * LPCBYTE;
typedef const BITMAPINFO * LPCBITMAPINFO;

typedef float SINGLE;
typedef SINGLE * LPSINGLE;
typedef const SINGLE *LPCSINGLE;

typedef DOUBLE * LPDOUBLE;
typedef const DOUBLE * LPCDOUBLE;


#define NV_PATHMAX 1024


#define CPUTYPE_NON  0x00
#define CPUTYPE_MMX  0x01
#define CPUTYPE_SSE  0x02
#define CPUTYPE_SSE2 0x04
#define CPUTYPE_SSE3 0x08
#define CPUTYPE_SSSE3 0x10
#define CPUTYPE_SSE41 0x20
#define CPUTYPE_SSE42 0x40
#define CPUTYPE_3DNOW 0x100
#define CPUTYPE_E3DNOW 0x200



#define MAKETWOCC(ch0, ch1) ((WORD)(BYTE)(ch0) | ((WORD)(BYTE)(ch1) << 8))

#ifndef FIELDOFFSET
#define FIELDOFFSET(type, field)    ((size_t)&(((type *)0)->field))
#endif



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ߂l̒`
//

//  ėp}N
#define NV_OK           ((NVRESULT) 0)				//  

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReport(LPCTSTR lpcszFile, LONG lLine, LPCTSTR lpcszDate, LPCTSTR lpcszTime, LPCTSTR lpcszErrorName, DWORD nvres, DWORD dwFlag);
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportStart(void);
void NVLIBCORE_EXPORT NVLIBCORE_API NVErrorReportEnd(void);

#ifdef NVERROR_REPORT_ENABLE

#define NVERR_SAFE   0x00
#define NVERR_FATAL  0x01
#define NVERR_NORMAL 0x02

#define NVERRORLOGSTART (NVErrorReportStart())
#define NVERRORLOGEND (NVErrorReportEnd())
#define MAKE_NVERR(name, value, flag) (NVErrorReport(TEXT(__FILE__), __LINE__, TEXT(__DATE__), TEXT(__TIME__), (name), (value), (flag)))
#define MAKE_NVERR_VALUE(value) ((NVRESULT) (value))

#else

#define NVERRORLOGSTART
#define NVERRORLOGEND
#define MAKE_NVERR(name, value, flag) ((NVRESULT) (value))
#define MAKE_NVERR_VALUE(value) ((NVRESULT) (value))

#endif

//  `̃G[
#define NVERR_UNDEFINED MAKE_NVERR(TEXT("NVERR_UNDEFINED"), -1, NVERR_FATAL)
#define NVERR_VALUE_UNDEFINED MAKE_NVERR_VALUE(-1)		

//#define MAKE_ERR(name, value, flag) MAKE_NVERR((name), (ERR_ | (value)), (flag))
//#define MAKE_ERR_VALUE(value) MAKE_NVERR_VALUE(ERR_ | (value))


//  NVMemory Library p

#define NVMEMERR_                       0x0100
#define MAKE_NVMEMERR(name, value, flag) (MAKE_NVERR((name), (NVMEMERR_ | (value)), (flag)))
#define MAKE_NVMEMERR_VALUE(value) (MAKE_NVERR_VALUE(NVMEMERR_ | (value))

//  0x0101	//  vꂽIy[V́A܂T|[gĂȂ
#define NVMEMERR_UNSUPPORTED MAKE_NVMEMERR(TEXT("NVMEMERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define NVMEMERR_VALUE_UNSUPPORTED MAKE_NVMEMERR_VALUE(0x01)    



//  IVCOM p

#define VCOMERR_                       0x1000
#define MAKE_VCOMERR(name, value, flag) MAKE_NVERR((name), (VCOMERR_ | (value)), (flag))
#define MAKE_VCOMERR_VALUE(value) MAKE_NVERR_VALUE(VCOMERR_ | (value))

//  0x1001	//  vꂽIy[V́A܂T|[gĂȂ
#define VCOMERR_UNSUPPORTED                   MAKE_VCOMERR(TEXT("VCOMERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VCOMERR_VALUE_UNSUPPORTED             MAKE_VCOMERR_VALUE(0x01)

//  0x1002	//  łɏς݂̃IuWFNg悤Ƃ
#define VCOMERR_ALREADYUSED                   MAKE_VCOMERR(TEXT("VCOMERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VCOMERR_VALUE_ALREADYUSED             MAKE_VCOMERR_VALUE(0x02)

//  0x1003	//  ̌^Ⴄ
#define VCOMERR_INVALIDPARAMTYPE              MAKE_VCOMERR(TEXT("VCOMERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VCOMERR_VALUE_INVALIDPARAMTYPE        MAKE_VCOMERR_VALUE(0x03)

//  0x1004	//  ̃TCYႤ
#define VCOMERR_INVALIDPARAMSIZE              MAKE_VCOMERR(TEXT("VCOMERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VCOMERR_VALUE_INVALIDPARAMSIZE        MAKE_VCOMERR_VALUE(0x04)

//  0x1005	//  m̃NXʎqł
#define VCOMERR_UNKNOWNFOURCC                 MAKE_VCOMERR(TEXT("VCOMERR_UNKNOWNFOURCC"), 0x05, NVERR_FATAL)
#define VCOMERR_VALUE_UNKNOWNFOURCC           MAKE_VCOMERR_VALUE(0x05)

//  0x1006	//  IuWFNg̃bNoȂ(̃XbhbNĂ)
#define VCOMERR_CANTLOCKOBJECT                MAKE_VCOMERR(TEXT("VCOMERR_CANTLOCKOBJECT"), 0x06, NVERR_SAFE)
#define VCOMERR_VALUE_CANTLOCKOBJECT          MAKE_VCOMERR_VALUE(0x06)


//  INVSTREAMBUFFER p

#define VSTBERR_                       0x1100
#define MAKE_VSTBERR(name, value, flag) MAKE_NVERR((name), (VSTBERR_ | (value)), (flag))
#define MAKE_VSTBERR_VALUE(value) MAKE_NVERR_VALUE(VSTBERR_ | (value))

//  0x1101	//  vꂽIy[V́A܂T|[gĂȂ
#define VSTBERR_UNSUPPORTED                   MAKE_VSTBERR(TEXT("VSTBERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VSTBERR_VALUE_UNSUPPORTED             MAKE_VSTBERR_VALUE(0x01)

//  0x1102	//  łɏς݂̃IuWFNg悤Ƃ
#define VSTBERR_ALREADYUSED                   MAKE_VSTBERR(TEXT("VSTBERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VSTBERR_VALUE_ALREADYUSED             MAKE_VSTBERR_VALUE(0x02)

//  0x1103	//  ̌^Ⴄ
#define VSTBERR_INVALIDPARAMTYPE              MAKE_VSTBERR(TEXT("VSTBERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VSTBERR_VALUE_INVALIDPARAMTYPE        MAKE_VSTBERR_VALUE(0x03)

//  0x1104	//  ̃TCYႤ
#define VSTBERR_INVALIDPARAMSIZE              MAKE_VSTBERR(TEXT("VSTBERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VSTBERR_VALUE_INVALIDPARAMSIZE        MAKE_VSTBERR_VALUE(0x04)

//  0x1105	//  obt@tł
#define VSTBERR_BUFFERNOTENOUGH               MAKE_VSTBERR(TEXT("VSTBERR_BUFFERNOTENOUGH"), 0x05, NVERR_NORMAL)
#define VSTBERR_VALUE_BUFFERNOTENOUGH         MAKE_VSTBERR_VALUE(0x05)

//  0x1106	//  obt@ł
#define VSTBERR_BUFFEREMPTY                   MAKE_VSTBERR(TEXT("VSTBERR_BUFFEREMPTY"), 0x06, NVERR_NORMAL)
#define VSTBERR_VALUE_BUFFEREMPTY             MAKE_VSTBERR_VALUE(0x06)

//  0x1107	//  Ȉł
#define VSTBERR_INVALIDPARAM                  MAKE_VSTBERR(TEXT("VSTBERR_INVALIDPARAM"), 0x07, NVERR_FATAL)
#define VSTBERR_VALUE_INVALIDPARAM            MAKE_VSTBERR_VALUE(0x07)



#pragma pack(pop)


#ifdef __cplusplus
}
#endif
