//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  ǗW[  \[Xt@C  for  NVLibraryCore                                    //
//  NVMemory.cpp                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVMemory.h"
#include "NVCommon.h"


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  O[oϐ̐錾
//



static NVMEMCOREDATA nvmcd;		//  Cu̕ێf[^

#ifdef NVMEM_FINDMEMORYLEAK
void NVMemOutputDebugString(TCHAR *fmt, ...)
{
	va_list arg;
	FILE *fp;
	TCHAR buf[1024];

	fp = NVOpenDebugLogFile(TEXT("DebugLog\\NVMemLog.txt"), TEXT("a"));
	if (fp)
	{
		va_start(arg, fmt);

		_vstprintf_s(buf, 1024, fmt, arg);
		_fputts(buf, fp);
		OutputDebugString(buf);
		va_end(arg);
		fclose(fp);
	}
}
#else
	#ifdef NVMEM_USEDEBUGAREA
	void NVMemOutputDebugString(TCHAR *fmt, ...)
	{
		va_list arg;
		FILE *fp;
		TCHAR buf[1024];

		fp = NVOpenDebugLogFile(TEXT("DDELog.txt"), TEXT("a"));
		if (fp)
		{
			va_start(arg, fmt);

			_vstprintf_s(buf, 1024, fmt, arg);
			_fputts(buf, fp);
			OutputDebugString(buf);
			va_end(arg);
			fclose(fp);
		}
	}
	#else
	#define NVMemOutputDebugString
	#endif
#endif


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  O[o֐̐錾
//

NVRESULT NVMemPrepare(void)
{
//  Cȕ֐
	if (nvmcd.lpnvmlist)
	{
		//  łɏĂ̂ŁAG[Ԃ
		return NVERR_UNDEFINED;
	}

	nvmcd.lpnvmlist = new NVMEMLIST;		//  IuWFNge[u

	InitializeCriticalSection(&nvmcd.crsec);	//  NeBJZNV

	return NV_OK;
}


NVRESULT NVMemUnPrepare(void)
{
//  Củ֐

	if (! nvmcd.lpnvmlist)
	{
		//  ĂȂ̂ŁAG[Ԃ
		return NVERR_UNDEFINED;
	}

	{
		NVMEMLIST::iterator it;

		//  ׂĉĂ邩`FbN
		if (nvmcd.cbCount)
		{
			//  ĂȂubN̂ŁAx\B
			NVMemOutputDebugString(TEXT("NVMEM UnPrepare : Error !!  %d Blocks %d Bytes Memory was still Used !!\n"), nvmcd.cbCount, nvmcd.cbTotalSize);

			LPCVOID pvMem;
			it = nvmcd.lpnvmlist->begin();
			do
			{
				pvMem = (*it).second.pvMem;
#ifdef NVMEM_FINDMEMORYLEAK
				NVMemOutputDebugString(TEXT("NVMEM UnPrepare : Handle 0x%X was still Used !!\n"), pvMem);
				if (NVMemCheck(pvMem) & NVMEM_FIXED)
				{
					TCHAR szFileName[NV_PATHMAX];

					_stprintf_s(szFileName, NV_PATHMAX, TEXT("DebugLog\\LeakedMemoryDump%08X.dmp"), pvMem);
					FILE *fp = NVOpenDebugLogFile(szFileName, TEXT("wb"));
					if (fp)
					{
						fwrite(it->second.pvMem, it->second.cbRealSize - NVMEM_DEBUGAREASIZE, 1, fp);
						fclose(fp);
					}
				}
#endif
				nvmcd.lpnvmlist->erase(it);

				it = nvmcd.lpnvmlist->begin();
			} while (it != nvmcd.lpnvmlist->end());
		}
	}

	delete nvmcd.lpnvmlist;		//  IuWFNge[u
	if (nvmcd.crsec.LockSemaphore)
	{
		DeleteCriticalSection(&nvmcd.crsec);	//  NeBJZNV폜
	}

	ZeroMemory(&nvmcd, sizeof(NVMEMCOREDATA));		//  f[^Zbg

	return NV_OK;
}


LPVOID NVLIBCORE_EXPORT NVLIBCORE_API NVMemAlloc(DWORD dwFlag, SIZE_T cbSize)
{
//  mۗp֐
	LPVOID pvMem;

	//  }`XbhɂG[邽߁ANeBJZNVɓB
	EnterCriticalSection(&nvmcd.crsec);

	{
		//  Œ胁vꂽꍇ̏
		SIZE_T cbRealSize;
		DWORD dwRealFlag;
		NVMEMDATA nvmd;

		//  ۂɊmۂTCYvZ
#ifdef NVMEM_USEDEBUGAREA
		cbRealSize = cbSize + NVMEM_DEBUGAREASIZE;
#else
		cbRealSize = cbSize;
#endif

		//  HeapAlloc ֓ntOݒ
		if (dwFlag & NVMEM_ZEROINIT)
		{
			dwRealFlag = HEAP_ZERO_MEMORY;
			nvmd.dwFlag = NVMEM_FIXED | NVMEM_ZEROINIT;
		}
		else
		{
			dwRealFlag = 0;
			nvmd.dwFlag = NVMEM_FIXED;
		}

		//  ۂɃm
		pvMem = HeapAlloc(GetProcessHeap(), dwRealFlag, cbRealSize);
		NVMEMASSERT(pvMem);
		if (pvMem == NULL || pvMem == INVALID_HANDLE_VALUE)
		{
			pvMem = HeapAlloc(GetProcessHeap(), dwRealFlag, cbRealSize);
			NVMEMASSERT(pvMem);
		}

		//  ֐Ԃnhi|C^jvZB
#ifdef NVMEM_USEDEBUGAREA
		//  fobOpGAgꍇ́A̒ւ̃|C^A
		nvmd.pvMem = (((LPBYTE) pvMem) + NVMEM_DEBUGAREACOUNT * sizeof(DWORD));
#else
		//  fobOpGAgȂ΂́Â܂
		nvmd.pvMem = pvMem;
#endif
		//  e[ũf[^̐ݒBlpvOrg ɂ́AIWĩ|C^ݒ
		nvmd.lpvOrg = pvMem;
		nvmd.cbRealSize = cbRealSize;

		//  e[uփf[^ǉBL[́A֐Ԃnhi|C^j
		nvmcd.lpnvmlist->insert(std::make_pair(nvmd.pvMem, nvmd));

		//  TCYƐZ
		nvmcd.cbTotalSize += cbRealSize;
		nvmcd.cbCount++;

#ifdef NVMEM_USEDEBUGAREA
		//  fobOpGAgpꍇ̏
		DWORD i;
		LPDWORD lpdw = (LPDWORD) nvmd.lpvOrg;

		//  擪QOoCg_~[f[^Ŗ߂
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			*(lpdw++) = NVMEM_DUMMYDATA;
		}

		//  cQOoCg̈ʒu܂Ői߂
		lpdw = (LPDWORD) (((LPBYTE) lpdw) + cbSize);

		//  ŌQOoCg_~[f[^Ŗ߂
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			*(lpdw++) = NVMEM_DUMMYDATA;
		}
#endif
		//  NeBJZNVoāAnhԂB
		LeaveCriticalSection(&nvmcd.crsec);
		return (LPVOID) nvmd.pvMem;
	}
}


LPVOID NVLIBCORE_EXPORT NVLIBCORE_API NVMemFree(LPCVOID pvMem)
{
//  p֐

	//  }`XbhɂG[邽߁ANeBJZNVɓB
	EnterCriticalSection(&nvmcd.crsec);

	//  nhLǂ`FbN
	DWORD dw = NVMemCheck(pvMem);

	if (dw & NVMEM_FIXED)
	{
		//  Œ胁̏ꍇ̏
		NVMEMLIST::iterator it;
		LPDWORD lpdw;

		//  ̏e[u猟
		it = nvmcd.lpnvmlist->find(pvMem);

#ifdef NVMEM_USEDEBUGAREA
		//  fobOpGAgpĂꍇ̏
		lpdw = (LPDWORD) (*it).second.lpvOrg;
		BOOL bFlag = FALSE;
		DWORD i;

		//  擪QOoCg`FbN
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			if (*(lpdw++) != NVMEM_DUMMYDATA)
			{
				bFlag = TRUE;
				break;
			}
		}

		lpdw = (LPDWORD) (((LPBYTE) lpdw) + (*it).second.cbRealSize - NVMEM_DEBUGAREASIZE);

		//  Ō̂QOoCg`FbN
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			if (*(lpdw++) != NVMEM_DUMMYDATA)
			{
				bFlag = TRUE;
				break;
			}
		}

		if (bFlag)
		{
			//  ĂꍇAx\
			NVMemOutputDebugString(TEXT("NVMEM Free : Assertion Failed !!  DebugArea is Broken !!\n"));
		}
#endif

		//  ۂɉ
		lpdw = (LPDWORD) (*it).second.lpvOrg;
		HeapFree(GetProcessHeap(), 0, lpdw);

		//  TCYƐ
		nvmcd.cbTotalSize -= (*it).second.cbRealSize;
		nvmcd.cbCount--;

		//  e[u폜
		nvmcd.lpnvmlist->erase(it);

		//  NeBJZNV𗣂āAOԂ
		LeaveCriticalSection(&nvmcd.crsec);
		return NULL;
	}

	//  ȃnh̏ꍇÂ܂܃nhԂ
	LeaveCriticalSection(&nvmcd.crsec);
	return (LPVOID) pvMem;
}


LPVOID NVLIBCORE_EXPORT NVLIBCORE_API NVMemReAlloc(LPVOID pvMem, SIZE_T cbSize, DWORD dwFlag)
{
//  Ċmۊ֐

	EnterCriticalSection(&nvmcd.crsec);

	//  nh`FbN
	DWORD dw = NVMemCheck(pvMem);

	if (! dw)
	{
		//  ȃnh̏ꍇANULL Ԃ
		LeaveCriticalSection(&nvmcd.crsec);
		return NULL;
	}

	{
		//  Œ胁̏ꍇ̏
		SIZE_T cbRealSize;
		DWORD dwRealFlag;
		SIZE_T cbOldSize;

		NVMEMLIST::iterator it;
		LPVOID pvNewMem;

		if (! (dw & NVMEM_FIXED))
		{
			//  Œ胁̃nhłȂꍇAG[
			LeaveCriticalSection(&nvmcd.crsec);
			return NULL;
		}

		//  e[u
		it = nvmcd.lpnvmlist->find(pvMem);

		//  Vۂ̃TCYvZ
#ifdef NVMEM_USEDEBUGAREA
		cbRealSize = cbSize + NVMEM_DEBUGAREASIZE;
#else
		cbRealSize = cbSize;
#endif

#ifdef NVMEM_USEDEBUGAREA
		{
			//  fobOGAgĂꍇ̏
			DWORD i;
			BOOL bFlag = FALSE;
			LPDWORD lpdw = (LPDWORD) (*it).second.lpvOrg;
			NVMEMASSERT(lpdw);

			//  ŌQOoCg̈ʒuɃ|C^ݒ
			lpdw = (LPDWORD) (((LPBYTE) lpdw) + (*it).second.cbRealSize - NVMEM_DEBUGAREACOUNT * 4);

			//  Ō̂QOoCg`FbN
			//  TCYg{NVMEM_ZEROMEMORY ̃P[X̏ꍇ̂߁AOɏĂ
			for (i = NVMEM_DEBUGAREACOUNT; i; i--)
			{
				if (*lpdw != NVMEM_DUMMYDATA)
				{
					bFlag = TRUE;
				}

				*(lpdw++) = 0;
			}

			if (bFlag)
			{
				//  ĂꍇAx\
				NVMemOutputDebugString(TEXT("NVMEM Free : Assertion Failed !!  DebugArea is Broken !!\n"));
			}
		}
#endif	//  #ifdef NVMEM_USEDEBUGAREA

		//  HeapReAlloc ̃tOݒ肵Ae[ȕXV
		if (dwFlag & NVMEM_ZEROINIT)
		{
			dwRealFlag = HEAP_ZERO_MEMORY;
			(*it).second.dwFlag = NVMEM_FIXED | NVMEM_ZEROINIT;
		}
		else
		{
			dwRealFlag = 0;
			(*it).second.dwFlag = NVMEM_FIXED;
		}

		//  ۂɃĊm
		pvNewMem = HeapReAlloc(GetProcessHeap(), dwRealFlag, (*it).second.lpvOrg, cbRealSize);

		if (pvNewMem)
		{
			//  ݂̏Rs[
			NVMEMDATA nvmd = it->second;

			//  Âe[u폜
			nvmcd.lpnvmlist->erase(it);

			//  VIWĩ|C^ۑȂ
			nvmd.lpvOrg = pvNewMem;

			//  ֐Ԃ|C^vZAXV
#ifdef NVMEM_USEDEBUGAREA
			nvmd.pvMem = (((LPBYTE) pvNewMem) + NVMEM_DEBUGAREACOUNT * sizeof(DWORD));
			cbOldSize = nvmd.cbRealSize - NVMEM_DEBUGAREASIZE;
#else
			nvmd.pvMem = pvNewMem;
			cbOldSize = nvmd.cbRealSize;
#endif
			//  g[^̃TCYCAe[uɕۑTCYC
			nvmcd.cbTotalSize += cbRealSize - nvmd.cbRealSize;
			nvmd.cbRealSize = cbRealSize;

#ifdef NVMEM_USEDEBUGAREA
			//  fobOpGAgpĂꍇ̏
			DWORD i;
			LPDWORD lpdw;

			//  Ō̂QOoCgɃ_~[f[^ݒ肵Ȃ
			lpdw = (LPDWORD) (((LPBYTE) (nvmd.pvMem)) + cbSize);

			for (i = NVMEM_DEBUGAREACOUNT; i; i--)
			{
				*(lpdw++) = NVMEM_DUMMYDATA;
			}
#endif

			//  e[u֍XVf[^ǉBL[́A֐Ԃnhi|C^j
			nvmcd.lpnvmlist->insert(std::make_pair(nvmd.pvMem, nvmd));

			//  Vnhi|C^jԂ
			LeaveCriticalSection(&nvmcd.crsec);
			return nvmd.pvMem;
		}
		else
		{
			//  ĊmۂɎsꍇ̏

			//  x\āA񕜏ɓ
			NVOutputDebugString(TEXT("NVMEM ReAlloc : ReAllocation Error !!  Try to Recover\n"));

			//  Vm
			pvNewMem = NVMemAlloc(dwFlag, cbSize);
			if (! pvNewMem)
			{
				//  sꍇAvIG[
				NVOutputDebugString(TEXT("NVMEM ReAlloc : Fatal Error !!  return NULL\n"));
				LeaveCriticalSection(&nvmcd.crsec);
				return NULL;
			}

			{
				LPDWORD lpdwSrc;
				LPDWORD lpdwDest;

				lpdwSrc = (LPDWORD) pvMem;
				lpdwDest = (LPDWORD) pvNewMem;

				//  Lȕ̃Rs[
#ifdef NVMEM_USEDEBUGAREA
				CopyMemory(lpdwDest, lpdwSrc, min((*it).second.cbRealSize, cbRealSize) - NVMEM_DEBUGAREASIZE);
#else
				CopyMemory(lpdwDest, lpdwSrc, min((*it).second.cbRealSize, cbRealSize));
#endif			

#ifdef NVMEM_USEDEBUGAREA
				//  ÂOɁAfobOGA߂

				{
					DWORD i;

					lpdwSrc = (LPDWORD) (((LPBYTE) lpdwSrc) + (*it).second.cbRealSize - NVMEM_DEBUGAREASIZE);

					for (i = NVMEM_DEBUGAREACOUNT; i; i--)
					{
						*(lpdwSrc++) = NVMEM_DUMMYDATA;
					}
				}
#endif
			}

			//  Â
			NVMemFree(pvMem);

			//  񕜏\
			NVOutputDebugString(TEXT("NVMEM Realloc : Recover Success\n"));

			//  ṼnhԂ
			LeaveCriticalSection(&nvmcd.crsec);
			return pvNewMem;
		}
	}
}


DWORD NVLIBCORE_EXPORT NVLIBCORE_API NVMemCheck(LPCVOID pvMem)
{
//  nh̃`FbN֐

	EnterCriticalSection(&nvmcd.crsec);

	NVMEMLIST::iterator it;

	//  ړ\܂́AŒ胁ŃfobOpGAgpƉ肵āAnh
	it = nvmcd.lpnvmlist->find(pvMem);

	if (it == nvmcd.lpnvmlist->end())
	{
			//  ȂꍇAG[

/*		AԈႢ
#ifdef NVMEM_USEDEBUGAREA
			it = nvmcd.lpnvmlist->find(((DWORD) pvMem) - NVMEM_DEBUGAREACOUNT * sizeof(DWORD));
			if (it == nvmcd.lpnvmlist->end())
			{
				LeaveCriticalSection(&nvmcd.crsec);
				return 0;
			}
			else
			{
				LeaveCriticalSection(&nvmcd.crsec);
				return ((*it).second.dwFlag) & 0x03;
			}
#else
*/		LeaveCriticalSection(&nvmcd.crsec);
		return 0;
//#endif
	}

	//  ̎ނ̕Ƀ}XNāAtOԂ
	LeaveCriticalSection(&nvmcd.crsec);
	return ((*it).second.dwFlag) & 0x03;
}


SIZE_T NVLIBCORE_EXPORT NVLIBCORE_API NVMemGetAllocatedSize(void)
{
//  ̑mۃTCY擾֐
	return nvmcd.cbTotalSize;
}


SIZE_T NVLIBCORE_EXPORT NVLIBCORE_API NVMemGetAllocatedCount(void)
{
//  ̑mې擾֐
	return nvmcd.cbCount;
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVMemCheckDebugArea(LPVOID pvMem, SIZE_T *lplBrokenOffset)
{
	BOOL flag = FALSE;
	SIZE_T lBrokenOffset = 0;

	//  }`XbhɂG[邽߁ANeBJZNVɓB
	EnterCriticalSection(&nvmcd.crsec);

	//  nhLǂ`FbN
	DWORD dw = NVMemCheck(pvMem);

	if (dw & NVMEM_FIXED)
	{
		//  Œ胁̏ꍇ̏
		NVMEMLIST::iterator it;

		//  ̏e[u猟
		it = nvmcd.lpnvmlist->find(pvMem);

#ifdef NVMEM_USEDEBUGAREA
		LPDWORD lpdw;
		//  fobOpGAgpĂꍇ̏
		lpdw = (LPDWORD) (*it).second.lpvOrg;
		DWORD i;

		//  擪QOoCg`FbN
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			if (*(lpdw++) != NVMEM_DUMMYDATA)
			{
				flag = TRUE;
				lBrokenOffset = NVMEM_DEBUGAREACOUNT - i;
				break;
			}
		}

		lpdw = (LPDWORD) (((LPBYTE) lpdw) + (*it).second.cbRealSize - NVMEM_DEBUGAREASIZE);

		//  Ō̂QOoCg`FbN
		for (i = NVMEM_DEBUGAREACOUNT; i; i--)
		{
			if (*(lpdw++) != NVMEM_DUMMYDATA)
			{
				flag = TRUE;
				lBrokenOffset = (*it).second.cbRealSize - i;
				break;
			}
		}
		if (lplBrokenOffset)
		{
			*lplBrokenOffset = lBrokenOffset - NVMEM_DEBUGAREACOUNT;
		}
#endif

		//  NeBJZNV𗣂āAOԂ
		LeaveCriticalSection(&nvmcd.crsec);
		return flag;
	}

	//  ȃnh̏ꍇÂ܂܃nhԂ
	LeaveCriticalSection(&nvmcd.crsec);

	if (lplBrokenOffset)
	{
		*lplBrokenOffset = lBrokenOffset;
	}
	return TRUE;
}