//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  Xg[obt@W[ \[Xt@C  for  NVLibraryBase                             //
//  NVStreamBuffer.cpp                                                                          //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVStreamBuffer.h"
#include "NVMemory.h"




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API CreateInstance_NVStreamBuffer(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVStreamBuffer;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̒`
//

Class_NVStreamBuffer::Class_NVStreamBuffer(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVStreamBuffer), NVSTREAMBUFFER_FOURCC);
	return;
}


Class_NVStreamBuffer::~Class_NVStreamBuffer(void)
{
//  fXgN^
	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);
	return;
}



NVRESULT Class_NVStreamBuffer::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  IWǐ^ɃLXg
	LPCNVSTREAMBUFFERCREATE lpcnvsbc = (LPCNVSTREAMBUFFERCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VSTBERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvsbc->dwFourCC != NVSTREAMBUFFER_FOURCC)
		{
			//  ԈႦĂ
			return VSTBERR_INVALIDPARAMTYPE;
		}

		//  ̃TCY`FbN
		if (lpcnvsbc->dwObjSize != sizeof(NVSTREAMBUFFERCREATE))
		{
			//  ɓnꂽ\̂̃TCYĂ
			return VSTBERR_INVALIDPARAMSIZE;
		}
	}


	//  vꂽTCỸobt@m
	nvsbd.lpBuf = (LPBYTE) NVMemAlloc(NVMEM_FIXED, lpcnvsbc->dwBufferSize);

	//  obt@TCYۑ
	nvsbd.lBufferSize = lpcnvsbc->dwBufferSize;

	//  NeBJZNV̏
	InitializeCriticalSection(&nvsbd.crsec);

	return NV_OK;
}


NVRESULT Class_NVStreamBuffer::ResetData(void)
{
//  CX^X̃f[^Zbg

	if (nvsbd.lpBuf)
	{
		//  obt@mۂĂ΁A
		NVMemFree(nvsbd.lpBuf);
	}

	//  NeBJZNV폜
	if (nvsbd.crsec.LockSemaphore)
	{
		DeleteCriticalSection(&nvsbd.crsec);
	}

	//  ێf[^OZbg
	ZeroMemory(&nvsbd, sizeof(NVSTREAMBUFFERDATA));

	//  eNX ResetData Ɉp
	return Class_VCOM::ResetData();
}


NVRESULT Class_NVStreamBuffer::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVSTREAMBUFFER_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVSTREAMBUFFER) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VCOM::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVStreamBuffer::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVSTREAMBUFFER_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VCOM::AddInterface(0);
}


NVRESULT Class_NVStreamBuffer::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VCOM::DeleteInterface();
}


NVRESULT Class_NVStreamBuffer::Write(LPBYTE lpSrc, LONG lSize)
{
//  obt@ւ̏

	//  NeBJZNVɓ
	EnterCriticalSection(&nvsbd.crsec);

	if (lSize > QueryWriteSize())
	{
		//  ݉\ʂ̗vꍇAG[Ƃ
		LeaveCriticalSection(&nvsbd.crsec);
		return VSTBERR_BUFFERNOTENOUGH;
	}

	{
		LONG l;
		LONG n = nvsbd.lEndOffset;

		//  ݃ItZbg̏ݗʂ
		l = min(nvsbd.lBufferSize - n, lSize);

		//  ݃ItZbǧɏ
		CopyMemory(nvsbd.lpBuf + n, lpSrc, l);

		//  񂾗ʕAItZbgZ
		n += l;

		if (l < lSize)
		{
			//  ׂďݏIĂȂꍇ̏

			//  c̗ʂvZ
			n = lSize - l;

			//  cobt@̐擪珑
			CopyMemory(nvsbd.lpBuf, lpSrc + l, n);
		}

		//  obt@̎cf[^ʂZA݃ItZbgۑ
		nvsbd.lRestSize += lSize;
		nvsbd.lEndOffset = n;
	}

	LeaveCriticalSection(&nvsbd.crsec);
	return NV_OK;
}


NVRESULT Class_NVStreamBuffer::Read(LPBYTE lpDest, LONG lSize, LPLONG lplResult)
{
//  obt@̓ǂݍ

	EnterCriticalSection(&nvsbd.crsec);

	//  ǂݍ݉\ʂ
	lSize = min(lSize, QueryRestSize());

	//  ǂݍݍςݗʂOɃZbg
	*lplResult = 0;

	if (lSize > 0)
	{
		//  ǂݍރf[^ꍇ̏
		LONG l;
		LONG i = nvsbd.lStartOffset;
		LONG j = nvsbd.lEndOffset;

		//  ǂݍ݃ItZbg̓ǂݍ݃TCYvZAǂݍ
		l = min(lSize, ((j > i) ? (j - i) : (nvsbd.lBufferSize - i)));
		CopyMemory(lpDest, nvsbd.lpBuf + i, l);
		i += l;

		if (l < lSize)
		{
			//  ׂēǂݍݏIĂȂꍇ̏

			//  obt@̐擪cǂݍ
			i = lSize - l;
			CopyMemory(lpDest + l, nvsbd.lpBuf, i);
		}

		//  ǂݍ݉\ʁAItZbgXV
		nvsbd.lRestSize -= lSize;
		nvsbd.lStartOffset = i;

		//  ۂɓǂݍ񂾗ʂԂ
		*lplResult = lSize;
		LeaveCriticalSection(&nvsbd.crsec);

		return NV_OK;
	}
	else
	{
		//  ǂݍރf[^܂Ȃ΁AG[Ƃ
		LeaveCriticalSection(&nvsbd.crsec);

		if (lSize)
		{
			//  lSize OłȂ΁Aobt@
			return VSTBERR_BUFFEREMPTY;
		}
		else
		{
			//  lSize OȂA
			return VSTBERR_INVALIDPARAM;
		}
	}
}


NVRESULT Class_NVStreamBuffer::Read1Byte(LPBYTE lpDest)
{
//  obt@̂PoCgǂݍ

	EnterCriticalSection(&nvsbd.crsec);
	if (QueryRestSize())
	{
		//  obt@łȂꍇ̏
		LONG i = nvsbd.lStartOffset;

		//  PoCgǂݍ
		*lpDest = nvsbd.lpBuf[i++];

		if (i >= nvsbd.lBufferSize)
		{
			//  obt@̏I[ɒBĂ΁Aǂݍ݃ItZbg擪ɖ߂
			nvsbd.lStartOffset = 0;
		}
		else
		{
			//  ǂݍ݃ItZbgXV
			nvsbd.lStartOffset = i;
		}

		//  cʂfNg
		nvsbd.lRestSize--;

		LeaveCriticalSection(&nvsbd.crsec);
		return NV_OK;
	}
	else
	{
		//  obt@ł΁AG[Ƃ
		LeaveCriticalSection(&nvsbd.crsec);
		return VSTBERR_BUFFEREMPTY;
	}

}


LONG Class_NVStreamBuffer::QueryRestSize(void)
{
//  obt@̃f[^̗ʂ擾
	return nvsbd.lRestSize;
}

LONG Class_NVStreamBuffer::QueryWriteSize(void)
{
//  obt@ɏ݉\ȃTCY𓾂
	return nvsbd.lBufferSize - nvsbd.lRestSize;
}

NVRESULT Class_NVStreamBuffer::ClearBuffer(void)
{
//  obt@ɂ
	EnterCriticalSection(&nvsbd.crsec);
	nvsbd.lStartOffset = 0;
	nvsbd.lEndOffset = 0;
	nvsbd.lRestSize = 0;
	LeaveCriticalSection(&nvsbd.crsec);

	return NV_OK;
}

NVRESULT Class_NVStreamBuffer::WasteBytes(LPLONG lplSize)
{
	LONG lSize;

	EnterCriticalSection(&nvsbd.crsec);

	lSize = min(*lplSize, QueryRestSize());

	nvsbd.lStartOffset += lSize;
	nvsbd.lStartOffset %= nvsbd.lBufferSize;
	nvsbd.lRestSize -= lSize;

	LeaveCriticalSection(&nvsbd.crsec);

	*lplSize = lSize;

	return NV_OK;
}

LONG Class_NVStreamBuffer::GetBufferSize(void)
{
	return nvsbd.lBufferSize;
}
