//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  ACMFile Decompression W[ \[Xt@C  for  NVWaveFileLibrary                     //
//  NVACM.cpp                                                                                   //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVACM.h"
#include "..\\Resource\\Resource.h"

#pragma comment(lib, "msacm32.lib")



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  [J֐̐錾
//

static NVRESULT NVACMCreate(INVACM invacm, LPNVAUDIOFILEDATA lpnvafd, LPNVACMDATA lpnvacmd, LPCNVAUDIOFILECREATE lpcnvafc);
static INT_PTR CALLBACK NVACM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVACM(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVACM;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`    INVACM
//


Class_NVACM::Class_NVACM(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVACM), NVACM_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVACM::~Class_NVACM(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVACM::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	NVRESULT nvres;

	//  ʂ̌^ɃLXg
	LPCNVAUDIOFILECREATE lpcnvafc = (LPCNVAUDIOFILECREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VACMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvafc->dwFourCC == NVAUDIOFILE_FOURCC)
		{
			if (lpcnvafc->dwObjSize != sizeof(NVAUDIOFILECREATE))
			{
				return VACMERR_INVALIDPARAMSIZE;
			}

			//  p[^ftHgňp
			nvres = NVACMCreate(this, &nvafd, &nvacmd, lpcnvafc);
		}
		else if (lpcnvafc->dwFourCC == NVACM_FOURCC)
		{
			if (lpcnvafc->dwObjSize != sizeof(NVACMCREATE))
			{
				return VACMERR_INVALIDPARAMSIZE;
			}

			//  IWǐ^ɕϊ
			LPCNVACMCREATE lpcnvmp3c = (LPCNVACMCREATE) lpcnvafc;

			nvres = NVACMCreate(this, &nvafd, &nvacmd, lpcnvafc);
		}
		else
		{
			return VACMERR_INVALIDPARAMTYPE;
		}
	}

	if (nvres)
	{
		return nvres;
	}

	vcd.bIsCreated = TRUE;

	return NV_OK;
}


NVRESULT NVACMCreate(INVACM invacm, LPNVAUDIOFILEDATA lpnvafd, LPNVACMDATA lpnvacmd, LPCNVAUDIOFILECREATE lpcnvafc)
{
	NVRESULT nvres;
	INVSTREAM invst = NULL;
	LPWAVEFORMATEX lpwfxSrc = NULL;
	LPWAVEFORMATEX lpwfxDest = NULL;
	HACMSTREAM hacmst = NULL;
	LPNVAUDIOFILECOMMENT lpnvafc = NULL;

	try
	{
		if (lpcnvafc->dwFlag & NVAUDIOFILE_OPENSTREAM)
		{
			//  Xg[Jꍇ̏
			invst = lpcnvafc->invst;
			lpnvacmd->dwFlag |= NVAUDIOFILE_OPENSTREAM;
		}
		else
		{
			//  t@CJꍇ̏
			NVSTREAMCREATE nvstc;

			//  INVFILE CX^X쐬
			nvres = VCreateInstance(NVFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invst);
			if (nvres)
			{
				throw nvres;
			}

			//  CX^X
			SetNVStreamCreate(&nvstc, NVSTREAM_OPENREAD, lpcnvafc->lpcszDataName);
			nvres = invst->Create(&nvstc);
			if (nvres)
			{
				throw nvres;
			}

			lpnvacmd->dwFlag |= NVAUDIOFILE_OPENFILE;
		}

		//  t@C^Cv`FbN
		nvres = CheckACMFileType(invst, &lpnvacmd->lType, &lpnvacmd->qlStartOffset, &lpnvacmd->qlDataSize,
								&lpnvacmd->nvacmInfo, &lpwfxDest, &lpwfxSrc);
		if (nvres)
		{
			throw nvres;
		}

		lpnvafc = NVAudioFile_GetSIF(invst);

		//  f[^̕o悤AXg[̃f[^TCYI[o[Ch
		nvres = invst->OverrideSize(lpnvacmd->qlStartOffset, lpnvacmd->qlDataSize);
		if (nvres)
		{
			throw nvres;
		}

		//  Xg[̐擪Ɍ݈ʒuړ
		nvres = invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
		if (nvres)
		{
			throw nvres;
		}

		if (lpcnvafc->dwFlag & NVAUDIOFILE_GETINFOONLY)
		{
			lpnvacmd->dwFlag |= NVAUDIOFILE_GETINFOONLY;
		}
		else
		{
			//  ACM Xg[I[v
			MMRESULT mmres;

			mmres = acmStreamOpen(&hacmst, NULL, lpwfxSrc, lpwfxDest, NULL, NULL, 0, ACM_STREAMOPENF_NONREALTIME);
			if (mmres)
			{
				throw VACMERR_CANTOPENACMSTREAM;
			}
		}

		//  ef[^ۑ
		lpnvacmd->invst = invst;
		invst = NULL;
		lpnvacmd->hacmst = hacmst;
		hacmst = NULL;
		lpnvacmd->qlRestSize = lpnvacmd->qlDataSize;
		NVMemFree(lpwfxSrc);
		lpwfxSrc = NULL;
		NVMemFree(lpwfxDest);
		lpwfxDest = NULL;
		lpnvafd->lpnvafcm = lpnvafc;
		lpnvafc = NULL;
	}
	catch (NVRESULT nvres)
	{
		if (lpnvafc)
		{
			NVMemFree(lpnvafc);
		}

		if (hacmst)
		{
			acmStreamClose(hacmst, 0);
		}

		if (lpwfxSrc)
		{
			NVMemFree(lpwfxSrc);
		}

		if (lpwfxDest)
		{
			NVMemFree(lpwfxDest);
		}

		if (invst)
		{
			invst->Release();
		}

		return nvres;
	}

	return NV_OK;
}


NVRESULT Class_NVACM::ResetData(void)
{
	//  ACM Xg[N[Y
	if (nvacmd.hacmst)
	{
		acmStreamClose(nvacmd.hacmst, 0);
	}

	if (nvacmd.lpBuf)
	{
		NVMemFree(nvacmd.lpBuf);
	}

	//  ̓Xg[
	if (nvacmd.invst)
	{
		nvacmd.invst->Release();
	}

	//  CX^X̃f[^OZbgāAeNXɈp
	ZeroMemory(&nvacmd, sizeof(NVACMDATA));

	return Class_NVAudioFile::ResetData();
}


NVRESULT Class_NVACM::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVACM_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVACM) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVAudioFile::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVACM::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVACM_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVAudioFile::AddInterface(0);
}


NVRESULT Class_NVACM::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVAudioFile::DeleteInterface();
}


NVRESULT Class_NVACM::GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  tH[}bgƎ̊g擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	switch (dwFourCC)
	{
	case NVAUDIOFILE_FOURCC:
		{
			if (lpvInfo)
			{
				//  obt@w肳Ăꍇ̏
				
				//  obt@̃TCY`FbN
				if (*lpdwSize >= sizeof(NVAUDIOFILEINFO))
				{
					LPNVAUDIOFILEINFO lpnvafInfo = (LPNVAUDIOFILEINFO) lpvInfo;

					//  obt@\΁ARs[
					CopyMemory(lpvInfo, &nvacmd.nvacmInfo, sizeof(NVAUDIOFILEINFO));

					lpnvafInfo->dwFourCC = NVAUDIOFILE_FOURCC;
					lpnvafInfo->dwObjSize = sizeof(NVAUDIOFILEINFO);

					*lpdwSize = sizeof(NVAUDIOFILEINFO);
					return NV_OK;
				}
				else
				{
					//  Ȃ΁AKvȃTCYԂ
					*lpdwSize = sizeof(NVAUDIOFILEINFO);
					return VACMERR_BUFFERTOOSMALL;
				}
			}
			
			//  obt@w肳ĂȂ΁ATCY̖₢킹
			//  KvȃTCYԂ
			
			*lpdwSize = sizeof(NVACMINFO);
			return NV_OK;
		}
		break;
	case NVACM_FOURCC:
		{
			if (lpvInfo)
			{
				//  obt@w肳Ăꍇ̏
				
				//  obt@̃TCY`FbN
				if (*lpdwSize >= sizeof(NVACMINFO))
				{
					//  obt@\΁ARs[
					CopyMemory(lpvInfo, &nvacmd.nvacmInfo, sizeof(NVACMINFO));
					*lpdwSize = sizeof(NVACMINFO);
					return NV_OK;
				}
				else
				{
					//  Ȃ΁AKvȃTCYԂ
					*lpdwSize = sizeof(NVACMINFO);
					return VACMERR_BUFFERTOOSMALL;
				}
			}
			
			//  obt@w肳ĂȂ΁ATCY̖₢킹
			//  KvȃTCYԂ
			
			*lpdwSize = sizeof(NVACMINFO);
			return NV_OK;
		}
		break;
	default:
		{
			return VACMERR_UNKNOWNFOURCC;
		}
	}
}
	

NVRESULT Class_NVACM::GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  ȖȂǂ̃Rg擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (dwFourCC == NVACM_FOURCC)
	{
		dwFourCC = NVAUDIOFILE_FOURCC;
	}

	return Class_NVAudioFile::GetComment(dwFourCC, lpvInfo, lpdwSize);
}


NVRESULT Class_NVACM::GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf)
{
//  PCMWAVEFORMAT `̏擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	lppcmwf->wBitsPerSample = (WORD) nvacmd.nvacmInfo.dwBitsPerSample;		//  ݂̎gpł́A16 BitsPerSample ̂ݑΉ
	lppcmwf->wf.wFormatTag = WAVE_FORMAT_PCM;		//  ^O͂obl
	lppcmwf->wf.nChannels = (WORD) nvacmd.nvacmInfo.dwMode;
	lppcmwf->wf.nSamplesPerSec = nvacmd.nvacmInfo.dwSamplerate;
	lppcmwf->wf.nBlockAlign = (lppcmwf->wBitsPerSample >> 3) * lppcmwf->wf.nChannels;
	lppcmwf->wf.nAvgBytesPerSec = lppcmwf->wf.nSamplesPerSec * lppcmwf->wf.nBlockAlign;

	return NV_OK;
}


NVRESULT Class_NVACM::DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize)
{
//  
	NVRESULT nvres;
	MMRESULT mmres;
	DWORD dwSrcSize;
	DWORD dwDestSize;
	DWORD dwSize;
	LPVOID lpBuf = NULL;
	LPBYTE lpDest = (LPBYTE) lpBuffer;
	NVRESULT nvresReturn = NV_OK;
	DWORD dwRead;
	DWORD dwResult = 0;
	DWORD dwRequire;

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (nvacmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VACMERR_NOCREATE;
	}

	try
	{
		while (1)
		{
			dwSrcSize = 0;
			dwDestSize = 0;

			if (nvacmd.lpBuf)
			{
				dwSize = min((DWORD) lBufferSize, nvacmd.dwBufRest);
				CopyMemory(lpDest, nvacmd.lpBuf + nvacmd.dwBufOffset, dwSize);
				lpDest += dwSize;
				nvacmd.dwBufOffset += dwSize;
				nvacmd.dwBufRest -= dwSize;
				lBufferSize -= dwSize;
				dwResult += dwSize;

				if (nvacmd.dwBufRest <= 0)
				{
					NVMemFree(nvacmd.lpBuf);
					nvacmd.lpBuf = NULL;
				}

				if (lBufferSize <= 0)
				{
					nvacmd.quCurrent.ql += dwResult;
					*lplResultSize = dwResult;
					return NV_OK;
				}
			}

			dwRequire = lBufferSize;
			while (dwDestSize < (DWORD) lBufferSize && dwSrcSize < nvacmd.qlRestSize)
			{
				mmres = acmStreamSize(nvacmd.hacmst, dwRequire, &dwSize, ACM_STREAMSIZEF_DESTINATION);
				if (mmres)
				{
					dwRequire <<= 1;
					continue;
				}
				dwSrcSize += dwSize;
				mmres = acmStreamSize(nvacmd.hacmst, dwSrcSize, &dwDestSize, ACM_STREAMSIZEF_SOURCE);
			}

			if (dwSrcSize > nvacmd.qlRestSize)
			{
				dwSrcSize = (DWORD) nvacmd.qlRestSize;
				mmres = acmStreamSize(nvacmd.hacmst, dwSrcSize, &dwDestSize, ACM_STREAMSIZEF_SOURCE);
			}

			nvacmd.lpBuf = (LPBYTE) NVMemAlloc(NVMEM_FIXED, dwDestSize);
			lpBuf = (LPBYTE) NVMemAlloc(NVMEM_FIXED, dwSrcSize);

			nvres = nvacmd.invst->Read(lpBuf, dwSrcSize, &dwRead);
			nvacmd.qlRestSize -= dwRead;
			if (nvres)
			{
				dwSrcSize = dwRead;
				mmres = acmStreamSize(nvacmd.hacmst, dwSrcSize, &dwDestSize, ACM_STREAMSIZEF_SOURCE);
				if (nvres == VSTMERR_VALUE_ENDOFDATA)
				{
					nvresReturn = VACMERR_ENDOFDATA;
				}
				else
				{
					nvresReturn = VACMERR_FILEISBROKEN;
				}
			}
			else if (! dwRead)
			{
				nvresReturn = VACMERR_ENDOFDATA;
			}

			if (! dwDestSize)
			{
				throw nvresReturn;
			}

			ACMSTREAMHEADER acmsth;

			ZeroMemory(&acmsth, sizeof(ACMSTREAMHEADER));
			acmsth.cbStruct = sizeof(ACMSTREAMHEADER);
			acmsth.pbSrc = (unsigned char *) lpBuf;
			acmsth.cbSrcLength = dwSrcSize;
			acmsth.pbDst = nvacmd.lpBuf;
			acmsth.cbDstLength = dwDestSize;

			mmres = acmStreamPrepareHeader(nvacmd.hacmst, &acmsth, 0);
			mmres = acmStreamConvert(nvacmd.hacmst, &acmsth, ACM_STREAMCONVERTF_BLOCKALIGN);
			nvacmd.dwBufOffset = 0;
			nvacmd.dwBufRest = acmsth.cbDstLengthUsed;
			mmres = acmStreamUnprepareHeader(nvacmd.hacmst, &acmsth, 0);

			NVMemFree(lpBuf);
			lpBuf = NULL;
		}
	}
	catch (NVRESULT nvres)
	{
		if (lpBuf)
		{
			NVMemFree(lpBuf);
		}

		nvacmd.quCurrent.ql += dwResult;
		*lplResultSize = dwResult;
		return nvres;
	}

	return NV_OK;
}


NVRESULT Class_NVACM::Rewind(void)
{
	NVRESULT nvres;

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (nvacmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VACMERR_NOCREATE;
	}

	nvres = nvacmd.invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
	if (nvres)
	{
		return nvres;
	}

	if (nvacmd.lpBuf)
	{
		nvacmd.dwBufRest = 0;
		NVMemFree(nvacmd.lpBuf);
		nvacmd.lpBuf = NULL;
	}

	nvacmd.qlRestSize = nvacmd.qlDataSize;

	nvacmd.quCurrent.ql = 0;
	return NV_OK;
}


NVRESULT Class_NVACM::FileInfoDialog(HWND hwnd)
{
//  t@C̃_CAO\

	extern HINSTANCE hinstNVWave;

	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (nvacmd.hwndInfo)
	{
		SetFocus(nvacmd.hwndInfo);
		return NV_OK;
	}

	AddRef();

	nvacmd.hwndInfo = CreateDialogParam(NVGetResourceDLL(), MAKEINTRESOURCE(IDD_AUDIOFILE_INFO), hwnd, NVACM_InfoDialogProc, (LPARAM) this);
	if (! nvacmd.hwndInfo)
	{
		Release();
		return VACMERR_CANTCREATEINFODIALOG;
	}
	NVRegisterDialog(nvacmd.hwndInfo);

	return NV_OK;
}


INT_PTR CALLBACK NVACM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch (uMessage)
	{
	case WM_INITDIALOG:
		{
			SetProp(hwnd, TEXT("invacm"), (HANDLE) lParam);
			SetFocus(GetDlgItem(hwnd, IDC_AUDIOFILE_FILENAME));

			TCHAR lpszBuf[1024];
			LPNVACMINFO lpInfo = &((INVACM) lParam)->nvacmd.nvacmInfo;
			QWORD qwPlayTime = lpInfo->quPlayTime.qw / 1000;

			SetDlgItemText(hwnd, IDC_AUDIOFILE_FILENAME, lpInfo->lpszDataName);
			_stprintf_s(lpszBuf, 1024, TEXT("FileType = RIFF WAVE\n   (%s)\nFileSize = %I64u bytes\nPlaySize = %I64u bytes\nPlayTime = %2I64u:%02I64u.%03I64u\n")
				TEXT("Bitrate = %d kbps (%s)\nBitsPerSample = %d bits\nSampleRate = %d Hz\nMode = %s"),
				lpInfo->lpszFormatString, lpInfo->quDataSize.qw, lpInfo->quDecodedSize.qw, qwPlayTime / 60, qwPlayTime % 60, lpInfo->quPlayTime.qw % 1000,
				lpInfo->dwBitrate, (lpInfo->dwFlag & NVAUDIOFILE_FLAG_VBR) ? TEXT("VBR") : TEXT("CBR"), lpInfo->dwBitsPerSample, lpInfo->dwSamplerate, lpInfo->lpszModeString);
			SetDlgItemText(hwnd, IDC_AUDIOFILE_INFO, lpszBuf);
			LPNVAUDIOFILECOMMENT lpnvafcm = (((INVACM) lParam)->nvafd.lpnvafcm);
			if (lpnvafcm)
			{
				SetDlgItemText(hwnd, IDC_AUDIOFILE_TITLE, &lpnvafcm->szString[lpnvafcm->lOffsetTitle]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_ARTIST, &lpnvafcm->szString[lpnvafcm->lOffsetArtist]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_ALBUM, &lpnvafcm->szString[lpnvafcm->lOffsetAlbum]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_DATE, &lpnvafcm->szString[lpnvafcm->lOffsetDate]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_TRACK, &lpnvafcm->szString[lpnvafcm->lOffsetTrackNumber]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_GENRE, &lpnvafcm->szString[lpnvafcm->lOffsetGenre]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_COMMENT, &lpnvafcm->szString[lpnvafcm->lOffsetComment]);
			}
			NVClipWindowPos(hwnd);
		}
		return FALSE;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDOK:
			case IDCANCEL:
				{
					DestroyWindow(hwnd);
				}
				return TRUE;
			}
		}
		break;
	case WM_DESTROY:
		{
			INVACM invacm;

			invacm = (INVACM) GetProp(hwnd, TEXT("invacm"));
			if (invacm)
			{
				RemoveProp(hwnd, TEXT("invacm"));
				NVUnRegisterDialog(invacm->nvacmd.hwndInfo);
				invacm->nvacmd.hwndInfo = NULL;
				invacm->Release();
			}
		}
		break;
	}

	return FALSE;
}

NVRESULT Class_NVACM::GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag)
{
	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (nvacmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VACMERR_NOCREATE;
	}

	if (dwFlag & NVAUDIOFILE_SEEKCURRENT)
	{
		lpquPosition->qw = 0;
		return NV_OK;
	}
	else 
	{
		if (dwFlag & NVAUDIOFILE_SEEKEND)
		{
			lpquPosition->ql = nvacmd.nvacmInfo.quDecodedSize.ql - nvacmd.quCurrent.ql;
		}
		else
		{
			*lpquPosition = nvacmd.quCurrent;
		}
	}

	return NV_OK;
}

NVRESULT Class_NVACM::SetCurrentPosition(QWUNION quPosition, DWORD dwFlag)
{
	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VACMERR_NOCREATE;
	}

	if (nvacmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VACMERR_NOCREATE;
	}

	QWUNION quCurrent;
	DWORD dwResult;
	NVRESULT nvres;

	quPosition.qw -= quPosition.qw % (nvacmd.nvacmInfo.dwMode * nvacmd.nvacmInfo.dwBitsPerSample / 8);

	if (dwFlag & NVAUDIOFILE_SEEKEND)
	{
		quCurrent.ql = nvacmd.nvacmInfo.quDecodedSize.ql + quPosition.ql;
	}
	else if (dwFlag & NVAUDIOFILE_SEEKCURRENT)
	{
		quCurrent.ql = nvacmd.quCurrent.ql + quPosition.ql;
	}
	else
	{
		quCurrent.ql = quPosition.ql;
	}

	if ((quCurrent.ql < 0) || (quCurrent.ql > nvacmd.nvacmInfo.quDecodedSize.ql))
	{
		return VACMERR_INVALIDPARAM;
	}

	if (quCurrent.qw)
	{
		DWORD dwRem;
		DWORD dwBlock;
		DWORD dwMultiply;

		acmStreamSize(nvacmd.hacmst, quCurrent.dwLow, &dwResult, ACM_STREAMSIZEF_DESTINATION);
		acmStreamSize(nvacmd.hacmst, dwResult, &dwBlock, ACM_STREAMSIZEF_SOURCE);

		dwMultiply = (DWORD) (quCurrent.qw / dwBlock);
		if (dwMultiply || quCurrent.qw < nvacmd.quCurrent.qw)
		{
			dwRem = quCurrent.qw % dwBlock;
			quCurrent.qw = ((QWORD) dwMultiply) * dwResult;

			nvres = nvacmd.invst->SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
			if (nvres)
			{
				return VACMERR_CANTSETCURRENTPOSITION;
			}

			if (nvacmd.lpBuf)
			{
				nvacmd.dwBufRest = 0;
				NVMemFree(nvacmd.lpBuf);
				nvacmd.lpBuf = NULL;
			}

			nvacmd.qlRestSize = ((DWORD) nvacmd.qlDataSize) - quCurrent.dwLow;
			nvacmd.quCurrent.ql = quPosition.ql - dwRem;
		}
		else
		{
			dwRem = (DWORD) (quCurrent.qw - nvacmd.quCurrent.qw);
		}
		if (dwRem)
		{
			LPVOID lpDummy = NVMemAlloc(NVMEM_FIXED, dwRem);
			LONG lResult;

			nvres = DecodeToPCMData(lpDummy, dwRem, &lResult);
			NVMemFree(lpDummy);
			if (nvres || (lResult != dwRem))
			{
				return VACMERR_CANTSETCURRENTPOSITION;
			}
		}
	}
	else
	{
		if (nvacmd.lpBuf)
		{
			nvacmd.dwBufRest = 0;
			NVMemFree(nvacmd.lpBuf);
			nvacmd.lpBuf = NULL;
		}

		nvacmd.qlRestSize = nvacmd.qlDataSize;
		nvres = nvacmd.invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
		nvacmd.quCurrent.ql = 0;
	}
	return NV_OK;
}

NVRESULT Class_NVACM::ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples)
{
//  QƎ(}CNbP)Tv֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquSamples->ql = NVMulDiv64(quReferenceTime.ql, nvacmd.nvacmInfo.dwSamplerate, 1000 * 1000);
	return NV_OK;
}

NVRESULT Class_NVACM::SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime)
{
//  TvQƎ(}CNbP)֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquReferenceTime->ql = NVMulDiv64(quSamples.ql, 1000 * 1000, nvacmd.nvacmInfo.dwSamplerate);
	
	return NV_OK;
}

NVRESULT Class_NVACM::GetReferenceTime(LPQWUNION lpquReferenceTime)
{
	//  ݂̎QƎ(}CNbP)擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	if (nvacmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VAFERR_NOCREATE;
	}

	lpquReferenceTime->ql = NVMulDiv64(nvacmd.quCurrent.ql, 1000 * 1000, nvacmd.nvacmInfo.dwSamplerate * nvacmd.nvacmInfo.dwMode * (nvacmd.nvacmInfo.dwBitsPerSample >> 3));

	return NV_OK;
}

NVRESULT Class_NVACM::GetTotalTime(LPQWUNION lpquTotalTime)
{
	//  }CNbPʂőSĐԂ擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquTotalTime->ql = NVMulDiv64(nvacmd.nvacmInfo.quDecodedSize.ql, 1000 * 1000, nvacmd.nvacmInfo.dwSamplerate * nvacmd.nvacmInfo.dwMode * (nvacmd.nvacmInfo.dwBitsPerSample >> 3));
	return NV_OK;
}


