//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  PCMFile Decompression W[ \[Xt@C  for  NVWaveFileLibrary                     //
//  NVPCM.cpp                                                                                   //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVPCM.h"
#include "..\\Resource\\Resource.h"




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  [J֐̐錾
//

static NVRESULT NVPCMCreate(INVPCM invpcm, LPNVAUDIOFILEDATA lpnvafd, LPNVPCMDATA lpnvpcmd, LPCNVAUDIOFILECREATE lpcnvafc);
static INT_PTR CALLBACK NVPCM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVPCM(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVPCM;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`    INVPCM
//


Class_NVPCM::Class_NVPCM(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVPCM), NVPCM_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVPCM::~Class_NVPCM(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVPCM::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	NVRESULT nvres;

	//  ʂ̌^ɃLXg
	LPCNVAUDIOFILECREATE lpcnvafc = (LPCNVAUDIOFILECREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VPCMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvafc->dwFourCC == NVAUDIOFILE_FOURCC)
		{
			if (lpcnvafc->dwObjSize != sizeof(NVAUDIOFILECREATE))
			{
				return VPCMERR_INVALIDPARAMSIZE;
			}

			//  p[^ftHgňp
			nvres = NVPCMCreate(this, &nvafd, &nvpcmd, lpcnvafc);
		}
		else if (lpcnvafc->dwFourCC == NVPCM_FOURCC)
		{
			if (lpcnvafc->dwObjSize != sizeof(NVPCMCREATE))
			{
				return VPCMERR_INVALIDPARAMSIZE;
			}

			//  IWǐ^ɕϊ
			LPCNVPCMCREATE lpcnvmp3c = (LPCNVPCMCREATE) lpcnvafc;

			nvres = NVPCMCreate(this, &nvafd, &nvpcmd, lpcnvafc);
		}
		else
		{
			return VPCMERR_INVALIDPARAMTYPE;
		}
	}

	if (nvres)
	{
		return nvres;
	}

	vcd.bIsCreated = TRUE;

	return NV_OK;
}


NVRESULT NVPCMCreate(INVPCM invpcm, LPNVAUDIOFILEDATA lpnvafd, LPNVPCMDATA lpnvpcmd, LPCNVAUDIOFILECREATE lpcnvafc)
{
	NVRESULT nvres;
	INVSTREAM invst = NULL;
	LPNVAUDIOFILECOMMENT lpnvafc = NULL;

	try
	{
		if (lpcnvafc->dwFlag & NVAUDIOFILE_OPENSTREAM)
		{
			//  Xg[Jꍇ̏
			invst = lpcnvafc->invst;
			lpnvpcmd->dwFlag |= NVAUDIOFILE_OPENSTREAM;
		}
		else
		{
			//  t@CJꍇ̏
			NVSTREAMCREATE nvstc;

			//  INVFILE CX^X쐬
			nvres = VCreateInstance(NVFILE_FOURCC, NVSTREAM_FOURCC, (LPVOID *) &invst);
			if (nvres)
			{
				throw nvres;
			}

			//  CX^X
			SetNVStreamCreate(&nvstc, NVSTREAM_OPENREAD, lpcnvafc->lpcszDataName);
			nvres = invst->Create(&nvstc);
			if (nvres)
			{
				throw nvres;
			}

			lpnvpcmd->dwFlag |= NVAUDIOFILE_OPENFILE;
		}

		//  t@C^Cv`FbN
		nvres = CheckPCMFileType(invst, &lpnvpcmd->lType, &lpnvpcmd->qlStartOffset, &lpnvpcmd->qlDataSize, &lpnvpcmd->nvpcmInfo);
		if (nvres)
		{
			throw nvres;
		}

		if (lpnvpcmd->lType == NVPCM_PCMFORMAT_IEEEFLOAT)
		{
			lpnvpcmd->nvpcmInfo.dwFlag |= NVAUDIOFILE_FLAG_FLOAT;
		}
		lpnvafc = NVAudioFile_GetSIF(invst);

		//  oblf[^̕o悤AXg[̃f[^TCYI[o[Ch
		nvres = invst->OverrideSize(lpnvpcmd->qlStartOffset, lpnvpcmd->qlDataSize);
		if (nvres)
		{
			throw nvres;
		}

		//  Xg[̐擪Ɍ݈ʒuړ
		nvres = invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
		if (nvres)
		{
			throw nvres;
		}

		if (lpcnvafc->dwFlag & NVAUDIOFILE_GETINFOONLY)
		{
			lpnvpcmd->dwFlag |= NVAUDIOFILE_GETINFOONLY;
		}

		//  ef[^ۑ
		lpnvpcmd->invst = invst;
		invst = NULL;
		lpnvafd->lpnvafcm = lpnvafc;
		lpnvafc = NULL;
	}
	catch (NVRESULT nvres)
	{
		if (lpnvafc)
		{
			NVMemFree(lpnvafc);
		}
		if (invst)
		{
			invst->Release();
		}

		return nvres;
	}

	return NV_OK;
}


NVRESULT Class_NVPCM::ResetData(void)
{
	//  ̓Xg[
	if (nvpcmd.invst)
	{
		nvpcmd.invst->Release();
	}

	//  CX^X̃f[^OZbgāAeNXɈp
	ZeroMemory(&nvpcmd, sizeof(NVPCMDATA));

	return Class_NVAudioFile::ResetData();
}


NVRESULT Class_NVPCM::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVPCM_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVPCM) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVAudioFile::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVPCM::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVPCM_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVAudioFile::AddInterface(0);
}


NVRESULT Class_NVPCM::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVAudioFile::DeleteInterface();
}


NVRESULT Class_NVPCM::GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  tH[}bgƎ̊g擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	switch (dwFourCC)
	{
	case NVAUDIOFILE_FOURCC:
		{
			if (lpvInfo)
			{
				//  obt@w肳Ăꍇ̏
				
				//  obt@̃TCY`FbN
				if (*lpdwSize >= sizeof(NVAUDIOFILEINFO))
				{
					LPNVAUDIOFILEINFO lpnvafInfo = (LPNVAUDIOFILEINFO) lpvInfo;

					//  obt@\΁ARs[
					CopyMemory(lpvInfo, &nvpcmd.nvpcmInfo, sizeof(NVAUDIOFILEINFO));

					lpnvafInfo->dwFourCC = NVAUDIOFILE_FOURCC;
					lpnvafInfo->dwObjSize = sizeof(NVAUDIOFILEINFO);

					*lpdwSize = sizeof(NVAUDIOFILEINFO);
					return NV_OK;
				}
				else
				{
					//  Ȃ΁AKvȃTCYԂ
					*lpdwSize = sizeof(NVAUDIOFILEINFO);
					return VPCMERR_BUFFERTOOSMALL;
				}
			}
			
			//  obt@w肳ĂȂ΁ATCY̖₢킹
			//  KvȃTCYԂ
			
			*lpdwSize = sizeof(NVAUDIOFILEINFO);
			return NV_OK;
		}
		break;
	case NVPCM_FOURCC:
		{
			if (lpvInfo)
			{
				//  obt@w肳Ăꍇ̏
				
				//  obt@̃TCY`FbN
				if (*lpdwSize >= sizeof(NVPCMINFO))
				{
					//  obt@\΁ARs[
					CopyMemory(lpvInfo, &nvpcmd.nvpcmInfo, sizeof(NVPCMINFO));
					*lpdwSize = sizeof(NVPCMINFO);
					return NV_OK;
				}
				else
				{
					//  Ȃ΁AKvȃTCYԂ
					*lpdwSize = sizeof(NVPCMINFO);
					return VPCMERR_BUFFERTOOSMALL;
				}
			}
			
			//  obt@w肳ĂȂ΁ATCY̖₢킹
			//  KvȃTCYԂ
			
			*lpdwSize = sizeof(NVPCMINFO);
			return NV_OK;
		}
		break;
	default:
		{
			return VPCMERR_UNKNOWNFOURCC;
		}
	}
}


NVRESULT Class_NVPCM::GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  ȖȂǂ̃Rg擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	if (dwFourCC == NVPCM_FOURCC)
	{
		dwFourCC = NVAUDIOFILE_FOURCC;
	}

	return Class_NVAudioFile::GetComment(dwFourCC, lpvInfo, lpdwSize);
}


NVRESULT Class_NVPCM::GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf)
{
//  PCMWAVEFORMAT `̏擾

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	lppcmwf->wBitsPerSample = (WORD) nvpcmd.nvpcmInfo.dwBitsPerSample;		//  ݂̎gpł́A16 BitsPerSample ̂ݑΉ
	lppcmwf->wf.wFormatTag = (nvpcmd.nvpcmInfo.dwFlag & NVAUDIOFILE_FLAG_FLOAT) ? WAVE_FORMAT_IEEE_FLOAT : WAVE_FORMAT_PCM;		//  ^O͂obl
	lppcmwf->wf.nChannels = (WORD) nvpcmd.nvpcmInfo.dwMode;
	lppcmwf->wf.nSamplesPerSec = nvpcmd.nvpcmInfo.dwSamplerate;
	lppcmwf->wf.nBlockAlign = (lppcmwf->wBitsPerSample >> 3) * lppcmwf->wf.nChannels;
	lppcmwf->wf.nAvgBytesPerSec = lppcmwf->wf.nSamplesPerSec * lppcmwf->wf.nBlockAlign;

	return NV_OK;
}


NVRESULT Class_NVPCM::DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize)
{
//  
	NVRESULT nvres;

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	nvres = nvpcmd.invst->Read(lpBuffer, lBufferSize, (LPDWORD)lplResultSize);
	if (nvres == VSTMERR_VALUE_ENDOFDATA)
	{
		return VPCMERR_ENDOFDATA;
	}
	else if (nvres)
	{
		return VPCMERR_FILEISBROKEN;
	}

	return NV_OK;
}


NVRESULT Class_NVPCM::Rewind(void)
{
	NVRESULT nvres;

	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	if (nvpcmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VPCMERR_NOCREATE;
	}

	nvres = nvpcmd.invst->SetCurrentPosition(0, NVSTREAM_SEEKBEGIN);
	if (nvres)
	{
		return nvres;
	}

	return NV_OK;
}

NVRESULT Class_NVPCM::FileInfoDialog(HWND hwnd)
{
//  t@C̃_CAO\

	extern HINSTANCE hinstNVWave;

	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	if (nvpcmd.hwndInfo)
	{
		SetFocus(nvpcmd.hwndInfo);
		return NV_OK;
	}

	AddRef();

	nvpcmd.hwndInfo = CreateDialogParam(NVGetResourceDLL(), MAKEINTRESOURCE(IDD_AUDIOFILE_INFO), hwnd, NVPCM_InfoDialogProc, (LPARAM) this);
	if (! nvpcmd.hwndInfo)
	{
		Release();
		return VPCMERR_CANTCREATEINFODIALOG;
	}
	NVRegisterDialog(nvpcmd.hwndInfo);

	return NV_OK;
}


INT_PTR CALLBACK NVPCM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch (uMessage)
	{
	case WM_INITDIALOG:
		{
			SetProp(hwnd, TEXT("invpcm"), (HANDLE) lParam);
			SetFocus(GetDlgItem(hwnd, IDC_AUDIOFILE_FILENAME));

			TCHAR lpszBuf[1024];
			LPNVPCMINFO lpInfo = &((INVPCM) lParam)->nvpcmd.nvpcmInfo;
			QWORD qwPlayTime = lpInfo->quPlayTime.qw / 1000;

			SetDlgItemText(hwnd, IDC_AUDIOFILE_FILENAME, lpInfo->lpszDataName);
			_stprintf_s(lpszBuf, 1024, TEXT("FileType = \n  RIFF WAVE (%s)\nFileSize = %I64u bytes\nPlaySize = %I64u bytes\nPlayTime = %2I64u:%02I64u.%03I64u\n")
				TEXT("Bitrate = %d kbps (%s)\nBitsPerSample = %d bits\nSampleRate = %d Hz\nMode = %s"),
				lpInfo->lpszFormatString, lpInfo->quDataSize.qw, lpInfo->quDecodedSize.qw, qwPlayTime / 60, qwPlayTime % 60, lpInfo->quPlayTime.qw % 1000,
				lpInfo->dwBitrate, (lpInfo->dwFlag & NVAUDIOFILE_FLAG_VBR) ? TEXT("VBR") : TEXT("CBR"), lpInfo->dwBitsPerSample, lpInfo->dwSamplerate, lpInfo->lpszModeString);
			SetDlgItemText(hwnd, IDC_AUDIOFILE_INFO, lpszBuf);
			LPNVAUDIOFILECOMMENT lpnvafcm = (((INVPCM) lParam)->nvafd.lpnvafcm);
			if (lpnvafcm)
			{
				SetDlgItemText(hwnd, IDC_AUDIOFILE_TITLE, &lpnvafcm->szString[lpnvafcm->lOffsetTitle]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_ARTIST, &lpnvafcm->szString[lpnvafcm->lOffsetArtist]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_ALBUM, &lpnvafcm->szString[lpnvafcm->lOffsetAlbum]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_DATE, &lpnvafcm->szString[lpnvafcm->lOffsetDate]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_TRACK, &lpnvafcm->szString[lpnvafcm->lOffsetTrackNumber]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_GENRE, &lpnvafcm->szString[lpnvafcm->lOffsetGenre]);
				SetDlgItemText(hwnd, IDC_AUDIOFILE_COMMENT, &lpnvafcm->szString[lpnvafcm->lOffsetComment]);
			}
			NVClipWindowPos(hwnd);
		}
		return FALSE;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDOK:
			case IDCANCEL:
				{
					DestroyWindow(hwnd);
				}
				return TRUE;
			}
		}
		break;
	case WM_DESTROY:
		{
			INVPCM invpcm;

			invpcm = (INVPCM) GetProp(hwnd, TEXT("invpcm"));
			if (invpcm)
			{
				RemoveProp(hwnd, TEXT("invpcm"));
				NVUnRegisterDialog(invpcm->nvpcmd.hwndInfo);
				invpcm->nvpcmd.hwndInfo = NULL;
				invpcm->Release();
			}
		}
		break;
	}

	return FALSE;
}

NVRESULT Class_NVPCM::GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag)
{
	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	if (nvpcmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VPCMERR_NOCREATE;
	}

	if (dwFlag & NVAUDIOFILE_SEEKCURRENT)
	{
		lpquPosition->qw = 0;
		return NV_OK;
	}
	else if (dwFlag & NVAUDIOFILE_SEEKEND)
	{
		NVRESULT nvres;
		nvres = nvpcmd.invst->GetCurrentPosition(&lpquPosition->ql, NVSTREAM_SEEKEND);
		return nvres;
	}
	else
	{
		NVRESULT nvres;
		nvres = nvpcmd.invst->GetCurrentPosition(&lpquPosition->ql, NVSTREAM_SEEKBEGIN);
		return nvres;
	}

	return NV_OK;
}


NVRESULT Class_NVPCM::SetCurrentPosition(QWUNION quPosition, DWORD dwFlag)
{
	//  ƏĂ邩`FbN
	if (! vcd.bIsCreated)
	{
		return VPCMERR_NOCREATE;
	}

	if (nvpcmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VPCMERR_NOCREATE;
	}

	quPosition.qw -= quPosition.qw % (nvpcmd.nvpcmInfo.dwMode * nvpcmd.nvpcmInfo.dwBitsPerSample / 8);
	if (dwFlag & NVAUDIOFILE_SEEKCURRENT)
	{
		dwFlag = NVSTREAM_SEEKCURRENT;
	}
	else if (dwFlag & NVAUDIOFILE_SEEKEND)
	{
		dwFlag = NVSTREAM_SEEKEND;
	}
	else
	{
		dwFlag = NVSTREAM_SEEKBEGIN;
	}

	return nvpcmd.invst->SetCurrentPosition(quPosition.ql, dwFlag);
}

NVRESULT Class_NVPCM::ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples)
{
//  QƎ(}CNbP)Tv֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquSamples->ql = NVMulDiv64(quReferenceTime.ql, nvpcmd.nvpcmInfo.dwSamplerate, 1000 * 1000);
	return NV_OK;
}

NVRESULT Class_NVPCM::SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime)
{
//  TvQƎ(}CNbP)֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquReferenceTime->ql = NVMulDiv64(quSamples.ql, 1000 * 1000, nvpcmd.nvpcmInfo.dwSamplerate);
	
	return NV_OK;
}

NVRESULT Class_NVPCM::GetReferenceTime(LPQWUNION lpquReferenceTime)
{
	//  ݂̎QƎ(}CNbP)擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	if (nvpcmd.dwFlag & NVAUDIOFILE_GETINFOONLY)
	{
		return VAFERR_NOCREATE;
	}

	NVRESULT nvres;

	nvres = nvpcmd.invst->GetCurrentPosition(&lpquReferenceTime->ql, NVSTREAM_SEEKBEGIN);
	if (nvres)
	{
		return nvres;
	}

	lpquReferenceTime->ql = NVMulDiv64(lpquReferenceTime->ql, 1000 * 1000, nvpcmd.nvpcmInfo.dwSamplerate * nvpcmd.nvpcmInfo.dwMode * (nvpcmd.nvpcmInfo.dwBitsPerSample >> 3));

	return NV_OK;
}

NVRESULT Class_NVPCM::GetTotalTime(LPQWUNION lpquTotalTime)
{
	//  }CNbPʂőSĐԂ擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	lpquTotalTime->ql = NVMulDiv64(nvpcmd.nvpcmInfo.quDecodedSize.ql, 1000 * 1000, nvpcmd.nvpcmInfo.dwSamplerate * nvpcmd.nvpcmInfo.dwMode * (nvpcmd.nvpcmInfo.dwBitsPerSample >> 3));
	return NV_OK;
}


